
#ifndef	_HTC_H_
#warning Header file 8051f12x.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Cygnal microcontrollers
    C8051F120
    C8051F121
    C8051F122
    C8051F123
    C8051F124
    C8051F125
    C8051F126
    C8051F127
 */

#ifndef	__8051F12X_H

#define	__8051F12X_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
/* Note that this microcontroller pages some of its SFRs,
 * these definitions provide convient access to the different
 * SFR pages in this device. */
#define CONFIG_PAGE       0x0F    /* SYSTEM AND PORT CONFIGURATION PAGE */
#define LEGACY_PAGE       0x00    /* LEGACY SFR PAGE */
#define TIMER01_PAGE      0x00    /* TIMER 0 AND TIMER 1 */
#define CPT0_PAGE         0x01    /* COMPARATOR 0 */
#define CPT1_PAGE         0x02    /* COMPARATOR 1 */
#define UART0_PAGE        0x00    /* UART 0 */
#define UART1_PAGE        0x01    /* UART 1 */
#define SPI0_PAGE         0x00    /* SPI 0 */
#define EMI0_PAGE         0x00    /* EXTERNAL MEMORY INTERFACE */
#define ADC0_PAGE         0x00    /* ADC 0 */
#define ADC2_PAGE         0x02    /* ADC 2 */
#define SMB0_PAGE         0x00    /* SMBUS 0 */
#define TMR2_PAGE         0x00    /* TIMER 2 */
#define TMR3_PAGE         0x01    /* TIMER 3 */
#define TMR4_PAGE         0x02    /* TIMER 4 */
#define DAC0_PAGE         0x00    /* DAC 0 */
#define DAC1_PAGE         0x01    /* DAC 1 */
#define PCA0_PAGE         0x00    /* PCA 0 */
#define PLL0_PAGE         0x0F    /* PLL 0 */
#define MAC0_PAGE         0x03    /* MAC 0 */

static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char SFRPAGE	@ 0x84;
static volatile unsigned char SFRNEXT	@ 0x85;
static volatile unsigned char SFRLAST	@ 0x86;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static          unsigned char CKCON	@ 0x8E;
static          unsigned char PSCTL	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char SSTA0	@ 0x91;
static volatile unsigned char SCON0	@ 0x98;
static volatile unsigned char SBUF0	@ 0x99;
static volatile unsigned char SPI0CFG	@ 0x9A;
static volatile unsigned char SPI0DAT	@ 0x9B;
static          unsigned char SPI0CKR	@ 0x9D;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char EMI0TC	@ 0xA1;
static		unsigned char EMI0CN	@ 0xA2;
static		unsigned char EMI0CF	@ 0xA3;
static          unsigned char IE	@ 0xA8;
static          unsigned char SADDR0	@ 0xA9;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char PSBANK	@ 0xB1;
static          unsigned char FLSCL	@ 0xB7;
static          unsigned char IP	@ 0xB8;
static          unsigned char SADEN0	@ 0xB9;
static          unsigned char AMX0CF	@ 0xBA;
static          unsigned char AMX0SL	@ 0xBB;
static volatile unsigned char ADC0CF	@ 0xBC;
static volatile unsigned char ADC0L	@ 0xBE;
static volatile unsigned char ADC0H	@ 0xBF;
static volatile unsigned char SMB0CN	@ 0xC0;
static volatile unsigned char SMB0STA	@ 0xC1;
static volatile unsigned char SMB0DAT	@ 0xC2;
static          unsigned char SMB0ADR	@ 0xC3;
static          unsigned char ADC0GTL	@ 0xC4;
static          unsigned char ADC0GTH	@ 0xC5;
static          unsigned char ADC0LTL	@ 0xC6;
static          unsigned char ADC0LTH	@ 0xC7;
static volatile unsigned char TMR2CN	@ 0xC8;
static volatile unsigned char TMR2CF	@ 0xC9;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TMR2L	@ 0xCC;
static volatile unsigned char TMR2H	@ 0xCD;
static          unsigned char SMB0CR	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char REF0CN	@ 0xD1;
static          unsigned char DAC0L	@ 0xD2;
static          unsigned char DAC0H	@ 0xD3;
static		unsigned char DAC0CN	@ 0xD4;
static volatile unsigned char PCA0CN	@ 0xD8;
static          unsigned char PCA0MD	@ 0xD9;
static          unsigned char PCA0CPM0	@ 0xDA;
static          unsigned char PCA0CPM1	@ 0xDB;
static          unsigned char PCA0CPM2	@ 0xDC;
static          unsigned char PCA0CPM3	@ 0xDD;
static          unsigned char PCA0CPM4	@ 0xDE;
static		unsigned char PCA0CPM5	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char PCA0CPL5	@ 0xE1;
static volatile unsigned char PCA0CPH5	@ 0xE2;
static          unsigned char EIE1	@ 0xE6;
static          unsigned char EIE2	@ 0xE7;
static volatile unsigned char ADC0CN	@ 0xE8;
static volatile unsigned char PCA0CPL2	@ 0xE9;
static volatile unsigned char PCA0CPH2	@ 0xEA;
static volatile unsigned char PCA0CPL3	@ 0xEB;
static volatile unsigned char PCA0CPH3	@ 0xEC;
static volatile unsigned char PCA0CPL4	@ 0xED;
static volatile unsigned char PCA0CPH4	@ 0xEE;
static volatile unsigned char RSTSRC	@ 0xEF;
static volatile unsigned char B		@ 0xF0;
static          unsigned char EIP1	@ 0xF6;
static          unsigned char EIP2	@ 0xF7;
static volatile unsigned char SPI0CN	@ 0xF8;
static volatile unsigned char PCA0L	@ 0xF9;
static volatile unsigned char PCA0H	@ 0xFA;
static volatile unsigned char PCA0CPL0	@ 0xFB;
static volatile unsigned char PCA0CPH0	@ 0xFC;
static volatile unsigned char PCA0CPL1	@ 0xFD;
static volatile unsigned char PCA0CPH1	@ 0xFE;
static volatile unsigned char WDTCN	@ 0xFF;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static volatile SFR_BITS	 SFRPAGE_BITS	@ 0x84;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static          SFR_BITS	 CKCON_BITS	@ 0x8E;
static          SFR_BITS	 PSCTL_BITS	@ 0x8F;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static volatile SFR_BITS	 SSTA0_BITS	@ 0x91;
static volatile SFR_BITS	 SCON0_BITS	@ 0x98;
static volatile SFR_BITS	 SPI0CFG_BITS	@ 0x9A;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static		SFR_BITS	 EMI0TC_BITS	@ 0xA1;
static		SFR_BITS	 EMI0CF_BITS	@ 0xA3;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static		SFR_BITS	 PSBANK_BITS	@ 0xB1;
static          SFR_BITS	 FLSCL_BITS	@ 0xB7;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 ADC0CF_BITS	@ 0xBC;
static volatile SFR_BITS	 SMB0CN_BITS	@ 0xC0;
static          SFR_BITS	 SMB0ADR_BITS	@ 0xC3;
static volatile SFR_BITS	 TMR2CN_BITS	@ 0xC8;
static		SFR_BITS	 TMR2CF_BITS	@ 0xC9;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static		SFR_BITS	 REF0CN_BITS	@ 0xD1;
static		SFR_BITS	 DAC0CN_BITS	@ 0xD4;
static volatile SFR_BITS	 PCA0CN_BITS	@ 0xD8;
static          SFR_BITS	 PCA0MD_BITS	@ 0xD9;
static          SFR_BITS	 PCA0CPM0_BITS	@ 0xDA;
static          SFR_BITS	 PCA0CPM1_BITS	@ 0xDB;
static          SFR_BITS	 PCA0CPM2_BITS	@ 0xDC;
static          SFR_BITS	 PCA0CPM3_BITS	@ 0xDD;
static          SFR_BITS	 PCA0CPM4_BITS	@ 0xDE;
static		SFR_BITS	 PCA0CPM5_BITS	@ 0xDF;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static          SFR_BITS	 EIE1_BITS	@ 0xE6;
static          SFR_BITS	 EIE2_BITS	@ 0xE7;
static volatile SFR_BITS	 ADC0CN_BITS	@ 0xE8;
static volatile SFR_BITS	 RSTSRC_BITS	@ 0xEF;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static          SFR_BITS	 EIP1_BITS	@ 0xF6;
static          SFR_BITS	 EIP2_BITS	@ 0xF7;
static volatile SFR_BITS	 SPI0CN_BITS	@ 0xF8;
static volatile SFR_BITS	 WDTCN_BITS	@ 0xFF;

//Special Function Registers in bank 1
static volatile unsigned char CPT0CN	@ 0x88;
static		unsigned char CPT0MD	@ 0x89;
static volatile unsigned char SCON1	@ 0x98;
static volatile unsigned char SBUF1	@ 0x99;
static volatile unsigned char TMR3CN	@ 0xC8;
static		unsigned char TMR3CF	@ 0xC9;
static volatile unsigned char RCAP3L	@ 0xCA;
static volatile unsigned char RCAP3H	@ 0xCB;
static volatile unsigned char TMR3L	@ 0xCC;
static volatile unsigned char TMR3H	@ 0xCD;
static          unsigned char DAC1L	@ 0xD2;
static          unsigned char DAC1H	@ 0xD3;
static		unsigned char DAC1CN	@ 0xD4;
static volatile SFR_BITS	 CPT0CN_BITS	@ 0x88;
static		SFR_BITS	 CPT0MD_BITS	@ 0x89;
static volatile SFR_BITS	 SCON1_BITS	@ 0x98;
static volatile SFR_BITS	 TMR3CN_BITS	@ 0xC8;
static		SFR_BITS	 TMR3CF_BITS	@ 0xC9;
static volatile SFR_BITS	 RCAP3L_BITS	@ 0xCA;
static volatile SFR_BITS	 RCAP3H_BITS	@ 0xCB;
static		SFR_BITS	 DAC1CN_BITS	@ 0xD4;

//Special Function Registers in bank 2
static volatile unsigned char CPT1CN	@ 0x88;
static volatile unsigned char CPT1MD	@ 0x89;
static		unsigned char AMX2CF	@ 0xBA;
static		unsigned char AMX2SL	@ 0xBB;
static		unsigned char ADC2CF	@ 0xBC;
static volatile unsigned char ADC2	@ 0xBE;
static		unsigned char ADC2GT	@ 0xC4;
static		unsigned char ADC2LT	@ 0xC6;
static volatile unsigned char TMR4CN	@ 0xC8;
static		unsigned char TMR4CF	@ 0xC9;
static volatile unsigned char RCAP4L	@ 0xCA;
static volatile unsigned char RCAP4H	@ 0xCB;
static volatile unsigned char TMR4L	@ 0xCC;
static volatile unsigned char TMR4H	@ 0xCD;
static volatile unsigned char ADC2CN	@ 0xE8;
static volatile SFR_BITS	 CPT1CN_BITS	@ 0x88;
static volatile SFR_BITS	 CPT1MD_BITS	@ 0x89;
static		SFR_BITS	 AMX2CF_BITS	@ 0xBA;
static		SFR_BITS	 AMX2SL_BITS	@ 0xBB;
static		SFR_BITS	 ADC2CF_BITS	@ 0xBC;
static volatile SFR_BITS	 TMR4CN_BITS	@ 0xC8;
static		SFR_BITS	 TMR4CF_BITS	@ 0xC9;
static volatile SFR_BITS	 ADC2CN_BITS	@ 0xE8;

//Special Function Registers in bank F
static volatile unsigned char FLSTAT	@ 0x88;
static volatile unsigned char PLL0CN	@ 0x89;
static volatile unsigned char OSCICN	@ 0x8A;
static		unsigned char OSCICL	@ 0x8B;
static volatile unsigned char OSCXCN	@ 0x8C;
static		unsigned char PLL0DIV	@ 0x8D;
static		unsigned char PLL0MUL	@ 0x8E;
static		unsigned char PLL0FLT	@ 0x8F;
static volatile unsigned char SFRPGCN	@ 0x96;
static		unsigned char CLKSEL	@ 0x97;
static volatile unsigned char CCH0MA	@ 0x9A;
static          unsigned char P4MDOUT	@ 0x9C;
static		unsigned char P5MDOUT	@ 0x9D;
static		unsigned char P6MDOUT	@ 0x9E;
static		unsigned char P7MDOUT	@ 0x9F;
static volatile unsigned char CCH0CN	@ 0xA1;
static volatile unsigned char CCH0TN	@ 0xA2;
static volatile unsigned char CCH0LC	@ 0xA3;
static          unsigned char P0MDOUT	@ 0xA4;
static          unsigned char P1MDOUT	@ 0xA5;
static          unsigned char P2MDOUT	@ 0xA6;
static          unsigned char P3MDOUT	@ 0xA7;
static          unsigned char P1MDIN	@ 0xAD;
static volatile unsigned char FLACL	@ 0xB7;
static volatile unsigned char P4	@ 0xC8;
static volatile unsigned char P5	@ 0xD8;
static          unsigned char XBR0	@ 0xE1;
static          unsigned char XBR1	@ 0xE2;
static          unsigned char XBR2	@ 0xE3;
static volatile unsigned char P6	@ 0xE8;
static volatile unsigned char P7	@ 0xF8;
static volatile SFR_BITS	 FLSTAT_BITS	@ 0x88;
static volatile SFR_BITS	 PLL0CN_BITS	@ 0x89;
static volatile SFR_BITS	 OSCICN_BITS	@ 0x8A;
static		SFR_BITS	 OSCICL_BITS	@ 0x8B;
static volatile SFR_BITS	 OSCXCN_BITS	@ 0x8C;
static		SFR_BITS	 PLL0FLT_BITS	@ 0x8F;
static volatile SFR_BITS	 SFRPGCN_BITS	@ 0x96;
static		SFR_BITS	 CLKSEL_BITS	@ 0x97;
static volatile SFR_BITS	 CCH0MA_BITS	@ 0x9A;
static          SFR_BITS	 P4MDOUT_BITS	@ 0x9C;
static		SFR_BITS	 P5MDOUT_BITS	@ 0x9D;
static		SFR_BITS	 P6MDOUT_BITS	@ 0x9E;
static		SFR_BITS	 P7MDOUT_BITS	@ 0x9F;
static volatile SFR_BITS	 CCH0CN_BITS	@ 0xA1;
static volatile SFR_BITS	 CCH0TN_BITS	@ 0xA2;
static volatile SFR_BITS	 CCH0LC_BITS	@ 0xA3;
static          SFR_BITS	 P0MDOUT_BITS	@ 0xA4;
static          SFR_BITS	 P1MDOUT_BITS	@ 0xA5;
static          SFR_BITS	 P2MDOUT_BITS	@ 0xA6;
static          SFR_BITS	 P3MDOUT_BITS	@ 0xA7;
static          SFR_BITS	 P1MDIN_BITS	@ 0xAD;
static volatile SFR_BITS	 P4_BITS	@ 0xC8;
static volatile SFR_BITS	 P5_BITS	@ 0xD8;
static          SFR_BITS	 XBR0_BITS	@ 0xE1;
static          SFR_BITS	 XBR1_BITS	@ 0xE2;
static          SFR_BITS	 XBR2_BITS	@ 0xE3;
static volatile SFR_BITS	 P6_BITS	@ 0xE8;
static volatile SFR_BITS	 P7_BITS	@ 0xF8;


// Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Comparator 0 control register CPT0CN (bank 1 register)
static 		bit	CP0HYN0	@ 0x88;
static 		bit	CP0HYN1	@ 0x89;
static 		bit	CP0HYP0	@ 0x8A;
static 		bit	CP0HYP1	@ 0x8B;
static volatile bit	CP0FIF	@ 0x8C;
static volatile bit	CP0RIF	@ 0x8D;
static volatile bit	CP0OUT	@ 0x8E;
static 		bit	CP0EN	@ 0x8F;

// Comparator 1 control register CPT1CN (bank 2 register)
static 		bit	CP1HYN0	@ 0x88;
static 		bit	CP1HYN1	@ 0x89;
static 		bit	CP1HYP0	@ 0x8A;
static 		bit	CP1HYP1	@ 0x8B;
static volatile bit	CP1FIF	@ 0x8C;
static volatile bit	CP1RIF	@ 0x8D;
static volatile bit	CP1OUT	@ 0x8E;
static 		bit	CP1EN	@ 0x8F;

// Flash status FLSTAT (bank F register)
static volatile bit	FLBUSY	@ 0x88;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Serial Control Register 0 SCON0
static volatile bit	RI0	@ 0x98;
static volatile bit	TI0	@ 0x99;
static volatile bit	RB80	@ 0x9A;
static 		bit	TB80	@ 0x9B;
static 		bit	REN0	@ 0x9C;
static 		bit	SM20	@ 0x9D;
static 		bit	SM10	@ 0x9E;
static 		bit	SM00	@ 0x9F;

//Serial Control 1 SCON1 (bank 1 register)
static volatile	bit	RI1	@ 0x98;
static volatile	bit	TI1	@ 0x99;
static volatile	bit	RB81	@ 0x9A;
static 		bit	TB81	@ 0x9B;
static 		bit	REN1	@ 0x9C;
static 		bit	MCE1	@ 0x9D;
static		bit	S1M0DE	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES0	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	IEGF0	@ 0xAE;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS0	@ 0xBC;
static 		bit	PT2	@ 0xBD;

// SM Bus Control Register SMB0CN
static		bit	TOE	@ 0xC0;
static		bit	FTE	@ 0xC1;
static volatile bit	AA	@ 0xC2;
static volatile bit	SI	@ 0xC3;
static volatile bit	STO	@ 0xC4;
static volatile bit	STA	@ 0xC5;
static		bit	ENSMB	@ 0xC6;
static volatile bit	BUSY	@ 0xC7;

// Timer 2 Control register TMR2CN
static		bit	CPRL2	@ 0xC8;
static		bit	CT2	@ 0xC9;
static		bit	TR2	@ 0xCA;
static		bit	EXEN2	@ 0xCB;
static volatile bit	EXF2	@ 0xCE;
static volatile bit	TF2	@ 0xCF;

// Timer 3 Control register TMR3CN (Bank 1 register)
static		bit	CPRL3	@ 0xC8;
static		bit	CT3	@ 0xC9;
static		bit	TR3	@ 0xCA;
static		bit	EXEN3	@ 0xCB;
static volatile bit	EXF3	@ 0xCE;
static volatile bit	TF3	@ 0xCF;

// Timer 4 Control register TMR4CN (Bank 2 register)
static		bit	CPRL4	@ 0xC8;
static		bit	CT4	@ 0xC9;
static		bit	TR4	@ 0xCA;
static		bit	EXEN4	@ 0xCB;
static volatile bit	EXF4	@ 0xCE;
static volatile bit	TF4	@ 0xCF;

//Port 4 (Bank F register)
static volatile bit	P40	@ 0xC8;
static volatile bit	P41	@ 0xC9;
static volatile bit	P42	@ 0xCA;
static volatile bit	P43	@ 0xCB;
static volatile bit	P44	@ 0xCC;
static volatile bit	P45	@ 0xCD;
static volatile bit	P46	@ 0xCE;
static volatile bit	P47	@ 0xCF;

//Program Status Word PSW
static volatile bit	PARITY	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//  PCA Control Register PCA0CN
static volatile bit	CCF0	@ 0xD8;
static volatile bit	CCF1	@ 0xD9;
static volatile bit	CCF2	@ 0xDA;
static volatile bit	CCF3	@ 0xDB;
static volatile bit	CCF4	@ 0xDC;
static volatile bit	CCF5	@ 0xDD;
static		bit	CR	@ 0xDE;
static volatile bit	CF	@ 0xDF;

//Port 5 P5 (Bank F register)
static volatile bit	P50	@ 0xD8;
static volatile bit	P51	@ 0xD9;
static volatile bit	P52	@ 0xDA;
static volatile bit	P53	@ 0xDB;
static volatile bit	P54	@ 0xDC;
static volatile bit	P55	@ 0xDD;
static volatile bit	P56	@ 0xDE;
static volatile bit	P57	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// ADC Control Register ADC0CN
static		bit	AD0LJST	@ 0xE8;
static volatile bit	AD0WINT	@ 0xE9;
static		bit	AD0CM0	@ 0xEA;
static		bit	AD0CM1	@ 0xEB;
static volatile bit	AD0BUSY	@ 0xEC;
static volatile bit	AD0INT	@ 0xED;
static		bit	AD0TM	@ 0xEE;
static		bit	AD0EN	@ 0xEF;

// ADC Control Register ADC2CN (Bank 2 register)
static volatile bit	AD2WINT	@ 0xE8;
static		bit	AD2CM0	@ 0xE9;
static		bit	AD2CM1	@ 0xEA;
static		bit	AD2CM2	@ 0xEB;
static volatile bit	AD2BUSY	@ 0xEC;
static volatile bit	AD2INT	@ 0xED;
static		bit	AD2TM	@ 0xEE;
static		bit	AD2EN	@ 0xEF;

//Port 6 P6 (Bank F register)
static volatile bit	P60	@ 0xE8;
static volatile bit	P61	@ 0xE9;
static volatile bit	P62	@ 0xEA;
static volatile bit	P63	@ 0xEB;
static volatile bit	P64	@ 0xEC;
static volatile bit	P65	@ 0xED;
static volatile bit	P66	@ 0xEE;
static volatile bit	P67	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// SPI Control Register SPI0CN
static		bit	SPIEN	@ 0xF8;
static volatile bit	TXBMT	@ 0xF9;
static		bit	NSSMD0	@ 0xFA;
static		bit	NSSMD1	@ 0xFB;
static volatile bit	RXOVRN	@ 0xFC;
static volatile bit	MODF	@ 0xFD;
static volatile bit	WCOL	@ 0xFE;
static volatile bit	SPIF	@ 0xFF;

//Port 7 P7 (Bank F register)
static volatile bit	P70	@ 0xF8;
static volatile bit	P71	@ 0xF9;
static volatile bit	P72	@ 0xFA;
static volatile bit	P73	@ 0xFB;
static volatile bit	P74	@ 0xFC;
static volatile bit	P75	@ 0xFD;
static volatile bit	P76	@ 0xFE;
static volatile bit	P77	@ 0xFF;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	SPI	0x33
#define	SMB	0x3B
#define	ADC0W	0x43
#define	PCA	0x4B
#define	CMP0F	0x53
#define	CMP0R	0x5B
#define	CMP1F	0x63
#define	CMP1R	0x6B
#define	TIMER3	0x73
#define	ADC0E	0x7B
#define	TIMER4	0x83
#define	ADC2W	0x8B
#define	ADC2E	0x93
#define	S1	0xA3

#endif
