
#ifndef	_HTC_H_
#warning Header file 8051f2xx.h included directly. Use #include <htc.h> instead.
#endif

/*
   Header file for the Cygnal microcontrollers
   C8051F206
   C8051F220
   C8051F221
   C8051F226
   C8051F230
   C8051F231
   C8051F236
 */

#ifndef	__8051F2XX_H

#define	__8051F2XX_H
	

typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//special function registers
static volatile	unsigned char	P0		@ 0x80;
static volatile	unsigned char	SP		@ 0x81;
static volatile	unsigned char	DPL		@ 0x82;
static volatile	unsigned char	DPH		@ 0x83;
// 16 bit definition
static volatile	unsigned char	PCON		@ 0x87;
static volatile	unsigned char	TCON		@ 0x88;
static 		unsigned char	TMOD		@ 0x89;
static volatile	unsigned char	TL0		@ 0x8A;
static volatile	unsigned char	TL1		@ 0x8B;
static volatile	unsigned char	TH0		@ 0x8C;
static volatile	unsigned char	TH1		@ 0x8D;
static 		unsigned char	CKCON		@ 0x8E;
static 		unsigned char	PSCTL		@ 0x8F;
static volatile	unsigned char	P1		@ 0x90;
static volatile	unsigned char	SCON		@ 0x98;
static volatile	unsigned char	SBUF		@ 0x99;
static volatile	unsigned char	SPI0CFG		@ 0x9A;
static volatile	unsigned char	SPI0DAT		@ 0x9B;
static 		unsigned char	SPI0CKR		@ 0x9D;
static volatile	unsigned char	CPT0CN		@ 0x9E;
static volatile	unsigned char	CPT1CN		@ 0x9F;
static volatile	unsigned char	P2		@ 0xA0;
static 		unsigned char	PRT0CF		@ 0xA4;
static 		unsigned char	PRT1CF		@ 0xA5;
static 		unsigned char	PRT2CF		@ 0xA6;
static 		unsigned char	PRT3CF		@ 0xA7;
static volatile	unsigned char	IE		@ 0xA8;
static volatile	unsigned char	PRT1IF		@ 0xAD;

#if defined(_C8051F206) || defined(_C8051F226) || defined(_C8051F236)
static 		unsigned char	EMI0CN	@ 0xAF;
#endif
static volatile	unsigned char	P3		@ 0xB0;
static volatile	unsigned char	OSCXCN		@ 0xB1;
static volatile	unsigned char	OSCICN		@ 0xB2;
static 		unsigned char	FLSCL		@ 0xB6;
static volatile	unsigned char	FLACL		@ 0xB7;
static 		unsigned char	IP		@ 0xB8;

#if !defined(_C8051F230) && !defined(_C8051F231) && !defined(_C8051F236)
static 		unsigned char	AMX0SL		@ 0xBB;
static 		unsigned char	ADC0CF		@ 0xBC;
static volatile	unsigned char	ADC0H		@ 0xBF;
static volatile	unsigned char	ADC0GTH		@ 0xC5;
static volatile	unsigned char	ADC0LTH		@ 0xC7;
static volatile	unsigned char	ADC0CN		@ 0xE8;
#endif

//12-bit ADC)
#if defined(_C8051F206)
static volatile	unsigned char	ADC0L		@ 0xBE;
static volatile	unsigned char	ADC0GTL		@ 0xC4;
static volatile	unsigned char	ADC0LTL		@ 0xC6;
#endif
static volatile	unsigned char	T2CON		@ 0xC8;
static volatile	unsigned char	RCAP2L		@ 0xCA;
static volatile	unsigned char	RCAP2H		@ 0xCB;
static volatile	unsigned char	TL2		@ 0xCC;
static volatile	unsigned char	TH2		@ 0xCD;
static volatile	unsigned char	PSW		@ 0xD0;
static 		unsigned char	REF0CN		@ 0xD1;
static volatile	unsigned char	ACC		@ 0xE0;
static 		unsigned char	PRT0MX		@ 0xE1;
static 		unsigned char	PRT1MX		@ 0xE2;
static 		unsigned char	PRT2MX		@ 0xE3;
static 		unsigned char	EIE1		@ 0xE6;
static 		unsigned char	EIE2		@ 0xE7;
static volatile	unsigned char	RSTSRC		@ 0xEF;
static volatile	unsigned char	B		@ 0xF0;
static 		unsigned char	P0MODE		@ 0xF1;
static 		unsigned char	P1MODE		@ 0xF2;
static 		unsigned char	P2MODE		@ 0xF3;
//32 pin package
#if !defined(_C8051F221) && !defined(_C8051F231)
static 		unsigned char	P3MODE		@ 0xF4;
#endif
static 		unsigned char	EIP1		@ 0xF6;
static 		unsigned char	EIP2		@ 0xF7;
static volatile	unsigned char	SPI0CN		@ 0xF8;
static volatile	unsigned char	WDTCN		@ 0xFF;


static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile	SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static 		SFR_BITS TMOD_BITS		@ 0x89;
static 		SFR_BITS CKCON_BITS		@ 0x8E;
static 		SFR_BITS PSCTL_BITS		@ 0x8F;
static volatile SFR_BITS P1_BITS		@ 0x90;
static volatile SFR_BITS SCON_BITS		@ 0x98;
static volatile	SFR_BITS SPI0CFG_BITS		@ 0x9A;
static volatile	SFR_BITS CPT0CN_BITS		@ 0x9E;
static volatile	SFR_BITS CPT1CN_BITS		@ 0x9F;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static 		SFR_BITS PRT0CF_BITS		@ 0xA4;
static 		SFR_BITS PRT1CF_BITS		@ 0xA5;
static 		SFR_BITS PRT2CF_BITS		@ 0xA6;
static 		SFR_BITS PRT3CF_BITS		@ 0xA7;
static volatile	SFR_BITS IE_BITS		@ 0xA8;
static volatile	SFR_BITS PRT1IF_BITS		@ 0xAD;
#if defined(_C8051F206) || defined(_C8051F226) || defined(_C8051F236)
	static	SFR_BITS EMI0CN_BITS		@ 0xAF;
#endif
static volatile SFR_BITS P3_BITS		@ 0xB0;
static volatile	SFR_BITS OSCXCN_BITS		@ 0xB2;
static volatile	SFR_BITS OSCICN_BITS		@ 0xB3;
static 		SFR_BITS IP_BITS		@ 0xB8;
#if !defined(_C8051F230) && !defined(_C8051F231) && !defined(_C8051F236)
static 		SFR_BITS AMX0SL_BITS		@ 0xBB;
static 		SFR_BITS ADC0CF_BITS		@ 0xBC;
static volatile	SFR_BITS ADC0CN_BITS		@ 0xE8;
#endif
static volatile SFR_BITS T2CON_BITS		@ 0xC8;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static 		SFR_BITS REF0CN_BITS		@ 0xD1;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static 		SFR_BITS PRT0MX_BITS		@ 0xE1;
static 		SFR_BITS PRT1MX_BITS		@ 0xE2;
static 		SFR_BITS PRT2MX_BITS		@ 0xE3;
static 		SFR_BITS EIE1_BITS		@ 0xE6;
static 		SFR_BITS EIE2_BITS		@ 0xE7;
static volatile	SFR_BITS RSTSRC_BITS		@ 0xEF;
static volatile SFR_BITS B_BITS			@ 0xF0;
static 		SFR_BITS P0MODE_BITS		@ 0xF1;
static 		SFR_BITS P1MODE_BITS		@ 0xF2;
static 		SFR_BITS P2MODE_BITS		@ 0xF3;
#if !defined(_C8051F221) && !defined(_C8051F231)
static	SFR_BITS P3MODE_BITS			@ 0xF4;
#endif
static 		SFR_BITS EIP1_BITS		@ 0xF6;
static 		SFR_BITS EIP2_BITS		@ 0xF7;
static volatile	SFR_BITS SPI0CN_BITS		@ 0xF8;
static volatile	SFR_BITS WDTCN_BITS		@ 0xFF;

//bit addressable locations
//Port 0
static volatile bit P00		@ 0x80;
static volatile bit P01		@ 0x81;
static volatile bit P02		@ 0x82;
static volatile bit P03		@ 0x83;
static volatile bit P04		@ 0x84;
static volatile bit P05		@ 0x85;
static volatile bit P06		@ 0x86;
static volatile bit P07		@ 0x87;

//Timer control TCON
static 		bit IT0		@ 0x88;
static volatile bit IE0		@ 0x89;
static 		bit IT1		@ 0x8A;
static volatile bit IE1 	@ 0x8B;
static		bit TR0 	@ 0x8C;
static volatile bit TF0 	@ 0x8D;
static		bit TR1 	@ 0x8E;
static volatile bit TF1 	@ 0x8F;

//Port 1
static volatile bit P10		@ 0x90;
static volatile bit P11		@ 0x91;
static volatile bit P12		@ 0x92;
static volatile bit P13		@ 0x93;
static volatile bit P14		@ 0x94;
static volatile bit P15		@ 0x95;
static volatile bit P16		@ 0x96;
static volatile bit P17		@ 0x97;

//Serial Control SCON
static volatile bit RI 		@ 0x98;
static volatile bit TI 		@ 0x99;
static volatile bit RB8 	@ 0x9A;
static 		bit TB8 	@ 0x9B;
static 		bit REN 	@ 0x9C;
static 		bit SM2 	@ 0x9D;
static 		bit SM1 	@ 0x9E;
static volatile	bit SM0 	@ 0x9F;

//Port 2
static volatile	bit P20 	@ 0xA0;
static volatile	bit P21 	@ 0xA1;
static volatile	bit P22 	@ 0xA2;
static volatile	bit P23 	@ 0xA3;
static volatile	bit P24 	@ 0xA4;
static volatile	bit P25 	@ 0xA5;
static volatile	bit P26 	@ 0xA6;
static volatile	bit P27 	@ 0xA7;

//Interrupt Enable IE
static		bit EX0		@ 0xA8;
static 		bit ET0		@ 0xA9;
static 		bit EX1		@ 0xAA;
static 		bit ET1		@ 0xAB;
static 		bit ES 		@ 0xAC;
static 		bit ET		@ 0xAD;
static 		bit EA		@ 0xAF;

//Port 3
static volatile bit P30		@ 0xB0;
static volatile bit P31		@ 0xB1;
static volatile bit P32		@ 0xB2;
static volatile bit P33		@ 0xB3;
static volatile bit P34		@ 0xB4;
static volatile bit P35		@ 0xB5;
static volatile bit P36		@ 0xB6;
static volatile bit P37		@ 0xB7;

//Interrupt Priority IP
static 		bit PX0	 	@ 0xB8;
static 		bit PT0		@ 0xB9;
static 		bit PX1		@ 0xBA;
static 		bit PT1		@ 0xBB;
static 		bit PS 		@ 0xBC;
static 		bit PT2		@ 0xBD;

//Timer 2 Control T2CON
static 		bit CPRL2	@ 0xC8;
static 		bit CT2		@ 0xC9;
static 		bit TR2		@ 0xCA;
static 		bit EXEN2	@ 0xCB;
static volatile bit TCLK	@ 0xCC;
static volatile bit RCLK	@ 0xCD;
static volatile bit EXF2	@ 0xCE;
static volatile bit TF2		@ 0xCF;

//Program Status Word PSW
static volatile bit PARITY	@ 0xD0;
static volatile bit F1		@ 0xD1;
static volatile bit OV 		@ 0xD2;
static 		bit RS0 	@ 0xD3;
static 		bit RS1 	@ 0xD4;
static volatile bit F0 		@ 0xD5;
static volatile bit AC 		@ 0xD6;
static volatile bit CY 		@ 0xD7;

//Accumulator
static volatile bit ACC0	@ 0xE0;
static volatile bit ACC1	@ 0xE1;
static volatile bit ACC2	@ 0xE2;
static volatile bit ACC3	@ 0xE3;
static volatile bit ACC4	@ 0xE4;
static volatile bit ACC5	@ 0xE5;
static volatile bit ACC6	@ 0xE6;
static volatile bit ACC7	@ 0xE7;

#if !defined(_C8051F230) && !defined(_C8051F231) && !defined(_C8051F236)
//ADC Control
static volatile bit ADLJST	@ 0xE8;
static volatile bit ADWINT	@ 0xE9;
static		bit ADSTM0	@ 0xEA;
static		bit ADSTM1	@ 0xEB;
static volatile bit ADBUSY	@ 0xEC;
static volatile bit ADCINT	@ 0xED;
static		bit ADCTM	@ 0xEE;
static		bit ADCEN	@ 0xEF;
#endif

//B Register
static volatile bit B0		@ 0xF0;
static volatile bit B1		@ 0xF1;
static volatile bit B2		@ 0xF2;
static volatile bit B3		@ 0xF3;
static volatile bit B4		@ 0xF4;
static volatile bit B5		@ 0xF5;
static volatile bit B6		@ 0xF6;
static volatile bit B7		@ 0xF7;

//SPI Bus Control
static 		bit SPIEN	@ 0xF8;
static 		bit MSTEN	@ 0xF9;
static volatile bit SLVSEL	@ 0xFA;
static volatile bit TXBSY	@ 0xFB;
static volatile bit RXOVRN	@ 0xFC;
static volatile bit MODF	@ 0xFD;
static volatile bit WCOL	@ 0xFE;
static volatile bit SPIF	@ 0xFF;

/*	Interrupt vectors */
#define	RESET	0
#define EXTINT0	0x03
#define TIMER0 	0x0B
#define EXTINT1	0x13
#define TIMER1 	0x1B
#define	SERIAL	0x23
#define TIMER2 	0x2B
#define SPI 	0x33
#define ADC0WC 	0x43
#define C0FE	0x53
#define C0RE 	0x5B
#define C1FE 	0x63
#define C1RE 	0x6B
#define ADC0EC	0x7B
#define EXTINT4	0x83
#define EXTINT5	0x8B
#define EXTINT6	0x93
#define EXTINT7	0x9B
#define INTU 	0xA3
#define CRYSTAL	0xAB

#endif	
