
#ifndef	_HTC_H_
#warning Header file 8951cc02.h included directly. Use #include <htc.h> instead.
#endif

/*
   Header file for the Atmel microcontroller
   T89C51CC02
 */

#ifndef __8951CC02_H

#define __8951CC02_H
	

typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//special function registers
static volatile	unsigned char	SP		@ 0x81;
static volatile	unsigned char	DPL		@ 0x82;
static volatile	unsigned char	DPH		@ 0x83;
// 16 bit definition
static volatile	unsigned char	PCON		@ 0x87;
static volatile	unsigned char	TCON		@ 0x88;
static 		unsigned char	TMOD		@ 0x89;
static volatile	unsigned char	TL0		@ 0x8A;
static volatile	unsigned char	TL1		@ 0x8B;
static volatile	unsigned char	TH0		@ 0x8C;
static volatile	unsigned char	TH1		@ 0x8D;
static		unsigned char	CKCON		@ 0x8F;
static volatile	unsigned char	P1		@ 0x90;
static volatile	unsigned char	SCON		@ 0x98;
static volatile	unsigned char	SBUF		@ 0x99;
static volatile	unsigned char	CANGIT		@ 0x9B;
static volatile	unsigned char	CANTEC		@ 0x9C;
static volatile	unsigned char	CANREC		@ 0x9D;
static volatile	unsigned char	P2		@ 0xA0;
static		unsigned char	CANTCON		@ 0xA1;
static		unsigned char	AUXR1		@ 0xA2;
static volatile	unsigned char	CANMSG		@ 0xA3;
static volatile	unsigned char	CANTTCL		@ 0xA4;
static volatile	unsigned char	CANTTCH		@ 0xA5;
static 		unsigned char	WDTRST		@ 0xA6;
static volatile	unsigned char	WDTPRG		@ 0xA7;
static 		unsigned char	IEN0		@ 0xA8;
static 		unsigned char	SADDR		@ 0xA9;
static volatile	unsigned char	CANGSTA		@ 0xAA;
static volatile	unsigned char	CANGCON		@ 0xAB;
static volatile	unsigned char	CANTIML		@ 0xAC;
static volatile	unsigned char	CANTIMH		@ 0xAD;
static volatile	unsigned char	CANSTMPL	@ 0xAE;
static volatile	unsigned char	CANSTMPH	@ 0xAF;
static volatile	unsigned char	P3		@ 0xB0;
static volatile	unsigned char	CANPAGE		@ 0xB1;
static volatile	unsigned char	CANSTCH		@ 0xB2;
static volatile	unsigned char	CANCONCH	@ 0xB3;
static		unsigned char	CANBT1		@ 0xB4;
static		unsigned char	CANBT2		@ 0xB5;
static		unsigned char	CANBT3		@ 0xB6;
static 		unsigned char	IPH0		@ 0xB7;
static 		unsigned char	IPL0 		@ 0xB8;
static 		unsigned char	SADEN		@ 0xB9;
static volatile	unsigned char	CANSIT2		@ 0xBB;
static volatile	unsigned char	CANIDT1		@ 0xBC;
static volatile	unsigned char	CANIDT2		@ 0xBD;
static volatile	unsigned char	CANIDT3		@ 0xBE;
static volatile	unsigned char	CANIDT4		@ 0xBF;
static volatile	unsigned char	P4		@ 0xC0;
static		unsigned char	CANGIE		@ 0xC1;
static		unsigned char	CANIE2		@ 0xC3;
static		unsigned char	CANIDM1		@ 0xC4;
static		unsigned char	CANIDM2		@ 0xC5;
static		unsigned char	CANIDM3		@ 0xC6;
static		unsigned char	CANIDM4		@ 0xC7;
static volatile	unsigned char	T2CON		@ 0xC8;
static		unsigned char	T2MOD		@ 0xC9;
static volatile	unsigned char	RCAP2L		@ 0xCA;
static volatile	unsigned char	RCAP2H		@ 0xCB;
static volatile	unsigned char	TL2		@ 0xCC;
static volatile	unsigned char	TH2		@ 0xCD;
static		unsigned char	CANEN2		@ 0xCF;
static volatile	unsigned char	PSW		@ 0xD0;
static volatile	unsigned char	FCON		@ 0xD1;
static volatile	unsigned char	EECON		@ 0xD2;
static volatile	unsigned char	CCON		@ 0xD8;
static		unsigned char	CMOD		@ 0xD9;
static		unsigned char	CCAPM0		@ 0xDA;
static		unsigned char	CCAPM1		@ 0xDB;
static volatile	unsigned char	ACC		@ 0xE0;
static		unsigned char	IEN1		@ 0xE8;
static volatile	unsigned char	CL		@ 0xE9;
static volatile	unsigned char	CCAP0L		@ 0xEA;
static volatile	unsigned char	CCAP1L		@ 0xEB;
static volatile	unsigned char	B		@ 0xF0;
static		unsigned char	ADCLK		@ 0xF2;
static volatile	unsigned char	ADCON		@ 0xF3;
static volatile	unsigned char	ADDL		@ 0xF4;
static volatile	unsigned char	ADDH		@ 0xF5;
static		unsigned char	ADCF		@ 0xF6;
static		unsigned char	IPH1		@ 0xF7;
static		unsigned char	IPL1		@ 0xF8;
static volatile	unsigned char	CH		@ 0xF9;
static volatile	unsigned char	CCAP0H		@ 0xFA;
static volatile	unsigned char	CCAP1H		@ 0xFB;

static volatile	SFR_BITS 	PCON_BITS	@ 0x87;
static volatile	SFR_BITS 	TCON_BITS	@ 0x88;
static 		SFR_BITS 	TMOD_BITS	@ 0x89;
static		SFR_BITS 	CKCON_BITS	@ 0x8F;
static volatile	SFR_BITS 	P1_BITS		@ 0x90;
static volatile	SFR_BITS 	SCON_BITS	@ 0x98;
static volatile	SFR_BITS 	CANGIT_BITS	@ 0x9B;
static volatile	SFR_BITS 	P2_BITS		@ 0xA0;
static		SFR_BITS 	AUXR1_BITS	@ 0xA2;
static volatile	SFR_BITS 	WDTPRG_BITS	@ 0xA7;
static 		SFR_BITS 	IEN0_BITS	@ 0xA8;
static volatile	SFR_BITS 	CANGSTA_BITS	@ 0xAA;
static volatile	SFR_BITS 	CANGCON_BITS	@ 0xAB;
static volatile	SFR_BITS 	P3_BITS		@ 0xB0;
static volatile	SFR_BITS 	CANPAGE_BITS	@ 0xB1;
static volatile	SFR_BITS 	CANSTCH_BITS	@ 0xB2;
static volatile	SFR_BITS 	CANCONCH_BITS	@ 0xB3;
static 		SFR_BITS 	IPH0_BITS	@ 0xB7;
static 		SFR_BITS 	IPL0_BITS 	@ 0xB8;
static 		SFR_BITS 	SADEN_BITS	@ 0xB9;
static volatile	SFR_BITS 	CANSIT2_BITS	@ 0xBB;
static volatile	SFR_BITS 	P4_BITS		@ 0xC0;
static		SFR_BITS 	CANGIE_BITS	@ 0xC1;
static		SFR_BITS 	CANIE2_BITS	@ 0xC3;
static		SFR_BITS 	CANIDM1_BITS	@ 0xC4;
static		SFR_BITS 	CANIDM2_BITS	@ 0xC5;
static		SFR_BITS 	CANIDM3_BITS	@ 0xC6;
static		SFR_BITS 	CANIDM4_BITS	@ 0xC7;
static volatile	SFR_BITS 	T2CON_BITS	@ 0xC8;
static		SFR_BITS 	T2MOD_BITS	@ 0xC9;
static		SFR_BITS	CANEN2_BITS	@ 0xCF;
static volatile	SFR_BITS	PSW_BITS	@ 0xD0;
static volatile	SFR_BITS	FCON_BITS	@ 0xD1;
static volatile	SFR_BITS	EECON_BITS	@ 0xD2;
static volatile	SFR_BITS	CCON_BITS	@ 0xD8;
static		SFR_BITS	CMOD_BITS	@ 0xD9;
static		SFR_BITS	CCAPM0_BITS	@ 0xDA;
static		SFR_BITS	CCAPM1_BITS	@ 0xDB;
static volatile	SFR_BITS	ACC_BITS	@ 0xE0;
static		SFR_BITS	IEN1_BITS	@ 0xE8;
static volatile	SFR_BITS	B_BITS		@ 0xF0;
static		SFR_BITS	ADCLK_BITS	@ 0xF2;
static volatile	SFR_BITS	ADCON_BITS	@ 0xF3;
static		SFR_BITS	ADCF_BITS	@ 0xF6;
static		SFR_BITS	IPH1_BITS	@ 0xF7;
static		SFR_BITS	IPL1_BITS	@ 0xF8;

//bit addressable locations
//Timer control TCON
static 		bit IT0		@ 0x88;
static volatile bit IE0		@ 0x89;
static 		bit IT1		@ 0x8A;
static volatile bit IE1		@ 0x8B;
static		bit TR0		@ 0x8C;
static volatile bit TF0		@ 0x8D;
static		bit TR1		@ 0x8E;
static volatile bit TF1		@ 0x8F;

//Port 1
static volatile bit P10		@ 0x90;
static volatile bit P11		@ 0x91;
static volatile bit P12		@ 0x92;
static volatile bit P13		@ 0x93;
static volatile bit P14		@ 0x94;
static volatile bit P15		@ 0x95;
static volatile bit P16		@ 0x96;
static volatile bit P17		@ 0x97;
// Alternate Functions
static volatile bit T2		@ 0x90;
static volatile bit T2EX	@ 0x91;
static volatile bit ECI		@ 0x92;
static volatile bit CEX0	@ 0x93;
static volatile bit CEX1	@ 0x94;
static volatile bit CEX2	@ 0x95;
static volatile bit CEX3	@ 0x96;
static volatile bit CEX4	@ 0x97;

//Serial Control SCON
static volatile bit RI		@ 0x98;
static volatile bit TI		@ 0x99;
static volatile bit RB8 	@ 0x9A;
static		bit TB8 	@ 0x9B;
static		bit REN 	@ 0x9C;
static		bit SM2 	@ 0x9D;
static		bit SM1 	@ 0x9E;
static volatile	bit SM0 	@ 0x9F;
// Alternate Function
static volatile	bit FE	 	@ 0x9F;

//Port 2
static volatile bit P20		@ 0xA0;
static volatile bit P21		@ 0xA1;
static volatile bit P22		@ 0xA2;
static volatile bit P23		@ 0xA3;
static volatile bit P24		@ 0xA4;
static volatile bit P25		@ 0xA5;
static volatile bit P26		@ 0xA6;
static volatile bit P27		@ 0xA7;

//Interrupt Enable 0 IEN0
static 		bit EX0		@ 0xA8;
static 		bit ET0		@ 0xA9;
static 		bit EX1		@ 0xAA;
static 		bit ET1		@ 0xAB;
static 		bit ES		@ 0xAC;
static 		bit ET2		@ 0xAD;
static 		bit EC		@ 0xAE;
static 		bit EA		@ 0xAF;

//Port 3
static volatile bit P30		@ 0xB0;
static volatile bit P31		@ 0xB1;
static volatile bit P32		@ 0xB2;
static volatile bit P33		@ 0xB3;
static volatile bit P34		@ 0xB4;
static volatile bit P35		@ 0xB5;
static volatile bit P36		@ 0xB6;
static volatile bit P37		@ 0xB7;
// Alternate Functions
static volatile bit RXD		@ 0xB0;
static volatile bit TXD		@ 0xB1;
static volatile bit INT0	@ 0xB2;
static volatile bit INT1	@ 0xB3;
static volatile bit T0		@ 0xB4;
static volatile bit T1		@ 0xB5;

//Interrupt Priority IPL0
static 		bit PX0 	@ 0xB8;
static 		bit PT0		@ 0xB9;
static 		bit PX1		@ 0xBA;
static 		bit PT1		@ 0xBB;
static 		bit PS		@ 0xBC;
static 		bit PT2		@ 0xBD;
static 		bit PPC		@ 0xBE;

//Port 4
static volatile bit P40		@ 0xC0;
static volatile bit P41		@ 0xC1;
static volatile bit P42		@ 0xC2;
static volatile bit P43		@ 0xC3;
static volatile bit P44		@ 0xC4;
static volatile bit P45		@ 0xC5;
static volatile bit P46		@ 0xC6;
static volatile bit P47		@ 0xC7;

//Timer 2 Control T2CON
static 		bit CPRL2	@ 0xC8;
static 		bit CT2		@ 0xC9;
static 		bit TR2		@ 0xCA;
static 		bit EXEN2	@ 0xCB;
static volatile	bit TCLK	@ 0xCC;
static volatile	bit RCLK	@ 0xCD;
static volatile	bit EXF2	@ 0xCE;
static volatile	bit TF2		@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Counter Control CCON
static volatile bit CCF0 	@ 0xD8;
static volatile bit CCF1 	@ 0xD9;
static volatile bit CCF2 	@ 0xDA;
static volatile bit CCF3 	@ 0xDB;
static volatile bit CCF4 	@ 0xDC;
static		bit CR	 	@ 0xDE;
static volatile bit CF		@ 0xDF;

//Accumulator
static volatile bit ACC0	@ 0xE0;
static volatile bit ACC1	@ 0xE1;
static volatile bit ACC2	@ 0xE2;
static volatile bit ACC3	@ 0xE3;
static volatile bit ACC4	@ 0xE4;
static volatile bit ACC5	@ 0xE5;
static volatile bit ACC6	@ 0xE6;
static volatile bit ACC7	@ 0xE7;

//Interrupt Enable 1 IEN1
static		bit ECAN	@ 0xE8;
static		bit EADC	@ 0xE9;
static		bit ETIM	@ 0xEA;

//B Register
static 		bit B0		@ 0xF0;
static 		bit B1		@ 0xF1;
static 		bit B2		@ 0xF2;
static 		bit B3		@ 0xF3;
static 		bit B4		@ 0xF4;
static 		bit B5		@ 0xF5;
static 		bit B6		@ 0xF6;
static 		bit B7		@ 0xF7;

//Interrupt Priority 1 Low IPL1
static		bit PCANL	@ 0xF8;
static		bit PADCL	@ 0xF9;
static		bit POVRL	@ 0xFA;

/*	Interrupt vectors */
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0 	0x0B
#define	EXTINT1	0x13
#define TIMER1 	0x1B
#define SERIAL 	0x23
#define TIMER2 	0x2B
#define PCA 	0x33
#define CAN 	0x3B
#define ADC 	0x43
#define CANTM 	0x4B

#endif	
