
#ifndef	_HTC_H_
#warning Header file 8xc5103.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Atmel microcontrollers
	AT83C5103
	AT87C5103
 */

/*** note that TCON bits IE0 and IE1 are renamed IEDGE0 and IEDGE1 ***/
/*** to avoid conflict with SFRs interrupt enable 0 & 1 ***/

#ifndef	__8XC5103_H

#define	__8XC5103_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static		unsigned char CKCON0	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static		unsigned char AUXR1	@ 0xA2;
static          unsigned char IE0	@ 0xA8;
static		unsigned char CKCON1	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static          unsigned char IE1	@ 0xB1;
static          unsigned char IPL1	@ 0xB2;
static          unsigned char IPH1	@ 0xB3;
static          unsigned char IPH0	@ 0xB7;
static          unsigned char IPL0	@ 0xB8;
static volatile unsigned char P4	@ 0xC0;
static		unsigned char SPCON	@ 0xC3;
static volatile unsigned char SPSTA	@ 0xC4;
static volatile unsigned char SPDAT	@ 0xC5;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char P1M1	@ 0xD4;
static		unsigned char P3M1	@ 0xD5;
static volatile unsigned char CCON	@ 0xD8;
static          unsigned char CMOD	@ 0xD9;
static          unsigned char CCAPM0	@ 0xDA;
static          unsigned char CCAPM1	@ 0xDB;
static          unsigned char CCAPM2	@ 0xDC;
static          unsigned char CCAPM3	@ 0xDD;
static          unsigned char CCAPM4	@ 0xDE;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char P1M2	@ 0xE2;
static		unsigned char P3M2	@ 0xE4;
static volatile unsigned char CL	@ 0xE9;
static volatile unsigned char CCAP0L	@ 0xEA;
static volatile unsigned char CCAP1L	@ 0xEB;
static volatile unsigned char CCAP2L	@ 0xEC;
static volatile unsigned char CCAP3L	@ 0xED;
static volatile unsigned char CCAP4L	@ 0xEE;
static volatile unsigned char B		@ 0xF0;
static volatile unsigned char CH	@ 0xF9;
static volatile unsigned char CCAP0H	@ 0xFA;
static volatile unsigned char CCAP1H	@ 0xFB;
static volatile unsigned char CCAP2H	@ 0xFC;
static volatile unsigned char CCAP3H	@ 0xFD;
static volatile unsigned char CCAP4H	@ 0xFE;

static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static		SFR_BITS	 CKCON0_BITS	@ 0x8F;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static		SFR_BITS	 AUXR1_BITS	@ 0xA2;
static          SFR_BITS	 IE0_BITS	@ 0xA8;
static		SFR_BITS	 CKCON1_BITS	@ 0xAF;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static          SFR_BITS	 IE1_BITS	@ 0xB1;
static          SFR_BITS	 IPL1_BITS	@ 0xB2;
static          SFR_BITS	 IPH1_BITS	@ 0xB3;
static          SFR_BITS	 IPH0_BITS	@ 0xB7;
static          SFR_BITS	 IPL0_BITS	@ 0xB8;
static volatile SFR_BITS	 P4_BITS	@ 0xC0;
static		SFR_BITS	 SPCON_BITS	@ 0xC3;
static volatile SFR_BITS	 SPSTA_BITS	@ 0xC4;
static volatile SFR_BITS	 SPDAT_BITS	@ 0xC5;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static		SFR_BITS	 P1M1_BITS	@ 0xD4;
static		SFR_BITS	 P3M1_BITS	@ 0xD5;
static volatile SFR_BITS	 CCON_BITS	@ 0xD8;
static          SFR_BITS	 CMOD_BITS	@ 0xD9;
static          SFR_BITS	 CCAPM0_BITS	@ 0xDA;
static          SFR_BITS	 CCAPM1_BITS	@ 0xDB;
static          SFR_BITS	 CCAPM2_BITS	@ 0xDC;
static          SFR_BITS	 CCAPM3_BITS	@ 0xDD;
static          SFR_BITS	 CCAPM4_BITS	@ 0xDE;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static		SFR_BITS	 P1M2_BITS	@ 0xE2;
static		SFR_BITS	 P3M2_BITS	@ 0xE4;
static volatile SFR_BITS	 CL_BITS	@ 0xE9;
static volatile SFR_BITS	 CCAP0L_BITS	@ 0xEA;
static volatile SFR_BITS	 CCAP1L_BITS	@ 0xEB;
static volatile SFR_BITS	 CCAP2L_BITS	@ 0xEC;
static volatile SFR_BITS	 CCAP3L_BITS	@ 0xED;
static volatile SFR_BITS	 CCAP4L_BITS	@ 0xEE;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static volatile SFR_BITS	 CH_BITS	@ 0xF9;
static volatile SFR_BITS	 CCAP0H_BITS	@ 0xFA;
static volatile SFR_BITS	 CCAP1H_BITS	@ 0xFB;
static volatile SFR_BITS	 CCAP2H_BITS	@ 0xFC;
static volatile SFR_BITS	 CCAP3H_BITS	@ 0xFD;
static volatile SFR_BITS	 CCAP4H_BITS	@ 0xFE;


// Bit Addressable Locations
//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IEDGE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IEDGE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate functions
static volatile bit	MISO	@ 0x90;
static volatile bit	MOSI	@ 0x91;
static volatile bit	DIG2	@ 0x92;
static volatile bit	CEX0	@ 0x93;
static volatile bit	CEX1	@ 0x94;
static volatile bit	CEX2	@ 0x95;
static volatile bit	CEX3	@ 0x96;
static volatile bit	SS	@ 0x97;

//Interrupt Enable 0 IE0
static 		bit	EX0	@ 0xA8;
static 		bit	ET0	@ 0xA9;
static 		bit 	ET1	@ 0xAB;
static 		bit 	EC	@ 0xAE;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;

// definitions for register IPL0
static		bit	PX0L	@ 0xB8;
static		bit	PT0L	@ 0xB9;
static		bit	PT1L	@ 0xBB;
static		bit	PPCL	@ 0xBE;

//Port 4
static volatile bit	P40	@ 0xC0;
static volatile bit	P41	@ 0xC1;
static volatile bit	P42	@ 0xC2;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Counter Control CCON
static volatile	bit	CCF0	@ 0xD8;
static volatile	bit	CCF1	@ 0xD9;
static volatile	bit	CCF2	@ 0xDA;
static volatile	bit	CCF3	@ 0xDB;
static volatile	bit	CCF4	@ 0xDC;
static		bit	CR	@ 0xDE;
static volatile	bit	CF	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	TIMER1	0x1B
#define	PCA	0x33
#define	SPI	0x43

#endif
