
#ifndef	_HTC_H_
#warning Header file 8xc51gb.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Intel Microcontrollers
	80C51GB
	87C51GB

	*** PLEASE NOTE THAT THE BIT, SEPDAT (P4.1) IS RENAMED SEPIO ***
	*** BITS AD0-AD7 (P0.0 - P0.7) ARE RENAMED A0 - A7 ***
*/

#ifndef __8XC51GB_H
#define __8XC51GB_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char AD0	@ 0x84;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char AD1	@ 0x94;
static volatile unsigned char ACON	@ 0x97;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static		unsigned char C1CAPM0	@ 0x9A;
static		unsigned char C1CAPM1	@ 0x9B;
static		unsigned char C1CAPM2	@ 0x9C;
static		unsigned char C1CAPM3	@ 0x9D;
static		unsigned char C1CAPM4	@ 0x9E;
static		unsigned char C1MOD	@ 0x9F;
static volatile unsigned char P2	@ 0xA0;
static volatile unsigned char AD2	@ 0xA4;
static volatile unsigned char OSCR	@ 0xA5;
static volatile unsigned char WDTRST	@ 0xA6;
static		unsigned char IEA	@ 0xA7;
static		unsigned char IE	@ 0xA8;
static		unsigned char SADDR	@ 0xA9;
static volatile	unsigned char C1CAP0L	@ 0xAA;
static volatile	unsigned char C1CAP1L	@ 0xAB;
static volatile	unsigned char C1CAP2L	@ 0xAC;
static volatile	unsigned char C1CAP3L	@ 0xAD;
static volatile	unsigned char C1CAP4L	@ 0xAE;
static volatile	unsigned char CL1	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static volatile unsigned char AD3	@ 0xB4;
static		unsigned char IPAH	@ 0xB5;
static		unsigned char IPA	@ 0xB6;
static		unsigned char IPH	@ 0xB7;
static		unsigned char IP	@ 0xB8;
static		unsigned char SADEN	@ 0xB9;
static volatile	unsigned char C1CAP0H	@ 0xBA;
static volatile	unsigned char C1CAP1H	@ 0xBB;
static volatile	unsigned char C1CAP2H	@ 0xBC;
static volatile	unsigned char C1CAP3H	@ 0xBD;
static volatile	unsigned char C1CAP4H	@ 0xBE;
static volatile	unsigned char CH1	@ 0xBF;
static volatile unsigned char P4	@ 0xC0;
static volatile unsigned char AD4	@ 0xC4;
static volatile unsigned char EXICON	@ 0xC6;
static volatile unsigned char ACMP	@ 0xC7;
static volatile unsigned char T2CON	@ 0xC8;
static		unsigned char T2MOD	@ 0xC9;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char AD5	@ 0xD4;
static		unsigned char SEPCON	@ 0xD7;
static volatile unsigned char CCON	@ 0xD8;
static		unsigned char CMOD	@ 0xD9;
static		unsigned char CCAPM0	@ 0xDA;
static		unsigned char CCAPM1	@ 0xDB;
static		unsigned char CCAPM2	@ 0xDC;
static		unsigned char CCAPM3	@ 0xDD;
static		unsigned char CCAPM4	@ 0xDE;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char AD6	@ 0xE4;
static volatile unsigned char SEPDAT	@ 0xE7;
static volatile unsigned char C1CON	@ 0xE8;
static volatile unsigned char CL	@ 0xE9;
static volatile unsigned char CCAP0L	@ 0xEA;
static volatile unsigned char CCAP1L	@ 0xEB;
static volatile unsigned char CCAP2L	@ 0xEC;
static volatile unsigned char CCAP3L	@ 0xED;
static volatile unsigned char CCAP4L	@ 0xEE;
static volatile unsigned char B		@ 0xF0;
static volatile unsigned char AD7	@ 0xF4;
static volatile unsigned char SEPSTAT	@ 0xF7;
static volatile unsigned char P5	@ 0xF8;
static volatile unsigned char CH	@ 0xF9;
static volatile unsigned char CCAP0H	@ 0xFA;
static volatile unsigned char CCAP1H	@ 0xFB;
static volatile unsigned char CCAP2H	@ 0xFC;
static volatile unsigned char CCAP3H	@ 0xFD;
static volatile unsigned char CCAP4H	@ 0xFE;

static volatile SFR_BITS P0_BITS	@ 0x80;
static volatile SFR_BITS PCON_BITS	@ 0x87;
static volatile SFR_BITS TCON_BITS	@ 0x88;
static		SFR_BITS TMOD_BITS	@ 0x89;
static volatile SFR_BITS P1_BITS	@ 0x90;
static volatile SFR_BITS ACON_BITS	@ 0x97;
static volatile SFR_BITS SCON_BITS	@ 0x98;
static		SFR_BITS C1CAPM0_BITS	@ 0x9A;
static		SFR_BITS C1CAPM1_BITS	@ 0x9B;
static		SFR_BITS C1CAPM2_BITS	@ 0x9C;
static		SFR_BITS C1CAPM3_BITS	@ 0x9D;
static		SFR_BITS C1CAPM4_BITS	@ 0x9E;
static		SFR_BITS C1MOD_BITS	@ 0x9F;
static volatile SFR_BITS P2_BITS	@ 0xA0;
static volatile SFR_BITS OSCR_BITS	@ 0xA5;
static		SFR_BITS IEA_BITS	@ 0xA7;
static		SFR_BITS IE_BITS	@ 0xA8;
static volatile SFR_BITS P3_BITS	@ 0xB0;
static		SFR_BITS IPAH_BITS	@ 0xB5;
static		SFR_BITS IPA_BITS	@ 0xB6;
static		SFR_BITS IPH_BITS	@ 0xB7;
static		SFR_BITS IP_BITS	@ 0xB8;
static		SFR_BITS SADEN_BITS	@ 0xB9;
static volatile SFR_BITS P4_BITS	@ 0xC0;
static volatile SFR_BITS EXICON_BITS	@ 0xC6;
static volatile SFR_BITS ACMP_BITS	@ 0xC7;
static volatile SFR_BITS T2CON_BITS	@ 0xC8;
static		SFR_BITS T2MOD_BITS	@ 0xC9;
static volatile SFR_BITS PSW_BITS	@ 0xD0;
static		SFR_BITS SEPCON_BITS	@ 0xD7;
static volatile SFR_BITS CCON_BITS	@ 0xD8;
static		SFR_BITS CMOD_BITS	@ 0xD9;
static		SFR_BITS CCAPM0_BITS	@ 0xDA;
static		SFR_BITS CCAPM1_BITS	@ 0xDB;
static		SFR_BITS CCAPM2_BITS	@ 0xDC;
static		SFR_BITS CCAPM3_BITS	@ 0xDD;
static		SFR_BITS CCAPM4_BITS	@ 0xDE;
static volatile SFR_BITS ACC_BITS	@ 0xE0;
static volatile SFR_BITS C1CON_BITS	@ 0xE8;
static volatile SFR_BITS B_BITS		@ 0xF0;
static volatile SFR_BITS SEPSTAT_BITS	@ 0xF7;
static volatile SFR_BITS P5_BITS	@ 0xF8;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	A0	@ 0x80;
static volatile bit	A1	@ 0x81;
static volatile bit	A2	@ 0x82;
static volatile bit	A3	@ 0x83;
static volatile bit	A4	@ 0x84;
static volatile bit	A5	@ 0x85;
static volatile bit	A6	@ 0x86;
static volatile bit	A7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate Functions
static volatile bit	T2	@ 0x90;
static volatile bit	T2EX	@ 0x91;
static volatile bit	ECI	@ 0x92;
static volatile bit	CEX0	@ 0x93;
static volatile bit	CEX1	@ 0x94;
static volatile bit	CEX2	@ 0x95;
static volatile bit	CEX3	@ 0x96;
static volatile bit	CEX4	@ 0x97;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile	bit	SM0	@ 0x9F;
// Alternate Functions
static volatile	bit	FE	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	EC	@ 0xAE;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
static 		bit	PT2	@ 0xBD;
static 		bit	PPC	@ 0xBE;

//Port 4
static volatile bit	P40	@ 0xC0;
static volatile bit	P41	@ 0xC1;
static volatile bit	P42	@ 0xC2;
static volatile bit	P43	@ 0xC3;
static volatile bit	P44	@ 0xC4;
static volatile bit	P45	@ 0xC5;
static volatile bit	P46	@ 0xC6;
static volatile bit	P47	@ 0xC7;
// Alternate Functions
static volatile bit	SEPCLK	@ 0xC0;
static volatile bit	SEPIO	@ 0xC1;
static volatile bit	ECI1	@ 0xC2;
static volatile bit	C1EX0	@ 0xC3;
static volatile bit	C1EX1	@ 0xC4;
static volatile bit	C1EX2	@ 0xC5;
static volatile bit	C1EX3	@ 0xC6;
static volatile bit	C1EX4	@ 0xC7;

//Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Counter Control CCON
static volatile	bit	CCF0	@ 0xD8;
static volatile	bit	CCF1	@ 0xD9;
static volatile	bit	CCF2	@ 0xDA;
static volatile	bit	CCF3	@ 0xDB;
static volatile	bit	CCF4	@ 0xDC;
static		bit	CR	@ 0xDE;
static volatile	bit	CF	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Counter Control 1 CCON1
static volatile	bit	CCF0_1	@ 0xE8;
static volatile	bit	CCF1_1	@ 0xE9;
static volatile	bit	CCF2_1	@ 0xEA;
static volatile	bit	CCF3_1	@ 0xEB;
static volatile	bit	CCF4_1	@ 0xEC;
static		bit	CR_1	@ 0xEE;
static volatile	bit	CF_1	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

//Port 5 P5
static volatile bit	P50	@ 0xF8;
static volatile bit	P51	@ 0xF9;
static volatile bit	P52	@ 0xFA;
static volatile bit	P53	@ 0xFB;
static volatile bit	P54	@ 0xFC;
static volatile bit	P55	@ 0xFD;
static volatile bit	P56	@ 0xFE;
static volatile bit	P57	@ 0xFF;
// Alternate Functions
static volatile bit	INT2	@ 0xFA;
static volatile bit	INT3	@ 0xFB;
static volatile bit	INT4	@ 0xFC;
static volatile bit	INT5	@ 0xFD;
static volatile bit	INT6	@ 0xFE;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	PCA	0x33
#define	AD	0x3B
#define	PCA1	0x43
#define	SEP	0x4B
#define	EXTINT2	0x53
#define	EXTINT3	0x5B
#define	EXTINT4	0x63
#define	EXTINT5	0x6B
#define	EXTINT6	0x73

#endif
