
#ifndef	_HTC_H_
#warning Header file 9xc713x.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Hynix Microcontrollers
	HMS91C7132
	HMS91C7134
	HMS97C7132
	HMS97C7134

*** Please note, to avoid identical declaration, the Bytes dealing with the ***
*** PWM unit retain their original name (eg. PWM0, DPWM0), whereas the Bits  ***
*** concerned with PWM channels are renamed to PWx (eg. PW0, DPW0). ***
*/

#ifndef __9XC713X_H
#define __9XC713X_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static		unsigned char P1SFS	@ 0x91;
static		unsigned char P2SFS	@ 0x92;
static		unsigned char P3SFS	@ 0x93;
static volatile unsigned char ADAT	@ 0x96;
static volatile unsigned char ACON	@ 0x97;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char PWMCON	@ 0xA1;
static		unsigned char PWM0	@ 0xA2;
static		unsigned char PWM1	@ 0xA3;
static		unsigned char PWM2	@ 0xA4;
static		unsigned char PWM3	@ 0xA5;
static volatile unsigned char WDTRST	@ 0xA6;
static		unsigned char IEA	@ 0xA7;
static		unsigned char IE	@ 0xA8;
static		unsigned char PWM4	@ 0xAA;
static		unsigned char PWM5	@ 0xAB;
static		unsigned char PWM6	@ 0xAC;
static		unsigned char PWM7	@ 0xAD;
static		unsigned char WDTKEY	@ 0xAE;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char DPWMCON	@ 0xB1;
static		unsigned char DPWM0	@ 0xB2;
static		unsigned char DPWM1	@ 0xB3;
static		unsigned char IPA	@ 0xB6;
static		unsigned char IP	@ 0xB8;
static volatile unsigned char T2CON	@ 0xC8;
static volatile unsigned char RC2L	@ 0xCA;
static volatile unsigned char RC2H	@ 0xCB;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char S1SDR1	@ 0xD3;
static volatile unsigned char RAMBUF	@ 0xD4;
static volatile unsigned char DDCDAT	@ 0xD5;
static volatile unsigned char DDCADR	@ 0xD6;
static volatile unsigned char DDCCON	@ 0xD7;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static		unsigned char S1ADR0	@ 0xDB;
static volatile unsigned char S2CON	@ 0xDC;
static volatile unsigned char S2STA	@ 0xDD;
static volatile unsigned char S2DAT	@ 0xDE;
static		unsigned char S2ADR	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char EXCON	@ 0xE8;
static volatile unsigned char B		@ 0xF0;
static volatile unsigned char MDCON	@ 0xF1;
static volatile unsigned char MDST	@ 0xF2;
static volatile unsigned char VPH	@ 0xF3;
static volatile unsigned char HPH	@ 0xF4;
static volatile unsigned char VHPL	@ 0xF5;
static		unsigned char HVGEN	@ 0xF9;
static		unsigned char CPGEN	@ 0xFA;
static volatile unsigned char VFH	@ 0xFB;
static volatile unsigned char VFL	@ 0xFC;
static volatile unsigned char HFH	@ 0xFD;
static volatile unsigned char HFL	@ 0xFE;

static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static		SFR_BITS P1SFS_BITS		@ 0x91;
static		SFR_BITS P2SFS_BITS		@ 0x92;
static		SFR_BITS P3SFS_BITS		@ 0x93;
static volatile SFR_BITS ACON_BITS		@ 0x97;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS PWMCON_BITS		@ 0xA1;
static		SFR_BITS IEA_BITS		@ 0xA7;
static		SFR_BITS IE_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static		SFR_BITS DPWMCON_BITS		@ 0xB1;
static		SFR_BITS IPA_BITS		@ 0xB6;
static		SFR_BITS IP_BITS		@ 0xB8;
static volatile SFR_BITS T2CON_BITS		@ 0xC8;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS S1SDR1_BITS		@ 0xD3;
static volatile SFR_BITS DDCCON_BITS		@ 0xD7;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS S2CON_BITS		@ 0xDC;
static volatile SFR_BITS S2STA_BITS		@ 0xDD;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static		SFR_BITS EXCON_BITS		@ 0xE8;
static volatile SFR_BITS B_BITS			@ 0xF0;
static volatile SFR_BITS MDCON_BITS		@ 0xF1;
static volatile SFR_BITS MDST_BITS		@ 0xF2;
static		SFR_BITS HVGEN_BITS		@ 0xF9;
static		SFR_BITS CPGEN_BITS		@ 0xFA;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate Functions
static volatile bit	SCL1	@ 0x90;
static volatile bit	SDA1	@ 0x91;
static volatile bit	ACH0	@ 0x92;
static volatile bit	ACH1	@ 0x93;
static volatile bit	ACH2	@ 0x94;
static volatile bit	ACH3	@ 0x95;
static volatile bit	SCL2	@ 0x96;
static volatile bit	SDA2	@ 0x97;


//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	DPW0	@ 0xA0;
static volatile bit	DPW1	@ 0xA1;
static volatile bit	PW0	@ 0xA2;
static volatile bit	PW1	@ 0xA3;
static volatile bit	PW2	@ 0xA4;
static volatile bit	PW3	@ 0xA5;
static volatile bit	PW4	@ 0xA6;
static volatile bit	PW5	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static		bit	ET2	@ 0xAD;
static		bit	EVSYNC	@ 0xAE;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	HSYNC	@ 0xB2;
static volatile bit	VSYNC	@ 0xB3;
static volatile bit	PW6	@ 0xB4;
static volatile bit	PW7	@ 0xB5;
static volatile bit	PATOUT	@ 0xB6;
static volatile bit	SOG	@ 0xB7;
static volatile bit	CLAMP	@ 0xB5;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
static 		bit	PT2	@ 0xBD;
static 		bit	PVSYNC	@ 0xBE;

//Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	ADDR	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENI1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// Extended Control Register EXCON
static		bit	XRAMS	@ 0xE8;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	TIMER2	0x2B
#define	VS	0x33
#define	DDC	0x3B
#define	I2C	0x43
#define	MD	0x4B

#endif
