
#ifndef	_HTC_H_
#warning Header file aduc836.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Analog Devices microcontroller
	ADUC836
 */

#ifndef	__ADUC836_H

#define	__ADUC836_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16-Bit definition
static volatile unsigned char DPP	@ 0x84;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static		unsigned char T3FD	@ 0x9D;
static		unsigned char T3CON	@ 0x9E;
static volatile unsigned char P2	@ 0xA0;
static volatile unsigned char TIMECON	@ 0xA1;
static volatile unsigned char HTHSEC	@ 0xA2;
static volatile unsigned char SEC	@ 0xA3;
static volatile unsigned char MIN	@ 0xA4;
static volatile unsigned char HOUR	@ 0xA5;
static		unsigned char INTVAL	@ 0xA6;
static		unsigned char DPCON	@ 0xA7;
static          unsigned char IE	@ 0xA8;
static		unsigned char IEIP2	@ 0xA9;
static		unsigned char PWMCON	@ 0xAE;
static		unsigned char CFG836	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static          unsigned char PWM0L	@ 0xB1;
static          unsigned char PWM0H	@ 0xB2;
static          unsigned char PWM1L	@ 0xB3;
static          unsigned char PWM1H	@ 0xB4;
static volatile unsigned char SPH	@ 0xB7;
static          unsigned char IP	@ 0xB8;
static volatile unsigned char ECON	@ 0xB9;
static volatile unsigned char EDATA1	@ 0xBC;
static volatile unsigned char EDATA2	@ 0xBD;
static volatile unsigned char EDATA3	@ 0xBE;
static volatile unsigned char EDATA4	@ 0xBF;
static volatile unsigned char WDCON	@ 0xC0;
static		unsigned char CHIPID	@ 0xC2;
static		unsigned char EADRL	@ 0xC6;
static		unsigned char EADRH	@ 0xC7;
static volatile unsigned char T2CON	@ 0xC8;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char ADCMODE	@ 0xD1;
static		unsigned char ADC0CON	@ 0xD2;
static		unsigned char ADC1CON	@ 0xD3;
static		unsigned char SF	@ 0xD4;
static		unsigned char ICON	@ 0xD5;
static volatile unsigned char PLLCON	@ 0xD7;
static volatile unsigned char ADCSTAT	@ 0xD8;
static volatile unsigned char ADC0M	@ 0xDA;
static volatile unsigned char ADC0H	@ 0xDB;
static volatile unsigned char ADC1L	@ 0xDC;
static volatile unsigned char ADC1H	@ 0xDD;
static volatile unsigned char PSMCON	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char OF0M	@ 0xE2;
static		unsigned char OF0H	@ 0xE3;
static		unsigned char OF1L	@ 0xE4;
static		unsigned char OF1H	@ 0xE5;
static volatile unsigned char I2CCON	@ 0xE8;
static		unsigned char GN0M	@ 0xEA;
static		unsigned char GN0H	@ 0xEB;
static		unsigned char GN1L	@ 0xEC;
static		unsigned char GN1H	@ 0xED;
static volatile unsigned char B		@ 0xF0;
static volatile unsigned char SPIDAT	@ 0xF7;
static volatile unsigned char SPICON	@ 0xF8;
static          unsigned char DACL	@ 0xFB;
static          unsigned char DACH	@ 0xFC;
static		unsigned char DACCON	@ 0xFD;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static volatile SFR_BITS	 SCON_BITS	@ 0x98;
static		SFR_BITS	 T3CON_BITS	@ 0x9E;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static volatile SFR_BITS	 TIMECON_BITS	@ 0xA1;
static		SFR_BITS	 DPCON_BITS	@ 0xA7;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static		SFR_BITS	 IEIP2_BITS	@ 0xA9;
static		SFR_BITS	 PWMCON_BITS	@ 0xAE;
static		SFR_BITS	 CFG836_BITS	@ 0xAF;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static volatile SFR_BITS	 SPH_BITS	@ 0xB7;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 ECON_BITS	@ 0xB9;
static volatile SFR_BITS	 WDCON_BITS	@ 0xC0;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static		SFR_BITS	 ADCMODE_BITS	@ 0xD1;
static		SFR_BITS	 ADC0CON_BITS	@ 0xD2;
static		SFR_BITS	 ADC1CON_BITS	@ 0xD3;
static		SFR_BITS	 ICON_BITS	@ 0xD5;
static volatile SFR_BITS	 PLLCON_BITS	@ 0xD7;
static volatile SFR_BITS	 ADCSTAT_BITS	@ 0xD8;
static volatile SFR_BITS	 PSMCON_BITS	@ 0xDF;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static volatile SFR_BITS	 I2CCON_BITS	@ 0xE8;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static volatile SFR_BITS	 SPIDAT_BITS	@ 0xF7;
static volatile SFR_BITS	 SPICON_BITS	@ 0xF8;
static		SFR_BITS	 DACCON_BITS	@ 0xFD;


// Bit Addressable Locations
// Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

// Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate Functions
static volatile bit	T2	@ 0x90;
static volatile bit	T2EX	@ 0x91;

// Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile bit	SM0	@ 0x9F;

// Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

// Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	EADC	@ 0xAE;
static 		bit	EA	@ 0xAF;

// Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

// Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
static 		bit	PT2	@ 0xBD;
static 		bit	PADC	@ 0xBE;

// Watchdog Control WDCON
static		bit	WDWR	@ 0xC0;
static		bit	WDE	@ 0xC1;
static volatile bit	WDS	@ 0xC2;
static		bit	WDIR	@ 0xC3;
static		bit	PRE0	@ 0xC4;
static		bit	PRE1	@ 0xC5;
static 		bit	PRE2	@ 0xC6;
static 		bit	PRE3	@ 0xC7;

// Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;
// Alternate definitions
static 		bit	CAP2	@ 0xC8;
static 		bit	CNT2	@ 0xC9;

// Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// definitions for register ADCSTAT
static volatile bit	ERR1	@ 0xDA;
static volatile bit	ERR0	@ 0xDB;
static volatile bit	NOXREF	@ 0xDC;
static volatile bit	CAL	@ 0xDD;
static volatile bit	RDY1	@ 0xDE;
static volatile bit	RDY0	@ 0xDF;


// Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// definitions for register I2CCON
static volatile bit	I2CI	@ 0xE8;
static volatile bit	I2CTX	@ 0xE9;
static		bit	I2CRS	@ 0xEA;
static		bit	I2CM	@ 0xEB;
static		bit	MDI	@ 0xEC;
static		bit	MCO	@ 0xED;
static		bit	MDE	@ 0xEE;
static		bit	MDO	@ 0xEF;

// B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// definitions for register SPICON
static		bit	SPR0	@ 0xF8;
static		bit	SPR1	@ 0xF9;
static		bit	CPHA	@ 0xFA;
static		bit	CPOL	@ 0xFB;
static		bit	SPIM	@ 0xFC;
static		bit	SPE	@ 0xFD;
static volatile bit	WCOL	@ 0xFE;
static volatile bit	ISPI	@ 0xFF;


// Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	ADC	0x33
#define	SPI	0x3B
#define	PSM	0x43
#define	TII	0x53
#define	WDTI	0x5B

#endif
