
#ifndef	_HTC_H_
#warning Header file atxsnd1a.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Atmel Microcontrollers
	AT83C51SND1A
	AT89C51SND1A
	AT80C51SND1C
	AT83SND1C
	AT89C51SND1C
	AT83SND2C
	AT89C51SND2C
*/

#ifndef __ATXSND1A_H
#define __ATXSND1A_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char AUXR	@ 0x8E;
static		unsigned char CKCON	@ 0x8F;
#if defined(_AT83SND2C) || defined(_AT89C51SND2C)
static volatile unsigned char AUXCON	@ 0x90;
#else
static volatile unsigned char P1	@ 0x90;
#endif
static		unsigned char BRL	@ 0x91;
static volatile unsigned char BDRCON	@ 0x92;
static volatile unsigned char SSCON	@ 0x93;
static volatile unsigned char SSSTA	@ 0x94;
static volatile unsigned char SSDAT	@ 0x95;
static volatile unsigned char SSADR	@ 0x96;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static volatile unsigned char AUDCON0	@ 0x9A;
static volatile unsigned char AUDCON1	@ 0x9B;
static volatile unsigned char AUDSTA	@ 0x9C;
static volatile unsigned char AUDDAT	@ 0x9D;
static		unsigned char MP3VOL	@ 0x9E;
static		unsigned char MP3VOR	@ 0x9F;
static volatile unsigned char P2	@ 0xA0;
static volatile unsigned char AUXR1	@ 0xA2;
static volatile unsigned char KBCON	@ 0xA3;
static volatile unsigned char KBSTA	@ 0xA4;
static volatile unsigned char WDTRST	@ 0xA6;
static volatile unsigned char WDTPRG	@ 0xA7;
static		unsigned char IEN0	@ 0xA8;
static		unsigned char SADDR	@ 0xA9;
static volatile unsigned char MP3CON	@ 0xAA;
static volatile unsigned char MP3DAT	@ 0xAC;
static volatile unsigned char MP3ANC	@ 0xAD;
static volatile unsigned char MP3STA1	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IEN1	@ 0xB1;
static		unsigned char IPL1	@ 0xB2;
static		unsigned char IPH1	@ 0xB3;
static		unsigned char MP3BAS	@ 0xB4;
static		unsigned char MP3MED	@ 0xB5;
static		unsigned char MP3TRE	@ 0xB6;
static		unsigned char IPH0	@ 0xB7;
static		unsigned char IPL0	@ 0xB8;
static		unsigned char SADEN	@ 0xB9;
static volatile unsigned char UFNUML	@ 0xBA;
static volatile unsigned char UFNUMH	@ 0xBB;
static volatile unsigned char USBCON	@ 0xBC;
static volatile unsigned char USBINT	@ 0xBD;
static		unsigned char USBIEN	@ 0xBE;
static volatile unsigned char P4	@ 0xC0;
static		unsigned char UEPIEN	@ 0xC2;
static volatile unsigned char SPCON	@ 0xC3;
static volatile unsigned char SPSTA	@ 0xC4;
static volatile unsigned char SPDAT	@ 0xC5;
static volatile unsigned char USBADDR	@ 0xC6;
static		unsigned char UEPNUM	@ 0xC7;
static volatile unsigned char MP3STA	@ 0xC8;
static volatile unsigned char UEPSTAX	@ 0xCE;
static volatile unsigned char UEPDATX	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
#if defined(_AT89C51SND1A) || defined(_AT89C51SND1C) || defined(_AT89C51SND2C)
static volatile unsigned char FCON	@ 0xD1;
#endif
static volatile unsigned char UEPCONX	@ 0xD4;
static volatile unsigned char UEPRST	@ 0xD5;
static volatile unsigned char P5	@ 0xD8;
static volatile unsigned char MMDAT	@ 0xDC;
static		unsigned char MMCMD	@ 0xDD;
static volatile unsigned char MMSTA	@ 0xDE;
static		unsigned char MMMSK	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char UBYCTLX	@ 0xE2;
static volatile unsigned char MMCON0	@ 0xE4;
static volatile unsigned char MMCON1	@ 0xE5;
static volatile unsigned char MMCON2	@ 0xE6;
static		unsigned char MMINT	@ 0xE7;
static volatile unsigned char PLLCON	@ 0xE9;
static		unsigned char USBCLK	@ 0xEA;
static		unsigned char MP3CLK	@ 0xEB;
static		unsigned char AUDCLK	@ 0xEC;
static		unsigned char MMCLK	@ 0xED;
static volatile unsigned char PLLNDIV	@ 0xEE;
static volatile unsigned char PLLRDIV	@ 0xEF;
static volatile unsigned char B		@ 0xF0;
#if defined(_AT83C51SND1A) || defined(_AT89C51SND1A) ||\
    defined(_AT80C51SND1C) || defined(_AT89C51SND1C) || defined(_AT83SND1C)
static		unsigned char ADCLK	@ 0xF2;
static volatile unsigned char ADCON	@ 0xF3;
static volatile unsigned char ADDL	@ 0xF4;
static volatile unsigned char ADDH	@ 0xF5;
#endif
static volatile unsigned char UEPINT	@ 0xF8;
static volatile unsigned char DAT16H	@ 0xF9;
static		unsigned char NVERS	@ 0xFB;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static volatile SFR_BITS	PCON_BITS	@ 0x87;
static volatile SFR_BITS	TCON_BITS	@ 0x88;
static		SFR_BITS	TMOD_BITS	@ 0x89;
static volatile SFR_BITS	AUXR_BITS	@ 0x8E;
static		SFR_BITS	CKCON_BITS	@ 0x8F;
#if defined(_AT83SND2C) || defined(_AT89C51SND2C)
static volatile SFR_BITS	AUXCON_BITS	@ 0x90;
#else
static volatile SFR_BITS	P1_BITS		@ 0x90;
#endif
static volatile SFR_BITS	BDRCON_BITS	@ 0x92;
static volatile SFR_BITS	SSCON_BITS	@ 0x93;
static volatile SFR_BITS	SSSTA_BITS	@ 0x94;
static volatile SFR_BITS	SSADR_BITS	@ 0x96;
static volatile SFR_BITS	SCON_BITS	@ 0x98;
static volatile SFR_BITS	AUDCON0_BITS	@ 0x9A;
static volatile SFR_BITS	AUDCON1_BITS	@ 0x9B;
static volatile SFR_BITS	AUDSTA_BITS	@ 0x9C;
static		SFR_BITS	MP3VOL_BITS	@ 0x9E;
static		SFR_BITS	MP3VOR_BITS	@ 0x9F;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static volatile SFR_BITS	AUXR1_BITS	@ 0xA2;
static volatile SFR_BITS	KBCON_BITS	@ 0xA3;
static volatile SFR_BITS	KBSTA_BITS	@ 0xA4;
static volatile SFR_BITS	WDTPRG_BITS	@ 0xA7;
static		SFR_BITS	IEN0_BITS	@ 0xA8;
static		SFR_BITS	SADDR_BITS	@ 0xA9;
static volatile SFR_BITS	MP3CON_BITS	@ 0xAA;
static volatile SFR_BITS	MP3STA1_BITS	@ 0xAF;
static volatile SFR_BITS	P3_BITS		@ 0xB0;
static		SFR_BITS	IEN1_BITS	@ 0xB1;
static		SFR_BITS	IPL1_BITS	@ 0xB2;
static		SFR_BITS	IPH1_BITS	@ 0xB3;
static		SFR_BITS	IPH0_BITS	@ 0xB7;
static		SFR_BITS	IPL0_BITS	@ 0xB8;
static		SFR_BITS	SADEN_BITS	@ 0xB9;
static volatile SFR_BITS	UFNUMH_BITS	@ 0xBB;
static volatile SFR_BITS	USBCON_BITS	@ 0xBC;
static volatile SFR_BITS	USBINT_BITS	@ 0xBD;
static		SFR_BITS	USBIEN_BITS	@ 0xBE;
static volatile SFR_BITS	P4_BITS		@ 0xC0;
static		SFR_BITS	UEPIEN_BITS	@ 0xC2;
static volatile SFR_BITS	SPCON_BITS	@ 0xC3;
static volatile SFR_BITS	SPSTA_BITS	@ 0xC4;
static volatile SFR_BITS	USBADDR_BITS	@ 0xC6;
static		SFR_BITS	UEPNUM_BITS	@ 0xC7;
static volatile SFR_BITS	MP3STA_BITS	@ 0xC8;
static volatile SFR_BITS	UEPSTAX_BITS	@ 0xCE;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
#if defined(_AT89C51SND1A) || defined(_AT89C51SND1C) || defined(_AT89C51SND2C)
static volatile SFR_BITS	FCON_BITS	@ 0xD1;
#endif
static volatile SFR_BITS	UEPCONX_BITS	@ 0xD4;
static volatile SFR_BITS	UEPRST_BITS	@ 0xD5;
static volatile SFR_BITS	P5_BITS		@ 0xD8;
static volatile SFR_BITS	MMSTA_BITS	@ 0xDE;
static		SFR_BITS	MMMSK_BITS	@ 0xDF;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static volatile SFR_BITS	MMCON0_BITS	@ 0xE4;
static volatile SFR_BITS	MMCON1_BITS	@ 0xE5;
static volatile SFR_BITS	MMCON2_BITS	@ 0xE6;
static volatile SFR_BITS	MMINT_BITS	@ 0xE7;
static volatile SFR_BITS	PLLCON_BITS	@ 0xE9;
static volatile SFR_BITS	B_BITS		@ 0xF0;
#if defined(_AT83C51SND1A) || defined(_AT89C51SND1A) ||\
    defined(_AT80C51SND1C) || defined(_AT89C51SND1C) || defined(_AT83SND1C)
static volatile SFR_BITS	ADCON_BITS	@ 0xF3;
#endif
static volatile SFR_BITS	UEPINT_BITS	@ 0xF8;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

#if defined(_AT83SND2C) || defined(_AT89C51SND2C)
// AUXCON - Auxilary control
static volatile bit	AUDCCS	@ 0x91;
static volatile bit	AUDCCLK	@ 0x92;
static volatile bit	AUDCDIN	@ 0x93;
static volatile bit	AUDCDOUT	@ 0x94;
#else
//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
#endif
// Alternate functions
static volatile bit	KIN0	@ 0x90;
static volatile bit	KIN1	@ 0x91;
static volatile bit	KIN2	@ 0x92;
static volatile bit	KIN3	@ 0x93;
static volatile bit	SCL	@ 0x96;
static volatile bit	SDA	@ 0x97;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile bit	SM0	@ 0x9F;
// Alternate definition
static volatile bit	FE	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES 	@ 0xAC;
static 		bit 	EMP3 	@ 0xAD;
static 		bit 	EAUD 	@ 0xAE;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority Low 0 IPL0
static 		bit 	IPLX0 	@ 0xB8;
static 		bit 	IPLT0 	@ 0xB9;
static 		bit 	IPLX1 	@ 0xBA;
static 		bit 	IPLT1 	@ 0xBB;
static 		bit 	IPLS 	@ 0xBC;
static 		bit 	IPLMP3 	@ 0xBD;
static 		bit 	IPLAUD 	@ 0xBE;

//Port 4
static volatile bit	P40	@ 0xC0;
static volatile bit	P41	@ 0xC1;
static volatile bit	P42	@ 0xC2;
static volatile bit	P43	@ 0xC3;
static volatile bit	P44	@ 0xC4;
static volatile bit	P45	@ 0xC5;
static volatile bit	P46	@ 0xC6;
static volatile bit	P47	@ 0xC7;
// Alternate Functions
static volatile bit	MISO	@ 0xC0;
static volatile bit	MOSI	@ 0xC1;
static volatile bit	SCK	@ 0xC2;
static volatile bit	SS	@ 0xC3;

// MP3 status register MP3STA
static volatile bit	MPVER	@ 0xC8;
static volatile bit	MPFS0	@ 0xC9;
static volatile bit	MPFS1	@ 0xCA;
static volatile bit	ERRCRC	@ 0xCB;
static volatile bit	ERRSYN	@ 0xCC;
static volatile bit	ERRLAY	@ 0xCD;
static volatile bit	MPREQ	@ 0xCE;
static volatile bit	MPANC	@ 0xCF;


//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Port 5 P5
static volatile bit	P50	@ 0xD8;
static volatile bit	P51	@ 0xD9;
static volatile bit	P52	@ 0xDA;
static volatile bit	P53	@ 0xDB;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// USB ENDPOINT INTERRUPT UEPINT
static volatile bit	EP0INT	@ 0xF8;
static volatile bit	EP1INT	@ 0xF9;
static volatile bit	EP2INT	@ 0xFA;
static volatile bit	EP3INT	@ 0xFB;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	MP3DECODE	0x2B
#define	AUDIO	0x33
#define	MMC	0x3B
#define	TWO_WIRE	0x43
#define	SPI	0x4B
#if defined(_AT83C51SND1A) || defined(_AT89C51SND1A) ||\
    defined(_AT80C51SND1C) || defined(_AT89C51SND1C) || defined(_AT83SND1C)
#define	A2D	0x53
#endif
#define	KEYBOARD	0x5B
#define	USB	0x6B

#endif
