
#ifndef	_HTC_H_
#warning Header file ks152jb.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Kawasaki LSI Microcontroller
	KS152JB
*/

#ifndef __KS152JB_H
#define __KS152JB_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static		unsigned char GMOD	@ 0x84;
static volatile unsigned char TFIFO	@ 0x85;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char P5	@ 0x91;
static volatile unsigned char DCON0	@ 0x92;
static volatile unsigned char DCON1	@ 0x93;
static		unsigned char BAUD	@ 0x94;
static		unsigned char ADR0	@ 0x95;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static volatile unsigned char P2	@ 0xA0;
static volatile unsigned char P6	@ 0xA1;
static volatile unsigned char SARL0	@ 0xA2;
static volatile unsigned char SARH0	@ 0xA3;
static volatile unsigned char IFS	@ 0xA4;
static		unsigned char ADR1	@ 0xA5;
static		unsigned char IE	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static volatile unsigned char SARL1	@ 0xB2;
static volatile unsigned char SARH1	@ 0xB3;
static volatile unsigned char SLOTTM	@ 0xB4;
static		unsigned char ADR2	@ 0xB5;
static		unsigned char IP	@ 0xB8;
static volatile unsigned char P4	@ 0xC0;
static volatile unsigned char DARL0	@ 0xC2;
static volatile unsigned char DARH0	@ 0xC3;
static volatile unsigned char BKOFF	@ 0xC4;
static		unsigned char ADR3	@ 0xC5;
static		unsigned char IEN1	@ 0xC8;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char DARL1	@ 0xD2;
static volatile unsigned char DARH1	@ 0xD3;
static volatile unsigned char TCDCNT	@ 0xD4;
static		unsigned char AMSK0	@ 0xD5;
static volatile unsigned char TSTAT	@ 0xD8;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char BCRL0	@ 0xE2;
static volatile unsigned char BCRH0	@ 0xE3;
static volatile unsigned char PBRS	@ 0xE4;
static		unsigned char AMSK1	@ 0xE5;
static volatile unsigned char RSTAT	@ 0xE8;
static volatile unsigned char B		@ 0xF0;
static volatile unsigned char BCRL1	@ 0xF2;
static volatile unsigned char BCRH1	@ 0xF3;
static volatile unsigned char RFIFO	@ 0xF4;
static		unsigned char MYSLOT	@ 0xF5;
static		unsigned char IPN1	@ 0xF8;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static		SFR_BITS	GMOD_BITS	@ 0x84;
static volatile SFR_BITS	PCON_BITS	@ 0x87;
static volatile SFR_BITS	TCON_BITS	@ 0x88;
static		SFR_BITS 	TMOD_BITS	@ 0x89;
static volatile SFR_BITS	P1_BITS		@ 0x90;
static volatile SFR_BITS	P5_BITS		@ 0x91;
static volatile SFR_BITS	DCON0_BITS	@ 0x92;
static volatile SFR_BITS	DCON1_BITS	@ 0x93;
static volatile SFR_BITS	SCON_BITS	@ 0x98;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static volatile SFR_BITS	P6_BITS		@ 0xA1;
static		SFR_BITS 	IE_BITS		@ 0xA8;
static volatile SFR_BITS	P3_BITS		@ 0xB0;
static		SFR_BITS 	IP_BITS		@ 0xB8;
static volatile SFR_BITS	P4_BITS		@ 0xC0;
static		SFR_BITS 	IEN1_BITS	@ 0xC8;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
static		SFR_BITS	AMSK0_BITS	@ 0xD5;
static volatile SFR_BITS	TSTAT_BITS	@ 0xD8;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static		SFR_BITS	AMSK1_BITS	@ 0xE5;
static volatile SFR_BITS	RSTAT_BITS	@ 0xE8;
static volatile SFR_BITS	B_BITS		@ 0xF0;
static		SFR_BITS	MYSLOT_BITS	@ 0xF5;
static		SFR_BITS	IPN1_BITS	@ 0xF8;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// alternate function
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static		bit	SM0	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// alternate function
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;

//Port 4
static volatile bit	P40	@ 0xC0;
static volatile bit	P41	@ 0xC1;
static volatile bit	P42	@ 0xC2;
static volatile bit	P43	@ 0xC3;
static volatile bit	P44	@ 0xC4;
static volatile bit	P45	@ 0xC5;
static volatile bit	P46	@ 0xC6;
static volatile bit	P47	@ 0xC7;

//Interrupt Enable 1 IEN1
static 		bit 	EGRSV	@ 0xC8;
static 		bit 	EGRSE	@ 0xC9;
static 		bit 	EDMA0	@ 0xCA;
static 		bit 	EGSTV	@ 0xCB;
static 		bit 	EDMA1	@ 0xCC;
static 		bit 	EGSTE	@ 0xCD;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// transmit status register TSTAT
static		bit	DMA	@ 0xD8;
static volatile bit	TEN	@ 0xD9;
static volatile bit	TFNF	@ 0xDA;
static volatile bit	TDN	@ 0xDB;
static volatile bit	TCDT	@ 0xDC;
static volatile bit	UR	@ 0xDD;
static volatile bit	NOACK	@ 0xDE;
static volatile bit	LNI	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// recieve status register RSTAT
static		bit	HABEN	@ 0xE8;
static volatile bit	GREN	@ 0xE9;
static volatile bit	RFNE	@ 0xEA;
static volatile bit	RDN	@ 0xEB;
static volatile bit	CRCE	@ 0xEC;
static volatile bit	AE	@ 0xED;
static volatile bit	RCABT	@ 0xEE;
static volatile bit	OVR	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// interrupt priority N1 IPN1
static		bit	PGSRV	@ 0xF8;
static		bit	PGSRE	@ 0xF9;
static		bit	PDMA0	@ 0xFA;
static		bit	PGSTV	@ 0xFB;
static		bit	PDMA1	@ 0xFC;
static		bit	PGSTE	@ 0xFD;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	GSCRV	0x2B
#define	GSCRE	0x33
#define	DMA0	0x3B
#define	GSCTV	0x43
#define	GSCTE	0x4B
#define	DMA1	0x53

#endif
