
#ifndef	_HTC_H_
#warning Header file msc1210.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Texas Instruments microcontrollers
	MSC1210Y2
	MSC1210Y3
	MSC1210Y4
	MSC1210Y5
 */

#ifndef	__MSC1210_H

#define	__MSC1210_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL0	@ 0x82;
static volatile unsigned char DPH0	@ 0x83;
// 16 bit definition
// Alternate definition
static volatile unsigned char DPL1	@ 0x84;
static volatile unsigned char DPH1	@ 0x85;
// 16 bit definition
static          unsigned char DPS	@ 0x86;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static          unsigned char CKCON	@ 0x8E;
static		unsigned char MWS	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char EXIF	@ 0x91;
static		unsigned char MPAGE	@ 0x92;
static		unsigned char CADDR	@ 0x93;
static volatile unsigned char CDATA	@ 0x94;
static volatile unsigned char MCON	@ 0x95;
static volatile unsigned char SCON0	@ 0x98;
static volatile unsigned char SBUF0	@ 0x99;
static		unsigned char SPICON	@ 0x9A;
static volatile unsigned char SPIDATA	@ 0x9B;
static volatile unsigned char SPIRCON	@ 0x9C;
static volatile unsigned char SPITCON	@ 0x9D;
static volatile unsigned char SPISTART	@ 0x9E;
static volatile unsigned char SPIEND	@ 0x9F;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char PWMCON	@ 0xA1;
static		unsigned char PWMLOW	@ 0xA2;
static		unsigned char PWMHI	@ 0xA3;
static volatile unsigned char PAI	@ 0xA5;
static volatile unsigned char AIE	@ 0xA6;
static volatile unsigned char AISTAT	@ 0xA7;
static          unsigned char IE	@ 0xA8;
static volatile unsigned char BPCON	@ 0xA9;
static		unsigned char BPL	@ 0xAA;
static		unsigned char BPH	@ 0xAB;
static		unsigned char P0DDRL	@ 0xAC;
static		unsigned char P0DDRH	@ 0xAD;
static		unsigned char P1DDRL	@ 0xAE;
static		unsigned char P1DDRH	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char P2DDRL	@ 0xB1;
static		unsigned char P2DDRH	@ 0xB2;
static		unsigned char P3DDRL	@ 0xB3;
static		unsigned char P3DDRH	@ 0xB4;
static          unsigned char IP	@ 0xB8;
static volatile unsigned char SCON1	@ 0xC0;
static volatile unsigned char SBUF1	@ 0xC1;
static		unsigned char EWU	@ 0xC6;
static volatile unsigned char T2CON	@ 0xC8;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char OCL	@ 0xD1;
static		unsigned char OCM	@ 0xD2;
static		unsigned char OCH	@ 0xD3;
static		unsigned char GCL	@ 0xD4;
static		unsigned char GCM	@ 0xD5;
static		unsigned char GCH	@ 0xD6;
static		unsigned char ADMUX	@ 0xD7;
static volatile unsigned char EICON	@ 0xD8;
static volatile unsigned char ADRESL	@ 0xD9;
static volatile unsigned char ADRESM	@ 0xDA;
static volatile unsigned char ADRESH	@ 0xDB;
static volatile unsigned char ADCON0	@ 0xDC;
static		unsigned char ADCON1	@ 0xDD;
static		unsigned char ADCON2	@ 0xDE;
static		unsigned char ADCON3	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char SSCON	@ 0xE1;
static volatile unsigned char SUMR0	@ 0xE2;
static volatile unsigned char SUMR1	@ 0xE3;
static volatile unsigned char SUMR2	@ 0xE4;
static volatile unsigned char SUMR3	@ 0xE5;
static		unsigned char ODAC	@ 0xE6;
static		unsigned char LVDCON	@ 0xE7;
static          unsigned char EIE	@ 0xE8;
static		unsigned char HWPC0	@ 0xE9;
static		unsigned char HWPC1	@ 0xEA;
static volatile unsigned char FMCON	@ 0xEE;
static		unsigned char FTCON	@ 0xEF;
static volatile unsigned char B		@ 0xF0;
static		unsigned char PDCON	@ 0xF1;
static		unsigned char PASEL	@ 0xF2;
static		unsigned char ACLK	@ 0xF6;
static volatile unsigned char SRST	@ 0xF7;
static          unsigned char EIP	@ 0xF8;
static volatile unsigned char SECINT	@ 0xF9;
static volatile unsigned char MSINT	@ 0xFA;
static volatile unsigned char USEC	@ 0xFB;
static volatile unsigned char MSECL	@ 0xFC;
static volatile unsigned char MSECH	@ 0xFD;
static volatile unsigned char HMSEC	@ 0xFE;
static volatile unsigned char WDTCON	@ 0xFF;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static          SFR_BITS	 DPS_BITS	@ 0x86;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static          SFR_BITS	 CKCON_BITS	@ 0x8E;
static		SFR_BITS	 MWS_BITS	@ 0x8F;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static volatile SFR_BITS	 EXIF_BITS	@ 0x91;
static volatile SFR_BITS	 MCON_BITS	@ 0x95;
static volatile SFR_BITS	 SCON0_BITS	@ 0x98;
static		SFR_BITS	 SPICON_BITS	@ 0x9A;
static volatile SFR_BITS	 SPIRCON_BITS	@ 0x9C;
static volatile SFR_BITS	 SPITCON_BITS	@ 0x9D;
static volatile SFR_BITS	 SPISTART_BITS	@ 0x9E;
static volatile SFR_BITS	 SPIEND_BITS	@ 0x9F;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static		SFR_BITS	 PWMCON_BITS	@ 0xA1;
static volatile SFR_BITS	 PAI_BITS	@ 0xA5;
static volatile SFR_BITS	 AIE_BITS	@ 0xA6;
static volatile SFR_BITS	 AISTAT_BITS	@ 0xA7;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static volatile SFR_BITS	 BPCON_BITS	@ 0xA9;
static		SFR_BITS	 P0DDRL_BITS	@ 0xAC;
static		SFR_BITS	 P0DDRH_BITS	@ 0xAD;
static		SFR_BITS	 P1DDRL_BITS	@ 0xAE;
static		SFR_BITS	 P1DDRH_BITS	@ 0xAF;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static		SFR_BITS	 P2DDRL_BITS	@ 0xB1;
static		SFR_BITS	 P2DDRH_BITS	@ 0xB2;
static		SFR_BITS	 P3DDRL_BITS	@ 0xB3;
static		SFR_BITS	 P3DDRH_BITS	@ 0xB4;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 SCON1_BITS	@ 0xC0;
static		SFR_BITS	 EWU_BITS	@ 0xC6;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static		SFR_BITS	 ADMUX_BITS	@ 0xD7;
static volatile SFR_BITS	 EICON_BITS	@ 0xD8;
static volatile SFR_BITS	 ADCON0_BITS	@ 0xDC;
static		SFR_BITS	 ADCON1_BITS	@ 0xDD;
static		SFR_BITS	 ADCON2_BITS	@ 0xDE;
static		SFR_BITS	 ADCON3_BITS	@ 0xDF;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static volatile SFR_BITS	 SSCON_BITS	@ 0xE1;
static		SFR_BITS	 LVDCON_BITS	@ 0xE7;
static          SFR_BITS	 EIE_BITS	@ 0xE8;
static volatile SFR_BITS	 FMCON_BITS	@ 0xEE;
static		SFR_BITS	 FTCON_BITS	@ 0xEF;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static		SFR_BITS	 PDCON_BITS	@ 0xF1;
static		SFR_BITS	 PASEL_BITS	@ 0xF2;
static volatile SFR_BITS	 SRST_BITS	@ 0xF7;
static          SFR_BITS	 EIP_BITS	@ 0xF8;
static volatile SFR_BITS	 SECINT_BITS	@ 0xF9;
static volatile SFR_BITS	 MSINT_BITS	@ 0xFA;
static volatile SFR_BITS	 WDTCON_BITS	@ 0xFF;


// Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// alternate functions
static volatile bit	T2	@ 0x90;
static volatile bit	T2EX	@ 0x91;
static volatile bit	RXD1	@ 0x92;
static volatile bit	TXD1	@ 0x93;
static volatile bit	INT2	@ 0x94;
static volatile bit	INT3	@ 0x95;
static volatile bit	INT4	@ 0x96;
static volatile bit	INT5	@ 0x97;
static volatile bit	SS	@ 0x94;
static volatile bit	MOSI	@ 0x95;
static volatile bit	MISO	@ 0x96;
static volatile bit	SCK	@ 0x97;

//Serial Control Register 0 SCON0
static volatile bit	RI_0	@ 0x98;
static volatile bit	TI_0	@ 0x99;
static volatile bit	RB8_0	@ 0x9A;
static 		bit	TB8_0	@ 0x9B;
static 		bit	REN_0	@ 0x9C;
static 		bit	SM2_0	@ 0x9D;
static 		bit	SM1_0	@ 0x9E;
static 		bit	SM0_0	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES0	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	ES1	@ 0xAE;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD0	@ 0xB0;
static volatile bit	TXD0	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS0	@ 0xBC;
static 		bit	PT2	@ 0xBD;
static 		bit	PS1	@ 0xBE;

//Serial Control 1 SCON1
static volatile	bit	RI_1	@ 0xC0;
static volatile	bit	TI_1	@ 0xC1;
static volatile	bit	RB8_1	@ 0xC2;
static 		bit	TB8_1	@ 0xC3;
static 		bit	REN_1	@ 0xC4;
static 		bit	SM2_1	@ 0xC5;
static 		bit	SM1_1	@ 0xC6;
static		bit	SM0_1	@ 0xC7;

//Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// Enable Interrupt Control EICON
static volatile bit	WDTI	@ 0xDB;
static volatile bit	AI	@ 0xDC;
static 		bit	EAI	@ 0xDD;
static 		bit	SMOD1	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Extended Interrupt Enable EIE
static		bit	EX2	@ 0xE8;
static		bit	EX3	@ 0xE9;
static		bit	EX4	@ 0xEA;
static		bit	EX5	@ 0xEB;
static		bit	EWDI	@ 0xEC;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

//Extended Interrupt Priority EIP
static		bit	PX2	@ 0xF8;
static		bit	PX3	@ 0xF9;
static		bit	PX4	@ 0xFA;
static		bit	PX5	@ 0xFB;
static		bit	PWDI	@ 0xFC;

//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	AUX	0x33
#define	EXTINT2	0x43
#define	EXTINT3	0x4B
#define	EXTINT4	0x53
#define	EXTINT5	0x5B

#endif
