
#ifndef	_HTC_H_
#warning Header file mtv412m.h included directly. Use #include <htc.h> instead.
#endif

/*header file for the Myson microcontrollers
	MTV412M
 */

#ifndef	__MTV412M_H

#define	__MTV412M_H


typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char	P0	@ 0x80;
static volatile unsigned char	SP	@ 0x81;
static volatile unsigned char	DPL	@ 0x82;
static volatile unsigned char	DPH	@ 0x83;
// 16 bit definition
static 		unsigned char	PCON	@ 0x87;
static volatile	unsigned char	TCON	@ 0x88;
static 		unsigned char	TMOD	@ 0x89;
static volatile unsigned char	TL0	@ 0x8A;
static volatile unsigned char	TL1	@ 0x8B;
static volatile unsigned char	TH0	@ 0x8C;
static volatile unsigned char	TH1	@ 0x8D;
static volatile unsigned char	P1	@ 0x90;
static 		unsigned char	SCON	@ 0x98;
static volatile unsigned char	SBUF	@ 0x99;
static volatile unsigned char	P2	@ 0xA0;
static 		unsigned char	IE	@ 0xA8;
static volatile unsigned char	P3	@ 0xB0;
static 		unsigned char	IP	@ 0xB8;
static volatile unsigned char	PSW	@ 0xD0;
static volatile unsigned char	ACC	@ 0xE0;
static volatile unsigned char	B	@ 0xF0;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static 		SFR_BITS	PCON_BITS	@ 0x87;
static volatile	SFR_BITS	TCON_BITS	@ 0x88;
static 		SFR_BITS	TMOD_BITS	@ 0x89;
static volatile SFR_BITS	P1_BITS		@ 0x90;
static 		SFR_BITS	SCON_BITS	@ 0x98;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static 		SFR_BITS	IE_BITS		@ 0xA8;
static volatile SFR_BITS	P3_BITS		@ 0xB0;
static 		SFR_BITS	IP_BITS		@ 0xB8;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static volatile SFR_BITS	B_BITS		@ 0xF0;

// XFRs
static volatile xdata	unsigned char IICCTR	@ 0xF00;
static volatile xdata	unsigned char IICSTUS	@ 0xF01;
static volatile xdata	unsigned char INTFLG0	@ 0xF03;
static		xdata	unsigned char INTEN0	@ 0xF04;
static volatile xdata	unsigned char MBUF	@ 0xF05;
static		xdata	unsigned char DDCCTR	@ 0xF06;
static		xdata	unsigned char SLVAADR	@ 0xF07;
static volatile xdata	unsigned char RCBBUF	@ 0xF08;
// alternate purpose
static volatile xdata	unsigned char TXBBUF	@ 0xF08;
static		xdata	unsigned char SLVBADR	@ 0xF09;
static		xdata	unsigned char ISPSLV	@ 0xF0B;
static		xdata	unsigned char ISPEN	@ 0xF0C;
static		xdata	unsigned char ISPCMP1	@ 0xF0D;
static		xdata	unsigned char ISPCMP2	@ 0xF0E;
static		xdata	unsigned char ISPCMP3	@ 0xF0F;
static		xdata	unsigned char ADC	@ 0xF10;
static		xdata	unsigned char WDT	@ 0xF18;
static		xdata	unsigned char DA0	@ 0xF20;
static		xdata	unsigned char DA1	@ 0xF21;
static		xdata	unsigned char DA2	@ 0xF22;
static		xdata	unsigned char DA3	@ 0xF23;
static		xdata	unsigned char DA4	@ 0xF24;
static		xdata	unsigned char DA5	@ 0xF25;
static		xdata	unsigned char DA6	@ 0xF26;
static		xdata	unsigned char DA7	@ 0xF27;
static		xdata	unsigned char DA8	@ 0xF28;
static		xdata	unsigned char DA9	@ 0xF29;
static		xdata	unsigned char DA10	@ 0xF2A;
static		xdata	unsigned char DA11	@ 0xF2B;
static		xdata	unsigned char DA12	@ 0xF2C;
static		xdata	unsigned char DA13	@ 0xF2D;
static volatile xdata	unsigned char PORT50	@ 0xF30;
static volatile xdata	unsigned char PORT51	@ 0xF31;
static volatile xdata	unsigned char PORT52	@ 0xF32;
static volatile xdata	unsigned char PORT53	@ 0xF33;
static volatile xdata	unsigned char PORT54	@ 0xF34;
static volatile xdata	unsigned char PORT55	@ 0xF35;
static volatile xdata	unsigned char PORT56	@ 0xF36;
static volatile xdata	unsigned char PORT60	@ 0xF38;
static volatile xdata	unsigned char PORT61	@ 0xF39;
static volatile xdata	unsigned char PORT62	@ 0xF3A;
static volatile xdata	unsigned char PORT63	@ 0xF3B;
static volatile xdata	unsigned char PORT64	@ 0xF3C;
static volatile xdata	unsigned char PORT65	@ 0xF3D;
static volatile xdata	unsigned char PORT66	@ 0xF3E;
static volatile xdata	unsigned char PORT67	@ 0xF3F;
static volatile xdata	unsigned char HVCTR0	@ 0xF40;
// alternate purpose
static volatile xdata	unsigned char HVSTUS	@ 0xF40;
static volatile xdata	unsigned char HCNTH	@ 0xF41;
static volatile xdata	unsigned char HCNTL	@ 0xF42;
static volatile xdata	unsigned char HVCTR3	@ 0xF43;
// alternate purpose
static volatile xdata	unsigned char VCNTH	@ 0xF43;
static volatile xdata	unsigned char HVCTR4	@ 0xF44;
// alternate purpose
static volatile xdata	unsigned char VCNTL	@ 0xF44;
static volatile xdata	unsigned char INTFLG1	@ 0xF48;
static		xdata	unsigned char INTEN1	@ 0xF49;
static		xdata	unsigned char PADMOD0	@ 0xF50;
static		xdata	unsigned char PADMOD1	@ 0xF51;
static		xdata	unsigned char PADMOD2	@ 0xF52;
static		xdata	unsigned char PADMOD3	@ 0xF53;
static		xdata	unsigned char PADMOD4	@ 0xF54;
static		xdata	unsigned char PADMOD5	@ 0xF55;
static		xdata	unsigned char OPTION	@ 0xF56;
static		xdata	unsigned char PORT40	@ 0xF58;
static		xdata	unsigned char PORT41	@ 0xF59;
static		xdata	unsigned char PORT42	@ 0xF5A;
static		xdata	unsigned char PADMOD6	@ 0xF5E;
static		xdata	unsigned char PADMOD7	@ 0xF5F;
static volatile xdata	unsigned char PORT70	@ 0xF70;
static volatile xdata	unsigned char PORT71	@ 0xF71;
static volatile xdata	unsigned char PORT72	@ 0xF72;
static volatile xdata	unsigned char PORT73	@ 0xF73;
static volatile xdata	unsigned char PORT74	@ 0xF74;
static volatile xdata	unsigned char PORT75	@ 0xF75;
static volatile xdata	unsigned char PORT76	@ 0xF76;
static volatile xdata	unsigned char PORT77	@ 0xF77;
static		xdata	unsigned char EPADRH	@ 0xFF1;
static		xdata	unsigned char EPADRL	@ 0xFF2;
static volatile xdata	unsigned char EPDATA	@ 0xFF3;
static volatile xdata	unsigned char INTFLG2	@ 0xFF4;
static		xdata	unsigned char INTEN2	@ 0xFF5;


/*bit addressable locations*/
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static		bit	SM0	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


/*	Interrupt vectors */
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23

#endif	
