
#ifndef	_HTC_H_
#warning Header file nrf24e1.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Nordic microcontrollers
	NRF24E1
	NRF24E2
 */

#ifndef	__NRF24E1_H

#define	__NRF24E1_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16-Bit definition
static volatile unsigned int  DPTR	@ 0x82;
static volatile unsigned char DPL1	@ 0x84;
static volatile unsigned char DPH1	@ 0x85;
// 16-Bit definition
static volatile unsigned int  DPTR1	@ 0x84;
static          unsigned char DPS	@ 0x86;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static          unsigned char CKCON	@ 0x8E;
static volatile unsigned char SPC_FNC	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char EXIF	@ 0x91;
static		unsigned char MPAGE	@ 0x92;
static		unsigned char P0_DIR	@ 0x94;
static		unsigned char P0_ALT	@ 0x95;
static		unsigned char P1_DIR	@ 0x96;
static		unsigned char P1_ALT	@ 0x97;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static volatile unsigned char RADIO	@ 0xA0;
static		unsigned char ADCCON	@ 0xA1;
static volatile unsigned char ADCDATAH	@ 0xA2;
static volatile unsigned char ADCDATAL	@ 0xA3;
static		unsigned char ADCSTATIC	@ 0xA4;
static          unsigned char IE	@ 0xA8;
static		unsigned char PWMCON	@ 0xA9;
static		unsigned char PWMDUTY	@ 0xAA;
static volatile unsigned char REGX_MSB	@ 0xAB;
static volatile unsigned char REGX_LSB	@ 0xAC;
static volatile unsigned char REGX_CTRL	@ 0xAD;
static volatile unsigned char RSTREAS	@ 0xB1;
static volatile unsigned char SPI_DATA	@ 0xB2;
static		unsigned char SPI_CTRL	@ 0xB3;
static		unsigned char SPICLK	@ 0xB4;
static		unsigned char TICK_DV	@ 0xB5;
static volatile unsigned char CK_CTRL	@ 0xB6;
static volatile unsigned char TEST_MODE	@ 0xB7;
static          unsigned char IP	@ 0xB8;
static volatile unsigned char T1_1V2	@ 0xBC;
static volatile unsigned char T2_1V2	@ 0xBD;
static volatile unsigned char DEV_OFFSET	@ 0xBE;
static volatile unsigned char T2CON	@ 0xC8;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char EICON	@ 0xD8;
static volatile unsigned char ACC	@ 0xE0;
static          unsigned char EIE	@ 0xE8;
static volatile unsigned char B		@ 0xF0;
static          unsigned char EIP	@ 0xF8;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static          SFR_BITS	 DPS_BITS	@ 0x86;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static          SFR_BITS	 CKCON_BITS	@ 0x8E;
static volatile SFR_BITS	 SPC_FNC_BITS	@ 0x8F;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static volatile SFR_BITS	 EXIF_BITS	@ 0x91;
static		SFR_BITS	 P0_DIR_BITS	@ 0x94;
static		SFR_BITS	 P0_ALT_BITS	@ 0x95;
static		SFR_BITS	 P1_DIR_BITS	@ 0x96;
static		SFR_BITS	 P1_ALT_BITS	@ 0x97;
static volatile SFR_BITS	 SCON_BITS	@ 0x98;
static volatile SFR_BITS	 RADIO_BITS	@ 0xA0;
static		SFR_BITS	 ADCCON_BITS	@ 0xA1;
static		SFR_BITS	 ADCSTATIC_BITS	@ 0xA4;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static		SFR_BITS	 PWM_CON_BITS	@ 0xA9;
static volatile SFR_BITS	 REGX_CTRL_BITS	@ 0xAD;
static volatile SFR_BITS	 RSTREAS_BITS	@ 0xB1;
static		SFR_BITS	 SPI_CTRL_BITS	@ 0xB3;
static		SFR_BITS	 SPICLK_BITS	@ 0xB4;
static volatile SFR_BITS	 CK_CTRL_BITS	@ 0xB6;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static volatile SFR_BITS	 EICON_BITS	@ 0xD8;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static          SFR_BITS	 EIE_BITS	@ 0xE8;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static          SFR_BITS	 EIP_BITS	@ 0xF8;


// Bit Addressable Locations
// Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

// Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

// Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile bit	SM0	@ 0x9F;

// RADIO Port
static volatile bit	DATA	@ 0xA0;
static volatile bit	CLK1	@ 0xA1;
static volatile bit	DR1	@ 0xA2;
static volatile bit	CS	@ 0xA3;
static volatile bit	DOUT2	@ 0xA4;
static volatile bit	CLK2	@ 0xA5;
static volatile bit	DR2	@ 0xA6;
static volatile bit	PWR_UP	@ 0xA7;
// Alternate defintion
static volatile bit	CE	@ 0xA6;

// Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	EA	@ 0xAF;

// Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
static 		bit	PT2	@ 0xBD;

// Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

// Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// Extended Interrupt Control EICON
static volatile bit	WDTI	@ 0xDB;

// Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// Extended Interrupt Enable EIE
static		bit	EX2	@ 0xE8;
static		bit	EX3	@ 0xE9;
static		bit	EX4	@ 0xEA;
static		bit	EX5	@ 0xEB;
static		bit	EWDI	@ 0xEC;

// B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// Extended Interrupt Priority EIP
static		bit	PX2	@ 0xF8;
static		bit	PX3	@ 0xF9;
static		bit	PX4	@ 0xFA;
static		bit	PX5	@ 0xFB;
static		bit	PWDI	@ 0xFC;


// Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	ADC	0x43
#define	SPI	0x4B
#define	RTC	0x63

#endif
