
#ifndef	_HTC_H_
#warning Header file p83cx34.h included directly. Use #include <htc.h> instead.
#endif

/*header file for the Pillips Microcontrollers
	P83C434
	P83C834
8-Bit Microcontrollers with LCD drivers
 */

#ifndef	__P83CX34_H

#define	__P83CX34_H
	
typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char		P0	@ 0x80;
static volatile unsigned char		SP	@ 0x81;
static volatile unsigned char		DPL	@ 0x82;
static volatile unsigned char		DPH	@ 0x83;
// 16 bit definition
static 		unsigned char		PCON	@ 0x87;
static volatile	unsigned char		TCON	@ 0x88;
static 		unsigned char		TMOD	@ 0x89;
static volatile unsigned char		TL0	@ 0x8A;
static volatile unsigned char		TL1	@ 0x8B;
static volatile unsigned char		TH0	@ 0x8C;
static volatile unsigned char		TH1	@ 0x8D;
static volatile unsigned char		IG	@ 0x97;
static volatile unsigned char		MCON	@ 0x98;
static		unsigned char		LCD0	@ 0x9A;
static		unsigned char		LCD1	@ 0x9B;
static		unsigned char		LCD2	@ 0x9C;
static		unsigned char		LCD3	@ 0x9D;
static		unsigned char		LCD4	@ 0x9E;
static		unsigned char		LCD5	@ 0x9F;
static volatile unsigned char		P2	@ 0xA0;
static 		unsigned char		IE	@ 0xA8;
static		unsigned char		OSCON	@ 0xB7;
static 		unsigned char		IP	@ 0xB8;
static		unsigned char		LCDCON	@ 0xB9;
static		unsigned char		LCD6	@ 0xBA;
static		unsigned char		LCD7	@ 0xBB;
static		unsigned char		LCD8	@ 0xBC;
static		unsigned char		LCD9	@ 0xBD;
static		unsigned char		LCD10	@ 0xBE;
static		unsigned char		LCD11	@ 0xBF;
static volatile unsigned char		PSW	@ 0xD0;
static volatile unsigned char		ACC	@ 0xE0;
static volatile unsigned char		B	@ 0xF0;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static 		SFR_BITS	PCON_BITS	@ 0x87;
static volatile	SFR_BITS	TCON_BITS	@ 0x88;
static 		SFR_BITS	TMOD_BITS	@ 0x89;
static volatile SFR_BITS	IG_BITS		@ 0x97;
static volatile SFR_BITS	MCON_BITS	@ 0x98;
static		SFR_BITS	LCD0_BITS	@ 0x9A;
static		SFR_BITS	LCD1_BITS	@ 0x9B;
static		SFR_BITS	LCD2_BITS	@ 0x9C;
static		SFR_BITS	LCD3_BITS	@ 0x9D;
static		SFR_BITS	LCD4_BITS	@ 0x9E;
static		SFR_BITS	LCD5_BITS	@ 0x9F;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static 		SFR_BITS	IE_BITS		@ 0xA8;
static		SFR_BITS	OSCON_BITS	@ 0xB7;
static 		SFR_BITS	IP_BITS		@ 0xB8;
static		SFR_BITS	LCDCON_BITS	@ 0xB9;
static		SFR_BITS	LCD6_BITS	@ 0xBA;
static		SFR_BITS	LCD7_BITS	@ 0xBB;
static		SFR_BITS	LCD8_BITS	@ 0xBC;
static		SFR_BITS	LCD9_BITS	@ 0xBD;
static		SFR_BITS	LCD10_BITS	@ 0xBE;
static		SFR_BITS	LCD11_BITS	@ 0xBF;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static volatile SFR_BITS	B_BITS		@ 0xF0;

/*bit addressable locations*/
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Miscellaneous Control Register MCON
static		bit	ILVL0	@ 0x98;
static		bit	ILVL1	@ 0x99;
static		bit	ILVL2	@ 0x9A;
static		bit	ILVL3	@ 0x9B;
static volatile	bit	SECINT	@ 0x9C;
static		bit	RUN32	@ 0x9D;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	EA	@ 0xAF;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


/*	Interrupt vectors */
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B

#endif	
