
#ifndef	_HTC_H_
#warning Header file p87cl888.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Philps microcontroller
	P87CL888
 */

#ifndef	__P87CL888_H

#define	__P87CL888_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16-Bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static          unsigned char P0CFGA	@ 0x8E;
static          unsigned char P0CFGB	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static          unsigned char P1CFGA	@ 0x9E;
static          unsigned char P1CFGB	@ 0x9F;
static volatile unsigned char WDCON	@ 0xA5;
static		unsigned char WDTIM	@ 0xA6;
static          unsigned char IEN0	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char SYSCON	@ 0xB4;
static          unsigned char IP0	@ 0xB8;
static          unsigned char P3CFGA	@ 0xBE;
static          unsigned char P3CFGB	@ 0xBF;
static volatile unsigned char IRQ1	@ 0xC0;
static volatile unsigned char P4	@ 0xC1;
static volatile unsigned char ADCON0	@ 0xC4;
static		unsigned char ADCON1	@ 0xC5;
static volatile unsigned char ADCDAT	@ 0xC6;
static		unsigned char ADCPS	@ 0xC7;
static volatile unsigned char T2CON	@ 0xC8;
static          unsigned char T2MOD	@ 0xC9;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static		unsigned char P4CFGA	@ 0xCE;
static		unsigned char P4CFGB	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char MBUF	@ 0xD1;
static volatile unsigned char MSTAT	@ 0xD2;
static		unsigned char MCON	@ 0xD3;
static		unsigned char OAL	@ 0xD4;
static		unsigned char OAH	@ 0xD5;
static volatile unsigned char ODATA	@ 0xD6;
static		unsigned char OTEST	@ 0xD7;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static          unsigned char S1ADR	@ 0xDB;
static volatile unsigned char OISYS	@ 0xDC;
static		unsigned char WKCON	@ 0xDD;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char ISE1	@ 0xE1;
static          unsigned char IEN1	@ 0xE8;
static          unsigned char IX1	@ 0xE9;
static volatile unsigned char B		@ 0xF0;
static		unsigned char IEN2	@ 0xF1;
static		unsigned char PRESC	@ 0xF3;
static		unsigned char IX3	@ 0xF4;
static volatile unsigned char IRQ3	@ 0xF5;
static		unsigned char IEN3	@ 0xF6;
static		unsigned char ISE3	@ 0xF7;
static          unsigned char IP1	@ 0xF8;
static		unsigned char IP2	@ 0xF9;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static          SFR_BITS	 P0CFGA_BITS	@ 0x8E;
static          SFR_BITS	 P0CFGB_BITS	@ 0x8F;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static          SFR_BITS	 P1CFGA_BITS	@ 0x9E;
static          SFR_BITS	 P1CFGB_BITS	@ 0x9F;
static volatile SFR_BITS	 WDCON_BITS	@ 0xA5;
static          SFR_BITS	 IEN0_BITS	@ 0xA8;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static		SFR_BITS	 SYSCON_BITS	@ 0xB4;
static          SFR_BITS	 IP0_BITS	@ 0xB8;
static          SFR_BITS	 P3CFGA_BITS	@ 0xBE;
static          SFR_BITS	 P3CFGB_BITS	@ 0xBF;
static volatile SFR_BITS	 IRQ1_BITS	@ 0xC0;
static volatile SFR_BITS	 P4_BITS	@ 0xC1;
static volatile SFR_BITS	 ADCON0_BITS	@ 0xC4;
static		SFR_BITS	 ADCON1_BITS	@ 0xC5;
static		SFR_BITS	 ADCPS_BITS	@ 0xC7;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static          SFR_BITS	 T2MOD_BITS	@ 0xC9;
static		SFR_BITS	 P4CFGA_BITS	@ 0xCE;
static		SFR_BITS	 P4CFGB_BITS	@ 0xCF;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static volatile SFR_BITS	 MSTAT_BITS	@ 0xD2;
static		SFR_BITS	 MCON_BITS	@ 0xD3;
static		SFR_BITS	 OTEST_BITS	@ 0xD7;
static volatile SFR_BITS	 S1CON_BITS	@ 0xD8;
static volatile SFR_BITS	 S1STA_BITS	@ 0xD9;
static volatile SFR_BITS	 S1DAT_BITS	@ 0xDA;
static          SFR_BITS	 S1ADR_BITS	@ 0xDB;
static volatile SFR_BITS	 OISYS_BITS	@ 0xDC;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static		SFR_BITS	 ISE1_BITS	@ 0xE1;
static          SFR_BITS	 IEN1_BITS	@ 0xE8;
static          SFR_BITS	 IX1_BITS	@ 0xE9;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static		SFR_BITS	 IEN2_BITS	@ 0xF1;
static		SFR_BITS	 PRESC_BITS	@ 0xF3;
static		SFR_BITS	 IX3_BITS	@ 0xF4;
static volatile SFR_BITS	 IRQ3_BITS	@ 0xF5;
static		SFR_BITS	 IEN3_BITS	@ 0xF6;
static		SFR_BITS	 ISE3_BITS	@ 0xF7;
static          SFR_BITS	 IP1_BITS	@ 0xF8;
static		SFR_BITS	 IP2_BITS	@ 0xF9;


// Bit Addressable Locations
// Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

// Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

// Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES1 	@ 0xAD;
static 		bit 	ET2 	@ 0xAE;
static 		bit 	EA	@ 0xAF;

// Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;

// Interrupt Priority 0 IP0
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PTO 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS1 	@ 0xBD;
static 		bit 	PT2 	@ 0xBE;

// Interrupt Request Register IRQ1
static volatile bit	IQ2	@ 0xC0;
static volatile bit	IQ3	@ 0xC1;
static volatile bit	IQ4	@ 0xC2;
static volatile bit	IQ5	@ 0xC3;
static volatile bit	IQ6	@ 0xC4;
static volatile bit	IQ7	@ 0xC5;
static volatile bit	IQ8	@ 0xC6;
static volatile bit	IQ9	@ 0xC7;

// Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

// Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

// Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// Interrupt Enable 1 IEN1
static 		bit 	EX2	@ 0xE8;
static 		bit 	EX3	@ 0xE9;
static 		bit 	EX4	@ 0xEA;
static 		bit 	EX5	@ 0xEB;
static 		bit 	EX6	@ 0xEC;
static 		bit 	EX7	@ 0xED;
static 		bit 	EX8	@ 0xEE;
static 		bit 	EX9	@ 0xEF;

// B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// Interrupt Priority 1 IP1
static 		bit	PX2	@ 0xF8;
static 		bit	PX3	@ 0xF9;
static 		bit 	PX4	@ 0xFA;
static 		bit 	PX5	@ 0xFB;
static 		bit 	PX6	@ 0xFC;
static 		bit 	PX7	@ 0xFD;
static 		bit 	PX8	@ 0xFE;
static 		bit 	PX9	@ 0xFF;


// Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	I2C	0x2B
#define	TIMER2	0x33
#define	EXTINT2	0x3B
#define	EXTINT3	0x43
#define	EXTINT4	0x4B
#define	EXTINT5	0x53
#define	EXTINT6	0x5B
#define	EXTINT7	0x63
#define	EXTINT8	0x6B
#define	EXTINT9	0x73
#define	MSKTX	0x83
#define	MSKRX	0x8B
#define	LVDINT	0x93
#define	KEYINT	0xA3
#define	A2D	0xAB
#define	WDTINT	0xB3

#endif
