
#ifndef	_HTC_H_
#warning Header file p89c669.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the Philips microcontroller
	P89C669
 */

#ifndef	__P89C669_H

#define	__P89C669_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16-Bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static		unsigned char AUXR	@ 0x8E;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char I2CON	@ 0x91;
static volatile unsigned char I2STA	@ 0x92;
static volatile unsigned char I2DAT	@ 0x93;
static volatile unsigned char I2ADR	@ 0x94;
static		unsigned char I2CLL	@ 0x95;
static		unsigned char I2CLH	@ 0x96;
static volatile unsigned char S0CON	@ 0x98;
static volatile unsigned char S0BUF	@ 0x99;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char AUXR1	@ 0xA2;
static volatile unsigned char WDTRST	@ 0xA6;
static          unsigned char IEN0	@ 0xA8;
static		unsigned char S0ADDR	@ 0xA9;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IP0H	@ 0xB7;
static          unsigned char IP0	@ 0xB8;
static		unsigned char S0ADEN	@ 0xB9;
static volatile unsigned char T2CON	@ 0xC8;
static          unsigned char T2MOD	@ 0xC9;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char CCON	@ 0xD8;
static          unsigned char CMOD	@ 0xD9;
static          unsigned char CCAPM0	@ 0xDA;
static          unsigned char CCAPM1	@ 0xDB;
static          unsigned char CCAPM2	@ 0xDC;
static          unsigned char CCAPM3	@ 0xDD;
static          unsigned char CCAPM4	@ 0xDE;
static volatile unsigned char ACC	@ 0xE0;
static          unsigned char IEN1	@ 0xE8;
static volatile unsigned char CL	@ 0xE9;
static volatile unsigned char CCAP0L	@ 0xEA;
static volatile unsigned char CCAP1L	@ 0xEB;
static volatile unsigned char CCAP2L	@ 0xEC;
static volatile unsigned char CCAP3L	@ 0xED;
static volatile unsigned char CCAP4L	@ 0xEE;
static volatile unsigned char B		@ 0xF0;
static		unsigned char IP1H	@ 0xF7;
static          unsigned char IP1	@ 0xF8;
static volatile unsigned char CH	@ 0xF9;
static volatile unsigned char CCAP0H	@ 0xFA;
static volatile unsigned char CCAP1H	@ 0xFB;
static volatile unsigned char CCAP2H	@ 0xFC;
static volatile unsigned char CCAP3H	@ 0xFD;
static volatile unsigned char CCAP4H	@ 0xFE;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static		SFR_BITS	 AUXR_BITS	@ 0x8E;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static volatile SFR_BITS	 I2CON_BITS	@ 0x91;
static volatile SFR_BITS	 I2STA_BITS	@ 0x92;
static volatile SFR_BITS	 I2DAT_BITS	@ 0x93;
static volatile SFR_BITS	 S0CON_BITS	@ 0x98;
static volatile SFR_BITS	 S0BUF_BITS	@ 0x99;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static		SFR_BITS	 AUXR1_BITS	@ 0xA2;
static volatile SFR_BITS	 WDTRST_BITS	@ 0xA6;
static          SFR_BITS	 IEN0_BITS	@ 0xA8;
static		SFR_BITS	 S0ADDR_BITS	@ 0xA9;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static		SFR_BITS	 IP0H_BITS	@ 0xB7;
static          SFR_BITS	 IP0_BITS	@ 0xB8;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static          SFR_BITS	 T2MOD_BITS	@ 0xC9;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static volatile SFR_BITS	 CCON_BITS	@ 0xD8;
static          SFR_BITS	 CMOD_BITS	@ 0xD9;
static          SFR_BITS	 CCAPM0_BITS	@ 0xDA;
static          SFR_BITS	 CCAPM1_BITS	@ 0xDB;
static          SFR_BITS	 CCAPM2_BITS	@ 0xDC;
static          SFR_BITS	 CCAPM3_BITS	@ 0xDD;
static          SFR_BITS	 CCAPM4_BITS	@ 0xDE;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static          SFR_BITS	 IEN1_BITS	@ 0xE8;
static volatile SFR_BITS	 CL_BITS	@ 0xE9;
static volatile SFR_BITS	 CCAP0L_BITS	@ 0xEA;
static volatile SFR_BITS	 CCAP1L_BITS	@ 0xEB;
static volatile SFR_BITS	 CCAP2L_BITS	@ 0xEC;
static volatile SFR_BITS	 CCAP3L_BITS	@ 0xED;
static volatile SFR_BITS	 CCAP4L_BITS	@ 0xEE;
static volatile SFR_BITS	 B_BITS		@ 0xF0;
static		SFR_BITS	 IP1H_BITS	@ 0xF7;
static          SFR_BITS	 IP1_BITS	@ 0xF8;
static volatile SFR_BITS	 CH_BITS	@ 0xF9;
static volatile SFR_BITS	 CCAP0H_BITS	@ 0xFA;
static volatile SFR_BITS	 CCAP1H_BITS	@ 0xFB;
static volatile SFR_BITS	 CCAP2H_BITS	@ 0xFC;
static volatile SFR_BITS	 CCAP3H_BITS	@ 0xFD;
static volatile SFR_BITS	 CCAP4H_BITS	@ 0xFE;

/* A defintion for the escape sequence required to access
 * the MX's additional SFRs. */
#define MXE() asm("db 0xA5")
/* SFRs accessed via the MX escape sequence - use MXE() */
static volatile unsigned char S1CON	@ 0x80;
static volatile unsigned char S1BUF	@ 0x81;
static		unsigned char S1ADDR	@ 0x82;
static		unsigned char S1ADEN	@ 0x83;
static volatile unsigned char S1STAT	@ 0x84;
static volatile unsigned char BRGCON	@ 0x85;
static		unsigned char BRGR0	@ 0x86;
static		unsigned char BRGR1	@ 0x87;
static volatile unsigned char S0STAT	@ 0x8C;
static		unsigned char WDCON	@ 0x8F;
static volatile unsigned char SPE	@ 0xFB;
static volatile unsigned char EPL	@ 0xFC;
static volatile unsigned char EPM	@ 0xFD;
static volatile unsigned char EPH	@ 0xFE;
static volatile unsigned char MXCON	@ 0xFF;
/* SFR_BITSs accessed via the MX escape sequence - use MXE() */
static volatile SFR_BITS	 S1CON_BITS	@ 0x80;
static volatile SFR_BITS	 S1STAT_BITS	@ 0x84;
static volatile SFR_BITS	 BRGCON_BITS	@ 0x85;
static volatile SFR_BITS	 S0STAT_BITS	@ 0x8C;
static		SFR_BITS	 WDCON_BITS	@ 0x8F;
static volatile SFR_BITS	 MXCON_BITS	@ 0xFF;

// Bit Addressable Locations
// Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

// Serial Control 1 S1CON
static volatile bit 	RI_1	@ 0x80;
static volatile bit 	TI_1	@ 0x81;
static volatile bit 	RB8_1 	@ 0x82;
static 		bit 	TB8_1	@ 0x83;
static 		bit 	REN_1 	@ 0x84;
static 		bit 	SM2_1 	@ 0x85;
static 		bit 	SM1_1 	@ 0x86;
static volatile bit 	SM0_1 	@ 0x87;
// alternate function
static volatile bit 	FE_1 	@ 0x87;

// Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// alternate functions
static volatile bit	T2	@ 0x90;
static volatile bit	T2EX	@ 0x91;
static volatile bit	ECI	@ 0x92;
static volatile bit	CEX0	@ 0x93;
static volatile bit	CEX1	@ 0x94;
static volatile bit	CEX2	@ 0x95;
static volatile bit	CEX3	@ 0x96;
static volatile bit	CEX4	@ 0x97;
static volatile bit	MOSI	@ 0x94;
static volatile bit	SPICLK	@ 0x95;

// Serial Control 0 S0CON
static volatile bit 	RI_0	@ 0x98;
static volatile bit 	TI_0	@ 0x99;
static volatile bit 	RB8_0 	@ 0x9A;
static 		bit 	TB8_0 	@ 0x9B;
static 		bit 	REN_0 	@ 0x9C;
static 		bit 	SM2_0 	@ 0x9D;
static 		bit 	SM1_0 	@ 0x9E;
static volatile bit 	SM0_0 	@ 0x9F;
// alternate function
static volatile bit 	FE_0 	@ 0x9F;

// Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;
static volatile bit	A16	@ 0xA0;
static volatile bit	A17	@ 0xA1;
static volatile bit	A18	@ 0xA2;
static volatile bit	A19	@ 0xA3;
static volatile bit	A20	@ 0xA4;
static volatile bit	A21	@ 0xA5;
static volatile bit	A22	@ 0xA6;

// Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES0 	@ 0xAC;
// alternate definition
static 		bit 	ES0R 	@ 0xAC;
static 		bit 	ET2 	@ 0xAD;
static 		bit 	EC 	@ 0xAE;
static 		bit 	EA	@ 0xAF;

// Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD0	@ 0xB0;
static volatile bit	TXD0	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

// Interrupt Priority 0 IP0
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PTO 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS0 	@ 0xBC;
// alternate definition
static 		bit 	PS0R 	@ 0xBC;
static 		bit 	PT2 	@ 0xBD;
static 		bit 	PPC 	@ 0xBE;

// Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

// Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// Counter Control CCON
static volatile	bit	CCF0	@ 0xD8;
static volatile	bit	CCF1	@ 0xD9;
static volatile	bit	CCF2	@ 0xDA;
static volatile	bit	CCF3	@ 0xDB;
static volatile	bit	CCF4	@ 0xDC;
static		bit	CR	@ 0xDE;
static volatile	bit	CF	@ 0xDF;

// Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// Interrupt Enable 1 IEN1
static 		bit 	ES1	@ 0xE8;
// alternate definition
static 		bit 	ES1R	@ 0xE8;
static 		bit 	ES0T	@ 0xE9;
static 		bit 	ES1T	@ 0xEA;
static 		bit 	EI2C	@ 0xEC;

// B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

// Interrupt Priority 1 IP1
static 		bit	PS1	@ 0xF8;
// alternate defintion
static 		bit	PS1R	@ 0xF8;
static 		bit	PS0T	@ 0xF9;
static 		bit 	PS1T	@ 0xFA;
static 		bit 	PI2C	@ 0xFC;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
/* serial 0 interrupt can be configured to affect 
separate RX and TX interrupts using bit S0STAT.5 */
#define	S0RX	0x23
#define	TIMER2	0x2B
#define	PCA	0x33
#define	S0TX	0x3B
#define	S1TX	0x43
//#define	I2C	0x4B This value is unconfirmed
#define	S1	0x53
/* serial 1 interrupt can be configured to affect 
separate RX and TX interrupts using bit S1STAT.5 */
#define	S1RX	0x53

#endif
