
#ifndef	_HTC_H_
#warning Header file p8xc52x.h included directly. Use #include <htc.h> instead.
#endif

/*
 *	This is a header file for the Phillips microcontrollers
	P80C528
	P83C528
	P87C528
	P83C524
	P87C524
 */

#ifndef	__P8XC52X_H

#define	__P8XC52X_H
	
typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char	P0	@ 0x80;
static volatile unsigned char	SP	@ 0x81;
static volatile unsigned char	DPL	@ 0x82;
static volatile unsigned char	DPH	@ 0x83;
// 16 bit definition
static		unsigned char	PCON	@ 0x87;
static volatile unsigned char	TCON	@ 0x88;
static		unsigned char	TMOD	@ 0x89;
static volatile unsigned char	TL0	@ 0x8A;
static volatile unsigned char	TL1	@ 0x8B;
static volatile unsigned char	TH0	@ 0x8C;
static volatile unsigned char	TH1	@ 0x8D;
static volatile unsigned char	P1	@ 0x90;
static volatile unsigned char	SCON	@ 0x98;
static volatile unsigned char	SBUF	@ 0x99;
static volatile unsigned char	P2	@ 0xA0;
static volatile unsigned char	WDCON	@ 0xA5;
static		unsigned char	IE	@ 0xA8;
static volatile unsigned char	P3	@ 0xB0;
static		unsigned char	IP	@ 0xB8;
static volatile unsigned char	T2CON	@ 0xC8;
static volatile unsigned char	RCAP2L	@ 0xCA;
static volatile unsigned char	RCAP2H	@ 0xCB;
static volatile unsigned char	TL2	@ 0xCC;
static volatile unsigned char	TH2	@ 0xCD;
static volatile unsigned char	PSW	@ 0xD0;
static volatile unsigned char	S1SCS	@ 0xD8;
static volatile unsigned char	S1BIT	@ 0xD9;
static volatile unsigned char	S1INT	@ 0xDA;
static volatile unsigned char	ACC	@ 0xE0;
static volatile unsigned char	B	@ 0xF0;
static volatile unsigned char	T3	@ 0xFF;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static		SFR_BITS	PCON_BITS	@ 0x87;
static volatile SFR_BITS	TCON_BITS	@ 0x88;
static		SFR_BITS	TMOD_BITS	@ 0x89;
static volatile SFR_BITS	P1_BITS		@ 0x90;
static volatile SFR_BITS	SCON_BITS	@ 0x98;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static volatile SFR_BITS	WDCON_BITS	@ 0xA5;
static		SFR_BITS	IE_BITS		@ 0xA8;
static volatile SFR_BITS	P3_BITS		@ 0xB0;
static		SFR_BITS	IP_BITS		@ 0xB8;
static volatile SFR_BITS	T2CON_BITS	@ 0xC8;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
static volatile SFR_BITS	S1SCS_BITS	@ 0xD8;
static volatile SFR_BITS	S1BIT_BITS	@ 0xD9;
static volatile SFR_BITS	S1INT_BITS	@ 0xDA;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static volatile SFR_BITS	B_BITS		@ 0xF0;

//Bit Adressable Locations
//Port 0
static volatile bit 	AD0	@ 0x80;
static volatile bit 	AD1	@ 0x81;
static volatile bit 	AD2	@ 0x82;
static volatile bit 	AD3	@ 0x83;
static volatile bit 	AD4	@ 0x84;
static volatile bit 	AD5	@ 0x85;
static volatile bit 	AD6	@ 0x86;
static volatile bit 	AD7	@ 0x87;

//Timer Control TCON
static volatile	bit 	IT0	@ 0x88;
static		bit 	IE0	@ 0x89;
static volatile	bit 	IT1	@ 0x8A;
static		bit 	IE1	@ 0x8B;
static volatile	bit 	TR0	@ 0x8C;
static		bit 	TF0	@ 0x8D;
static volatile bit 	TR1	@ 0x8E;
static		bit 	TF1	@ 0x8F;

//Port 1
static volatile bit 	T2	@ 0x90;
static volatile bit 	T2EX	@ 0x91;
static volatile bit 	P12	@ 0x92;
static volatile bit 	P13	@ 0x93;
static volatile bit 	P14	@ 0x94;
static volatile bit 	P15	@ 0x95;
#if defined(_P83C524)
static volatile bit 	SCL	@ 0x96;
#else
static volatile bit 	SEL	@ 0x96;
#endif
static volatile bit 	SDA	@ 0x97;

//Serial Control SCON
static volatile bit 	RI	@ 0x98;
static volatile bit 	TI	@ 0x99;
static volatile bit 	RB8	@ 0x9A;
static		bit 	TB8	@ 0x9B;
static		bit 	REN	@ 0x9C;
static		bit 	SM2	@ 0x9D;
static		bit 	SM1	@ 0x9E;
static		bit 	SM0	@ 0x9F;

//Port 2
static volatile bit 	A8	@ 0xA0;
static volatile bit 	A9	@ 0xA1;
static volatile bit 	A10	@ 0xA2;
static volatile bit 	A11	@ 0xA3;
static volatile bit 	A12	@ 0xA4;
static volatile bit 	A13	@ 0xA5;
static volatile bit 	A14	@ 0xA6;
static volatile bit 	A15	@ 0xA7;

//Interrupt Enable Register IE0
static 		bit 	EX0	@ 0xA8;
static 		bit 	ET0	@ 0xA9;
static 		bit 	EX1	@ 0xAA;
static 		bit 	ET1	@ 0xAB;
static 		bit 	ES0	@ 0xAC;
static 		bit 	ET2	@ 0xAD;
static 		bit 	ES1	@ 0xAE;
static 		bit 	EA	@ 0xAF;

//Port 3
static volatile bit 	RXD	@ 0xB0;
static volatile bit 	TXD	@ 0xB1;
static volatile bit 	INT0	@ 0xB2;
static volatile bit 	INT1	@ 0xB3;
static volatile bit 	T0	@ 0xB4;
static volatile bit 	T1	@ 0xB5;
static volatile bit 	WR	@ 0xB6;
static volatile bit 	RD	@ 0xB7;

//Interrupt Priority IP
static 		bit 	PX0	@ 0xB8;
static 		bit 	PT0	@ 0xB9;
static 		bit 	PX1	@ 0xBA;
static 		bit 	PT1	@ 0xBB;
static 		bit 	PS0	@ 0xBC;
static 		bit 	PT2	@ 0xBD;
static 		bit 	PS1	@ 0xBE;

//Timer 2 Control T2CON
static		bit 	CPRL2	@ 0xC8;
static		bit 	CT2	@ 0xC9;
static		bit 	TR2	@ 0xCA;
static		bit 	EXEN2	@ 0xCB;
static		bit 	TCLK	@ 0xCC;
static		bit 	RCLK	@ 0xCD;
static volatile bit 	EXF2	@ 0xCE;
static volatile bit 	TF2	@ 0xCF;

//Program Status Word PSW
static volatile bit 	P	@ 0xD0;
static volatile bit 	F1	@ 0xD1;
static volatile bit 	OV	@ 0xD2;
static		bit 	RS0	@ 0xD3;
static		bit 	RS1	@ 0xD4;
static volatile bit 	F0	@ 0xD5;
static volatile bit 	AC	@ 0xD6;
static volatile bit 	CY	@ 0xD7;

//Serial I2C Control S1SCS
static		bit 	ENS	@ 0xD8;
static volatile bit 	STR	@ 0xD9;
static volatile bit 	CLH	@ 0xDD;
//read mode
static volatile bit 	WBF	@ 0xDA;
static volatile bit 	RBF	@ 0xDB;
static volatile bit 	BB	@ 0xDC;
static volatile bit 	SCI	@ 0xDE;
static volatile bit 	SDI	@ 0xDF;
//Write mode
static volatile bit 	SCO	@ 0xDE;
static volatile bit 	SDO	@ 0xDF;

//Accumulator ACC
static volatile bit 	ACC0	@ 0xE0;
static volatile bit 	ACC1	@ 0xE1;
static volatile bit 	ACC2	@ 0xE2;
static volatile bit 	ACC3	@ 0xE3;
static volatile bit 	ACC4	@ 0xE4;
static volatile bit 	ACC5	@ 0xE5;
static volatile bit 	ACC6	@ 0xE6;
static volatile bit 	ACC7	@ 0xE7;

//B Register
static volatile bit 	B0	@ 0xF0;
static volatile bit 	B1	@ 0xF1;
static volatile bit 	B2	@ 0xF2;
static volatile bit 	B3	@ 0xF3;
static volatile bit 	B4	@ 0xF4;
static volatile bit 	B5	@ 0xF5;
static volatile bit 	B6	@ 0xF6;
static volatile bit 	B7	@ 0xF7;

/*	Interrupt vectors */

#define	RESET	0
#define	EXTINT0	0x03
#define	TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B
#define	S1	0x53

#endif
