
#ifndef	_HTC_H_
#warning Header file p8xc591.h included directly. Use #include <htc.h> instead.
#endif

/*
   Header file for the Phillips Microcontrollers
   P83C591
   P87C591
*/

#ifndef	__P8XC591_H

#define	__P8XC591_H
	

typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//special function registers
static volatile	unsigned char	P0	@ 0x80;
static volatile	unsigned char	SP	@ 0x81;
static volatile	unsigned char	DPL	@ 0x82;
static volatile	unsigned char	DPH	@ 0x83;
// 16 bit definition
static volatile	unsigned char	PCON	@ 0x87;
static volatile	unsigned char	TCON	@ 0x88;
static 		unsigned char	TMOD	@ 0x89;
static volatile	unsigned char	TL0	@ 0x8A;
static volatile	unsigned char	TL1	@ 0x8B;
static volatile	unsigned char	TH0	@ 0x8C;
static volatile	unsigned char	TH1	@ 0x8D;
static 		unsigned char	AUXR	@ 0x8E;
static volatile	unsigned char	P1	@ 0x90;
static		unsigned char	P1M1	@ 0x92;
static		unsigned char	P1M2	@ 0x93;
static		unsigned char	P2M1	@ 0x94;
static		unsigned char	P2M2	@ 0x95;
static volatile	unsigned char	S0CON	@ 0x98;
static volatile	unsigned char	S0BUF	@ 0x99;
static		unsigned char	P3P1	@ 0x9A;
static		unsigned char	P3P2	@ 0x9B;
static volatile	unsigned char	P2	@ 0xA0;
static volatile	unsigned char	AUXR1	@ 0xA2;
static 		unsigned char	IEN0	@ 0xA8;
static volatile	unsigned char	CML0	@ 0xA9;
static volatile	unsigned char	CML1	@ 0xAA;
static volatile	unsigned char	CML2	@ 0xAB;
static volatile	unsigned char	CTL0	@ 0xAC;
static volatile	unsigned char	CTL1	@ 0xAD;
static volatile	unsigned char	CTL2	@ 0xAE;
static volatile	unsigned char	CTL3	@ 0xAF;
static volatile	unsigned char	P3	@ 0xB0;
static 		unsigned char	IP0H 	@ 0xB7;
static 		unsigned char	IP0 	@ 0xB8;
static 		unsigned char	S0ADEN	@ 0xB9;
static volatile	unsigned char	CANSTA	@ 0xC0;
static 		unsigned char	CANADR	@ 0xC1;
static volatile	unsigned char	CANDAT	@ 0xC2;
static volatile	unsigned char	CANCON	@ 0xC3;
static volatile	unsigned char	CANMOD	@ 0xC4;
static volatile	unsigned char	ADCON	@ 0xC5;
static volatile	unsigned char	ADCH	@ 0xC6;
static volatile	unsigned char	TM2IR	@ 0xC8;
static volatile	unsigned char	CMH0	@ 0xC9;
static volatile	unsigned char	CMH1	@ 0xCA;
static volatile	unsigned char	CMH2	@ 0xCB;
static volatile	unsigned char	CTH0	@ 0xCC;
static volatile	unsigned char	CTH1	@ 0xCD;
static volatile	unsigned char	CTH2	@ 0xCE;
static volatile	unsigned char	CTH3	@ 0xCF;
static volatile	unsigned char	PSW	@ 0xD0;
static volatile	unsigned char	S1CON	@ 0xD8;
static volatile	unsigned char	S1STA	@ 0xD9;
static volatile	unsigned char	S1DAT	@ 0xDA;
static volatile	unsigned char	S1ADR	@ 0xDB;
static volatile	unsigned char	ACC	@ 0xE0;
static		unsigned char	IEN1	@ 0xE8;
static volatile	unsigned char	TM2CON	@ 0xEA;
static		unsigned char	CTCON	@ 0xEB;
static volatile	unsigned char	TML2	@ 0xEC;
static volatile	unsigned char	TMH2	@ 0xED;
static		unsigned char	STE	@ 0xEE;
static		unsigned char	RTE	@ 0xEF;
static volatile	unsigned char	B	@ 0xF0;
static		unsigned char	IP1H	@ 0xF7;
static		unsigned char	IP1	@ 0xF8;
static		unsigned char	S0ADDR	@ 0xF9;
static		unsigned char	S0PSL	@ 0xFA;
static		unsigned char	S0PSH	@ 0xFB;
static		unsigned char	PWM0	@ 0xFC;
static		unsigned char	PWM1	@ 0xFD;
static		unsigned char	PWMP	@ 0xFE;
static volatile	unsigned char	T3	@ 0xFF;


static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile	SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static 		SFR_BITS TMOD_BITS		@ 0x89;
static 		SFR_BITS AUXR_BITS		@ 0x8E;
static volatile SFR_BITS P1_BITS		@ 0x90;
static 		SFR_BITS P1M1_BITS		@ 0x92;
static 		SFR_BITS P1M2_BITS		@ 0x93;
static 		SFR_BITS P2M1_BITS		@ 0x94;
static 		SFR_BITS P2M2_BITS		@ 0x95;
static volatile SFR_BITS S0CON_BITS		@ 0x98;
static 		SFR_BITS P3M1_BITS		@ 0x9A;
static 		SFR_BITS P3M2_BITS		@ 0x9B;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static volatile SFR_BITS AUXR1_BITS		@ 0xA2;
static 		SFR_BITS IEN0_BITS		@ 0xA8;
static 		SFR_BITS S0ADDR_BITS		@ 0xA9;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static 		SFR_BITS IP0H_BITS		@ 0xB7;
static 		SFR_BITS IP0_BITS		@ 0xB8;
static 		SFR_BITS S0ADEN_BITS		@ 0xB9;
static volatile SFR_BITS CANSTA_BITS		@ 0xC0;
static volatile SFR_BITS CANCON_BITS		@ 0xC3;
static volatile SFR_BITS CANMOD_BITS		@ 0xC4;
static volatile SFR_BITS ADCON_BITS		@ 0xC5;
static volatile SFR_BITS TM2IR_BITS		@ 0xC8;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static 		SFR_BITS IEN1_BITS		@ 0xE8;
static 		SFR_BITS CTCON_BITS		@ 0xEB;
static 		SFR_BITS STE_BITS		@ 0xEE;
static 		SFR_BITS RTE_BITS		@ 0xEF;
static volatile SFR_BITS B_BITS			@ 0xF0;
static 		SFR_BITS IP1H_BITS		@ 0xF7;
static 		SFR_BITS IP1_BITS		@ 0xF8;
static 		SFR_BITS PWM0_BITS		@ 0xFC;
static 		SFR_BITS PWM1_BITS		@ 0xFD;

//bit addressable locations
//Port 0
static volatile bit 	AD0	@ 0x80;
static volatile bit 	AD1	@ 0x81;
static volatile bit 	AD2	@ 0x82;
static volatile bit 	AD3	@ 0x83;
static volatile bit 	AD4	@ 0x84;
static volatile bit 	AD5	@ 0x85;
static volatile bit 	AD6	@ 0x86;
static volatile bit 	AD7	@ 0x87;

//Timer control TCON
static 		bit 	IT0	@ 0x88;
static volatile bit 	IE0	@ 0x89;
static 		bit 	IT1	@ 0x8A;
static volatile bit 	IE1 	@ 0x8B;
static		bit 	TR0 	@ 0x8C;
static volatile bit 	TF0 	@ 0x8D;
static		bit 	TR1 	@ 0x8E;
static volatile bit 	TF1 	@ 0x8F;

//Port 1
static volatile bit 	RXDC	@ 0x90;
static volatile bit 	TXDC	@ 0x91;
static volatile bit 	CT0I	@ 0x92;
static volatile bit 	CT1I	@ 0x93;
static volatile bit 	CT2I	@ 0x94;
static volatile bit 	CT3I	@ 0x95;
static volatile bit 	SCL	@ 0x96;
static volatile bit 	SDA	@ 0x97;

//Serial Control 0 S0CON
static volatile bit 	RI	@ 0x98;
static volatile bit 	TI 	@ 0x99;
static volatile bit 	RB8 	@ 0x9A;
static 		bit 	TB8 	@ 0x9B;
static 		bit 	REN 	@ 0x9C;
static 		bit 	SM2 	@ 0x9D;
static 		bit 	SM1 	@ 0x9E;
static volatile	bit 	SM0 	@ 0x9F;
// alternate function
static volatile	bit 	FE 	@ 0x9F;

//Port 2
static volatile	bit 	AD8 	@ 0xA0;
static volatile	bit 	AD9 	@ 0xA1;
static volatile	bit 	AD10 	@ 0xA2;
static volatile	bit 	AD11 	@ 0xA3;
static volatile	bit 	AD12 	@ 0xA4;
static volatile	bit 	AD13 	@ 0xA5;
static volatile	bit 	AD14 	@ 0xA6;
static volatile	bit 	AD15 	@ 0xA7;

//Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES0 	@ 0xAC;
static 		bit 	ES1 	@ 0xAD;
static 		bit 	EAD 	@ 0xAE;
static 		bit 	EA 	@ 0xAF;

//Port 3
static volatile bit 	RXD	@ 0xB0;
static volatile bit 	TXD	@ 0xB1;
static volatile bit 	INT0	@ 0xB2;
static volatile bit 	INT1	@ 0xB3;
static volatile bit 	T0	@ 0xB4;
static volatile bit 	T1	@ 0xB5;
static volatile bit 	WR	@ 0xB6;
static volatile bit 	RD	@ 0xB7;

//Interrupt Priority 0 IP0
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PT0 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS0 	@ 0xBC;
static 		bit 	PS1 	@ 0xBD;
static 		bit 	PAD 	@ 0xBE;

//CANSTA
//This register has a read and write mode
//READ mode
static volatile bit 	RBS	@ 0xC0;
static volatile bit 	DOS	@ 0xC1;
static volatile bit 	TBS	@ 0xC2;
static volatile bit 	TCS	@ 0xC3;
static volatile bit 	RS	@ 0xC4;
static volatile bit 	TS	@ 0xC5;
static volatile bit 	ES	@ 0xC6;
static volatile bit 	BS	@ 0xC7;
//WRITE mode
static volatile bit 	RIE	@ 0xC0;
static volatile bit 	TIE	@ 0xC1;
static volatile bit 	EIE	@ 0xC2;
static volatile bit 	DOIE	@ 0xC3;
static volatile bit 	WUIE	@ 0xC4;
static volatile bit 	EPIE	@ 0xC5;
static volatile bit 	ALIE	@ 0xC6;
static volatile bit 	BEIE	@ 0xC7;

//Timer 2 Interrupt Register TM2IR
static volatile bit 	CTI0	@ 0xC8;
static volatile bit 	CTI1	@ 0xC9;
static volatile bit 	CTI2	@ 0xCA;
static volatile bit 	CTI3	@ 0xCB;
static volatile bit 	CMI0	@ 0xCC;
static volatile bit 	CMI1	@ 0xCD;
static volatile bit 	CMI2	@ 0xCE;
// alternate function
static volatile bit 	CAN	@ 0xCE;
static volatile bit 	T20V	@ 0xCF;

//Serial Control 1 S1CON
static 		bit 	CR0	@ 0xD8;
static 		bit 	CR1	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO	@ 0xDC;
static volatile bit 	STA	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2	@ 0xDF;

//Accumulator
static volatile bit 	ACC0	@ 0xE0;
static volatile bit 	ACC1	@ 0xE1;
static volatile bit 	ACC2	@ 0xE2;
static volatile bit 	ACC3	@ 0xE3;
static volatile bit 	ACC4	@ 0xE4;
static volatile bit 	ACC5	@ 0xE5;
static volatile bit 	ACC6	@ 0xE6;
static volatile bit 	ACC7	@ 0xE7;

//Interrupt Enable 1 IEN1
static 		bit 	ECT0	@ 0xE8;
static 		bit 	ECT1	@ 0xE9;
static 		bit 	ECT2	@ 0xEA;
static 		bit 	ECT3	@ 0xEB;
static 		bit 	ECM0	@ 0xEC;
static 		bit 	ECM1	@ 0xED;
static 		bit 	ECAN	@ 0xEE;
static 		bit 	ET2	@ 0xEF;

//B Register
static volatile bit 	B0	@ 0xF0;
static volatile bit 	B1	@ 0xF1;
static volatile bit 	B2	@ 0xF2;
static volatile bit 	B3	@ 0xF3;
static volatile bit 	B4	@ 0xF4;
static volatile bit 	B5	@ 0xF5;
static volatile bit 	B6	@ 0xF6;
static volatile bit 	B7	@ 0xF7;

//Interrupt Priority 1 IP1
static 		bit 	PCT0	@ 0xF8;
static 		bit 	PCT1	@ 0xF9;
static 		bit 	PCT2	@ 0xFA;
static 		bit 	PCT3	@ 0xFB;
static 		bit 	PCM0	@ 0xFC;
static 		bit 	PCM1	@ 0xFD;
static 		bit 	PCAN	@ 0xFE;
static 		bit 	PT2	@ 0xFF;

/*	Interrupt vectors */
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0 	0x0B
#define	EXTINT1	0x13
#define TIMER1 	0x1B
#define	SERIAL	0x23
#define S1 	0x2B
#define CT0 	0x33
#define CT1 	0x3B
#define CT2 	0x43
#define CT3 	0x4B
#define ADC 	0x53
#define CM0 	0x5B
#define CM1 	0x63
#define CANI 	0x6B
#define TIMER2	0x73

#endif	
