
#ifndef	_HTC_H_
#warning Header file p8xc750.h included directly. Use #include <htc.h> instead.
#endif

/*
   Header file for the Phillips microcontrollers
   P83C750
   P87C750
 */

#ifndef	__P8XC750_H

#define	__P8XC750_H
	
typedef struct {
	unsigned B7:1;	/* this is the most significant bit */
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//special function registers
static volatile	unsigned char	P0	@ 0x80;
static volatile	unsigned char	SP	@ 0x81;
static volatile	unsigned char	DPL	@ 0x82;
static volatile	unsigned char	DPH	@ 0x83;
// 16 bit definition
static volatile	unsigned char	PCON	@ 0x87;
static volatile	unsigned char	TCON	@ 0x88;
static volatile	unsigned char	TL	@ 0x8A;
static volatile	unsigned char	RTL	@ 0x8B;
static volatile	unsigned char	TH	@ 0x8C;
static volatile	unsigned char	RTH	@ 0x8D;
static volatile	unsigned char	P1	@ 0x90;
static 		unsigned char	IE	@ 0xA8;
static volatile	unsigned char	P3	@ 0xB0;
static volatile	unsigned char	PSW	@ 0xD0;
static volatile	unsigned char	ACC	@ 0xE0;
static volatile	unsigned char	B	@ 0xF0;

static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile	SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static volatile SFR_BITS P1_BITS		@ 0x90;
static 		SFR_BITS IE_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static volatile SFR_BITS B_BITS			@ 0xF0;

//bit addressable locations
//PORT 0
static volatile bit 	P00	@ 0x80;
static volatile bit 	P01	@ 0x81;
static volatile bit 	P02	@ 0x82;

//Timer Control TCON
static 		bit 	IT1	@ 0x88;
static volatile bit 	IE1	@ 0x89;
static 		bit 	IT0	@ 0x8A;
static volatile bit 	IE0 	@ 0x8B;
static		bit 	TR 	@ 0x8C;
static volatile bit 	TF 	@ 0x8D;
static		bit 	CT 	@ 0x8E;
static 		bit 	GATE 	@ 0x8F;

//Port 1
static volatile bit 	P10	@ 0x90;
static volatile bit 	P11	@ 0x91;
static volatile bit 	P12	@ 0x92;
static volatile bit 	P13	@ 0x93;
static volatile bit 	P14	@ 0x94;
static volatile bit 	P15	@ 0x95;
static volatile bit 	P16	@ 0x96;
static volatile bit 	P17	@ 0x97;
// Alternate definitions
static volatile bit 	INT0	@ 0x95;
static volatile bit 	INT1	@ 0x96;
static volatile bit 	T0	@ 0x97;

//Interrupt Enable IE
static 		bit 	EX0	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	EA 	@ 0xAF;

//Port 3
static volatile bit 	P30	@ 0xB0;
static volatile bit 	P31	@ 0xB1;
static volatile bit 	P32	@ 0xB2;
static volatile bit 	P33	@ 0xB3;
static volatile bit 	P34	@ 0xB4;
static volatile bit 	P35	@ 0xB5;
static volatile bit 	P36	@ 0xB6;
static volatile bit 	P37	@ 0xB7;

//Program Status Word PSW
static volatile bit 	P 	@ 0xD0;
static volatile bit 	OV 	@ 0xD2;
static		bit 	RS0 	@ 0xD3;
static		bit 	RS1 	@ 0xD4;
static volatile bit 	F0 	@ 0xD5;
static volatile bit 	AC 	@ 0xD6;
static volatile bit 	CY 	@ 0xD7;

//Accumulator ACC
static volatile bit 	AC0	@ 0xE0;
static volatile bit 	AC1	@ 0xE1;
static volatile bit 	AC2	@ 0xE2;
static volatile bit 	AC3	@ 0xE3;
static volatile bit 	AC4	@ 0xE4;
static volatile bit 	AC5	@ 0xE5;
static volatile bit 	AC6	@ 0xE6;
static volatile bit 	AC7	@ 0xE7;

//B register
static volatile bit 	B0	@ 0xF0;
static volatile bit 	B1	@ 0xF1;
static volatile bit 	B2	@ 0xF2;
static volatile bit 	B3	@ 0xF3;
static volatile bit 	B4	@ 0xF4;
static volatile bit 	B5	@ 0xF5;
static volatile bit 	B6	@ 0xF6;
static volatile bit 	B7	@ 0xF7;

//Interrupt vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0 	0x0B
#define	EXTINT1	0x13

#endif	
