
#ifndef	_HTC_H_
#warning Header file p8xcl580.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Phillips Microcontrollers
	P80CL580
	P83CL580
*/

#ifndef __P8XCL580_H
#define __P8XCL580_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char S0CON	@ 0x98;
static		unsigned char S0BUF	@ 0x99;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char IEN0	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IP0	@ 0xB8;
static volatile unsigned char IRQ1	@ 0xC0;
static volatile unsigned char P4	@ 0xC1;
static volatile unsigned char ADCON	@ 0xC4;
static volatile unsigned char ADCH	@ 0xC5;
static volatile unsigned char T2CON	@ 0xC8;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static volatile unsigned char S1ADR	@ 0xDB;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char IEN1	@ 0xE8;
static		unsigned char IX1	@ 0xE9;
static volatile unsigned char B		@ 0xF0;
static		unsigned char IP1	@ 0xF8;
static		unsigned char PWM0	@ 0xFC;
static		unsigned char PWMP	@ 0xFE;
static volatile unsigned char T3	@ 0xFF;

static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static volatile SFR_BITS S0CON_BITS		@ 0x98;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS IEN0_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static		SFR_BITS IP0_BITS		@ 0xB8;
static volatile SFR_BITS IRQ1_BITS		@ 0xC0;
static volatile SFR_BITS P4_BITS		@ 0xC1;
static volatile SFR_BITS ADCON_BITS		@ 0xC4;
static volatile SFR_BITS ADCH_BITS		@ 0xC5;
static volatile SFR_BITS T2CON_BITS		@ 0xC8;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS S1ADR_BITS		@ 0xDB;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static		SFR_BITS IEN1_BITS		@ 0xE8;
static		SFR_BITS IX1_BITS		@ 0xE9;
static volatile SFR_BITS B_BITS			@ 0xF0;
static		SFR_BITS IP1_BITS		@ 0xF8;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Serial Control 0 S0CON
static volatile bit 	RI	@ 0x98;
static volatile bit 	TI	@ 0x99;
static volatile bit 	RB8 	@ 0x9A;
static 		bit 	TB8 	@ 0x9B;
static 		bit 	REN 	@ 0x9C;
static 		bit 	SM2 	@ 0x9D;
static 		bit 	SM1 	@ 0x9E;
static 		bit 	SM0 	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate functions
static volatile bit	T2	@ 0xA0;
static volatile bit	T2EX	@ 0xA1;
static volatile bit	STADC	@ 0xA2;
static volatile bit	SCL	@ 0xA6;
static volatile bit	SDA2	@ 0xA7;
static volatile bit	INT2	@ 0xA0;
static volatile bit	INT3	@ 0xA1;
static volatile bit	INT4	@ 0xA2;
static volatile bit	INT5	@ 0xA3;
static volatile bit	INT6	@ 0xA4;
static volatile bit	INT7	@ 0xA5;
static volatile bit	INT8	@ 0xA6;

//Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES0 	@ 0xAC;
static 		bit 	ES1 	@ 0xAD;
static 		bit 	ET2 	@ 0xAE;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//Interrupt Priority 0 IP0
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PT0 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS0 	@ 0xBC;
static 		bit 	PS1 	@ 0xBD;
static 		bit 	PT2 	@ 0xBE;

//Interrupt Request Register IRQ1
static volatile bit	IQ2	@ 0xC0;
static volatile bit	IQ3	@ 0xC1;
static volatile bit	IQ4	@ 0xC2;
static volatile bit	IQ5	@ 0xC3;
static volatile bit	IQ6	@ 0xC4;
static volatile bit	IQ7	@ 0xC5;
static volatile bit	IQ8	@ 0xC6;

//Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	RTCLK	@ 0xCC;
static volatile	bit	GF2	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Interrupt Enable 1 IEN1
static 		bit 	EX2	@ 0xE8;
static 		bit 	EX3	@ 0xE9;
static 		bit 	EX4	@ 0xEA;
static 		bit 	EX5	@ 0xEB;
static 		bit 	EX6	@ 0xEC;
static 		bit 	EX7	@ 0xED;
static 		bit 	EX8	@ 0xEE;
static 		bit 	EAD	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

//Interrupt Priority 1 IP1
static 		bit	PX2	@ 0xF8;
static 		bit	PX3	@ 0xF9;
static 		bit 	PX4	@ 0xFA;
static 		bit 	PX5	@ 0xFB;
static 		bit 	PX6	@ 0xFC;
static 		bit 	PX7	@ 0xFD;
static 		bit 	PX8	@ 0xFE;
static 		bit 	PADC	@ 0xFF;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	S1	0x2B
#define	TIMER2	0x33
#define	EXTINT2	0x3B
#define	EXTINT3	0x43
#define	EXTINT4	0x4B
#define	EXTINT5	0x53
#define	EXTINT6	0x5B
#define	EXTINT7	0x63
#define	EXTINT8	0x6B
#define	ADC	0x73

#endif
