
#ifndef	_HTC_H_
#warning Header file p8xcx66.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Phillips Microcontrollers
	P83C266
	P83C366
	P83C566
	P83C766
	P87C766
	
	*****	Note that SAD.0 - SAD.3 bits are now called SAD_0 - SAD_3 *****
 
 */

#ifndef __P8XCX66_H
#define __P8XCX66_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static		unsigned char I2CC0N	@ 0x86;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char P5	@ 0x98;
static		unsigned char OSAT	@ 0x99;
static		unsigned char OSDT	@ 0x9A;
static		unsigned char OSAD	@ 0x9B;
static		unsigned char OSDDEF	@ 0x9C;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char IEN0	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IP0	@ 0xB8;
static volatile unsigned char IRQ1	@ 0xC0;
static		unsigned char OSCON	@ 0xC1;
static		unsigned char OSORGV	@ 0xC2;
static		unsigned char OSORGH	@ 0xC3;
static		unsigned char OSPLL	@ 0xC4;
static		unsigned char OSSTART	@ 0xC5;
static		unsigned char HDEL	@ 0xC6;
static		unsigned char OSFBD	@ 0xC7;
static volatile unsigned char SAD	@ 0xC8;
static volatile unsigned char VINT	@ 0xC9;
static		unsigned char SAD2	@ 0xCA;
static		unsigned char OSCON2	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char TDACL	@ 0xD2;
static		unsigned char TDACH	@ 0xD3;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static volatile unsigned char S1ADR	@ 0xDB;
static volatile unsigned char S1IST	@ 0xDC;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char PWM0	@ 0xE4;
static		unsigned char PWM1	@ 0xE5;
static		unsigned char PWM2	@ 0xE6;
static		unsigned char PWM3	@ 0xE7;
static		unsigned char IEN1	@ 0xE8;
static		unsigned char IX1	@ 0xE9;
static		unsigned char PWM4	@ 0xEC;
static		unsigned char PWM5	@ 0xED;
static		unsigned char PWM6	@ 0xEE;
static		unsigned char PWM7	@ 0xEF;
static volatile unsigned char B		@ 0xF0;
static		unsigned char IP1	@ 0xF8;
static volatile unsigned char WDT	@ 0xFF;

static volatile SFR_BITS P0_BITS		@ 0x80;
static		SFR_BITS I2CC0N_BITS		@ 0x86;
static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static volatile SFR_BITS P5_BITS		@ 0x98;
static		SFR_BITS OSAT_BITS		@ 0x99;
static		SFR_BITS OSDDEF_BITS		@ 0x9C;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS IEN0_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static		SFR_BITS IP0_BITS		@ 0xB8;
static volatile SFR_BITS IRQ1_BITS		@ 0xC0;
static		SFR_BITS OSCON_BITS		@ 0xC1;
static volatile SFR_BITS SAD_BITS		@ 0xC8;
static volatile SFR_BITS VINT_BITS		@ 0xC9;
static		SFR_BITS SAD2_BITS		@ 0xCA;
static		SFR_BITS OSCON2_BITS		@ 0xCF;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static		SFR_BITS TDACH_BITS		@ 0xD3;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS S1ADR_BITS		@ 0xDB;
static volatile SFR_BITS S1IST_BITS		@ 0xDC;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static		SFR_BITS IEN1_BITS		@ 0xE8;
static		SFR_BITS IX1_BITS		@ 0xE9;
static volatile SFR_BITS B_BITS			@ 0xF0;
static		SFR_BITS IP1_BITS		@ 0xF8;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Port 5 P5
static volatile bit	P50	@ 0x98;
static volatile bit	P51	@ 0x99;
static volatile bit	P52	@ 0x9A;
static volatile bit	P53	@ 0x9B;
static volatile bit	P54	@ 0x9C;
static volatile bit	P55	@ 0x9D;
static volatile bit	P56	@ 0x9E;
static volatile bit	P57	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable 0 IEN0
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES1 	@ 0xAD;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;

//Interrupt Priority 0 IP0
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PT0 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS1 	@ 0xBD;

//Interrupt Request Register IRQ1
static volatile bit	IQ2	@ 0xC0;
static volatile bit	IQ3	@ 0xC1;
static volatile bit	IQ4	@ 0xC2;
static volatile bit	IQ5	@ 0xC3;
static volatile bit	IQ6	@ 0xC4;
static volatile bit	IQ7	@ 0xC5;
static volatile bit	IQ9	@ 0xC7;

//Software ADC SAD
static		bit	SAD_0	@ 0xC8;
static		bit	SAD_1	@ 0xC9;
static		bit	SAD_2	@ 0xCA;
static		bit	SAD_3	@ 0xCB;
static volatile	bit	ST	@ 0xCC;
static		bit	CH0	@ 0xCD;
static		bit	CH1	@ 0xCE;
static volatile	bit	VHI	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Interrupt Enable 1 IEN1
static 		bit 	EX2	@ 0xE8;
static 		bit 	EX3	@ 0xE9;
static 		bit 	EX4	@ 0xEA;
static 		bit 	EX5	@ 0xEB;
static 		bit 	EX6	@ 0xEC;
static 		bit 	EX7	@ 0xED;
static 		bit 	EX9	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

//Interrupt Priority 1 IP1
static 		bit	PX2	@ 0xF8;
static 		bit	PX3	@ 0xF9;
static 		bit 	PX4	@ 0xFA;
static 		bit 	PX5	@ 0xFB;
static 		bit 	PX6	@ 0xFC;
static 		bit 	PX7	@ 0xFD;
static 		bit 	PX9	@ 0xFF;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	I2CBUS	0x2B
#define	EXTINT2	0x33
#define	EXTINT3	0x3B
#define	EXTINT4	0x43
#define	EXTINT5	0x4B
#define	EXTINT6	0x5B
#define	EXTINT7	0x63
#define	EXTINT9	0x73

#endif
