
#ifndef	_HTC_H_
#warning Header file p8xcx80.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Phillips Microcontrollers
	P83C180
	P83C280
	P83C380
	P83C880
	P87C380
*/

#ifndef __P8XCX80_H
#define __P8XCX80_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char RAMBUF	@ 0x9C;
static volatile unsigned char DDCCON	@ 0x9D;
static volatile unsigned char DDCADR	@ 0x9E;
static volatile unsigned char DDCDAT	@ 0x9F;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char IE	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IP	@ 0xB8;
static		unsigned char DFCON	@ 0xC0;
static volatile unsigned char ADCDAT	@ 0xC1;
static		unsigned char PWM10H	@ 0xC6;
static		unsigned char PWM10L	@ 0xC7;
static		unsigned char PWME1	@ 0xC8;
static		unsigned char PWM0	@ 0xC9;
static		unsigned char PWM1	@ 0xCA;
static		unsigned char PWM2	@ 0xCB;
static		unsigned char PWM3	@ 0xCC;
static		unsigned char PWM4	@ 0xCD;
static		unsigned char PWM5	@ 0xCE;
static		unsigned char PWM6	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static volatile unsigned char S1ADR	@ 0xDB;
static volatile unsigned char ACC	@ 0xE0;
static		unsigned char PWME2	@ 0xE8;
static		unsigned char DAC0	@ 0xE9;
static		unsigned char DAC1	@ 0xEA;
static		unsigned char DAC2	@ 0xEB;
static		unsigned char DAC3	@ 0xEC;
static		unsigned char PWM7	@ 0xED;
static		unsigned char PWM8	@ 0xEE;
static		unsigned char PWM9	@ 0xEF;
static volatile unsigned char B		@ 0xF0;
static		unsigned char HFP	@ 0xF6;
static		unsigned char HFPOPW	@ 0xF7;
static volatile unsigned char MDCST	@ 0xF8;
static		unsigned char VFP	@ 0xF9;
static		unsigned char VFPOPW	@ 0xFA;
static		unsigned char PULCNT	@ 0xFB;
static volatile unsigned char HFHIGH	@ 0xFC;
static volatile unsigned char VFHIGH	@ 0xFD;
static volatile unsigned char VFLHFL	@ 0xFE;
static volatile unsigned char T2	@ 0xFF;

static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static volatile SFR_BITS DDCCON_BITS		@ 0x9D;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS IE_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static		SFR_BITS IP_BITS		@ 0xB8;
static		SFR_BITS DFCON_BITS		@ 0xC0;
static		SFR_BITS PWME1_BITS		@ 0xC8;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS S1ADR_BITS		@ 0xDB;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static		SFR_BITS PWME2_BITS		@ 0xE8;
static volatile SFR_BITS B_BITS			@ 0xF0;
static volatile SFR_BITS MDCST_BITS		@ 0xF8;
static		SFR_BITS PULCNT_BITS		@ 0xFB;
static volatile SFR_BITS VFLHFL_BITS		@ 0xFE;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable IE
static 		bit 	EX0 	@ 0xA8;
static 		bit 	ET0 	@ 0xA9;
static 		bit 	EX1 	@ 0xAA;
static 		bit 	ET1 	@ 0xAB;
static 		bit 	ES1 	@ 0xAD;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;

//Interrupt Priority IP
static 		bit 	PX0 	@ 0xB8;
static 		bit 	PT0 	@ 0xB9;
static 		bit 	PX1 	@ 0xBA;
static 		bit 	PT1 	@ 0xBB;
static 		bit 	PS1 	@ 0xBD;
static 		bit 	PAD 	@ 0xBE;

//Miscellaneous Control Register DFCON
static		bit	S1E	@ 0xC3;
static		bit	DDCE	@ 0xC4;
static		bit	SYNCE	@ 0xC5;
static		bit	SOGE	@ 0xC6;
static		bit	EW2	@ 0xC7;

//PWM Output Control Register 1 PWME1
static		bit	PWME10	@ 0xC8;
static		bit	PWME11	@ 0xC9;
static		bit	PWME12	@ 0xCA;
static		bit	PWME13	@ 0xCB;
static		bit	PWME14	@ 0xCC;
static		bit	PWME15	@ 0xCD;
static		bit	PWME16	@ 0xCE;
static		bit	PWME17	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//PWM Control 2 PWME2
static		bit	PWME20	@ 0xE8;
static		bit	PWME21	@ 0xE9;
static		bit	PWME22	@ 0xEA;
static		bit	DACE0	@ 0xEB;
static		bit	DACE1	@ 0xEC;
static		bit	DACE2	@ 0xED;
static		bit	DACE3	@ 0xEE;
static		bit	PATENA	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;

//Mode Detection/Sync Sepearation Control and Status Register MDCST
static		bit	VPOL	@ 0xF8;
static		bit	HPOL	@ 0xF9;
static volatile	bit	VPRES	@ 0xFA;
static volatile	bit	HPRES	@ 0xFB;
static		bit	HSEL	@ 0xFC;
static		bit	XSEL	@ 0xFD;
static volatile	bit	CHREQ	@ 0xFE;
static		bit	MARCH	@ 0xFF;

//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x2B

#endif
