
#ifndef	_HTC_H_
#warning Header file saa5x9x.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Phillips Microcontrollers
	SAA5290
	SAA5290A
	SAA5291
	SAA5291A
	SAA5296
	SAA5296A
	SAA5297
	SAA5297H
	SAA5297A
	SAA5491
	SAA5491H
	SAA5496
	SAA5497
	SAA5497H
	SAA5497A
*/

#ifndef __SAA5X9X_H
#define __SAA5X9X_H

#if defined(_SAA5296)	|| defined(_SAA5296A)	|| defined(_SAA5297)	||\
    defined(_SAA5297A)	|| defined(_SAA5496)	|| defined(_SAA5497)	||\
    defined(_SAA5290)	|| defined(_SAA5290A)	|| defined(_SAA5291)	||\
    defined(_SAA5291A)	|| defined(_SAA5491)	|| defined(_SAA5297H)	||\
    defined(_SAA5497H)	|| defined(_SAA5491H)
#define _note1
/* SAA5290, SAA5290A, SAA5291, SAA5291A, SAA5491 require TXT8.7 (I2C SELECT)
 * to be set for this SFR to be available, otherwise the SFR is permanently
 * available */
#endif

#if defined(_SAA5290)	|| defined(_SAA5290A)	|| defined(_SAA5291)	||\
    defined(_SAA5291A)	|| defined(_SAA5491)	|| defined(_SAA5291H)
#define _note2
#endif

#if defined(_SAA5296)	|| defined(_SAA5296A)	|| defined(_SAA5297)	||\
    defined(_SAA5297A)	|| defined(_SAA5496)	|| defined(_SAA5497)	||\
    defined(_SAA5497A)	|| defined(_SAA5297H)	|| defined(_SAA5497H)
#define _note3
#endif

#if defined(_SAA5491)	|| defined(_SAA5496)	|| defined(_SAA5497)	||\
    defined(_SAA5497A)	|| defined(_SAA5497H)
#define _note4
#endif

#if defined(_SAA5290A)	|| defined(_SAA5291A)	|| defined(_SAA5296A)	||\
    defined(_SAA5297A)	|| defined(_SAA5491)	|| defined(_SAA5496)	||\
    defined(_SAA5497)	|| defined(_SAA5497A)	|| defined(_SAA5497H)
#define _note5
#endif

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static		unsigned char SADB	@ 0x98;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char IE	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static volatile unsigned char TXT13	@ 0xC8;
static		unsigned char TXT17	@ 0xB9;
#if defined(_note5)
static volatile unsigned char WSS1	@ 0xBA;
static volatile unsigned char WSS2	@ 0xBB;
static volatile unsigned char WSS3	@ 0xBC;
#endif
static		unsigned char CLUT	@ 0xBD;
static		unsigned char TXT0	@ 0xC0;
static		unsigned char TXT1	@ 0xC1;
static		unsigned char TXT2	@ 0xC2;
static		unsigned char TXT3	@ 0xC3;
static		unsigned char TXT4	@ 0xC4;
static		unsigned char TXT5	@ 0xC5;
static		unsigned char TXT6	@ 0xC6;
static		unsigned char TXT7	@ 0xC7;
static volatile unsigned char TXT8	@ 0xC8;
static		unsigned char TXT9	@ 0xC9;
static		unsigned char TXT10	@ 0xCA;
static volatile unsigned char TXT11	@ 0xCB;
static volatile unsigned char TXT12	@ 0xCC;
#if defined(_note5)
static		unsigned char TXT14	@ 0xCD;
static		unsigned char TXT15	@ 0xCE;
#endif
static		unsigned char TXT16	@ 0xCF;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char TDACL	@ 0xD2;
static		unsigned char TDACH	@ 0xD3;
static		unsigned char PWM7	@ 0xD4;
static		unsigned char PWM0	@ 0xD5;
static		unsigned char PWM1	@ 0xD6;
static		unsigned char PWM2	@ 0xD7;
#if defined(_note1)
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static		unsigned char S1ADR	@ 0xDB;
#endif
#if defined(_note2)
static volatile unsigned char S1SCS	@ 0xD8;
static volatile unsigned char S1BIT	@ 0xD9;
static volatile unsigned char S1INT	@ 0xDA;
#endif
static		unsigned char PWM3	@ 0xDC;
static		unsigned char PWM4	@ 0xDD;
static		unsigned char PWM5	@ 0xDE;
static		unsigned char PWM6	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char SAD	@ 0xE8;
static volatile unsigned char B		@ 0xF0;

static volatile SFR_BITS P0_BITS		@ 0x80;
static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static		SFR_BITS SADB_BITS		@ 0x98;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS IE_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static volatile	SFR_BITS TXT13_BITS		@ 0xB8;
static		SFR_BITS TXT17_BITS		@ 0xB9;
#if defined(_note5)
static volatile SFR_BITS WSS1_BITS		@ 0xBA;
static volatile SFR_BITS WSS2_BITS		@ 0xBB;
static volatile SFR_BITS WSS3_BITS		@ 0xBC;
#endif
#if defined(_note4)
static		SFR_BITS CLUT_BITS		@ 0xBD;
#endif
static		SFR_BITS TXT0_BITS		@ 0xC0;
static		SFR_BITS TXT1_BITS		@ 0xC1;
static		SFR_BITS TXT2_BITS		@ 0xC2;
static		SFR_BITS TXT3_BITS		@ 0xC3;
static		SFR_BITS TXT4_BITS		@ 0xC4;
static		SFR_BITS TXT5_BITS		@ 0xC5;
static		SFR_BITS TXT6_BITS		@ 0xC6;
static		SFR_BITS TXT7_BITS		@ 0xC7;
static volatile	SFR_BITS TXT8_BITS		@ 0xC8;
static		SFR_BITS TXT9_BITS		@ 0xC9;
static		SFR_BITS TXT10_BITS		@ 0xCA;
static volatile	SFR_BITS TXT11_BITS		@ 0xCB;
static volatile	SFR_BITS TXT12_BITS		@ 0xCC;
#if defined(_note5)
static		SFR_BITS TXT14_BITS		@ 0xCD;
static		SFR_BITS TXT15_BITS		@ 0xCE;
#endif
static		SFR_BITS TXT16_BITS		@ 0xCF;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static		SFR_BITS TDACL_BITS		@ 0xD2;
static		SFR_BITS TDACH_BITS		@ 0xD3;
static		SFR_BITS PWM7_BITS		@ 0xD4;
static		SFR_BITS PWM0_BITS		@ 0xD5;
static		SFR_BITS PWM1_BITS		@ 0xD6;
static		SFR_BITS PWM2_BITS		@ 0xD7;
#if defined(_note1)
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS S1DAT_BITS		@ 0xDA;
static		SFR_BITS S1ADR_BITS		@ 0xDB;
#endif
#if defined(_note2)
static volatile SFR_BITS S1SCS_BITS		@ 0xD8;
static volatile SFR_BITS S1BIT_BITS		@ 0xD9;
static volatile SFR_BITS S1INT_BITS		@ 0xDA;
#endif
static		SFR_BITS PWM3_BITS		@ 0xDC;
static		SFR_BITS PWM4_BITS		@ 0xDD;
static		SFR_BITS PWM5_BITS		@ 0xDE;
static		SFR_BITS PWM6_BITS		@ 0xDF;
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static volatile SFR_BITS SAD_BITS		@ 0xE8;
static volatile SFR_BITS B_BITS			@ 0xF0;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Software ADC (LSB) SADB
static 		bit	SAD0	@ 0x98;
static 		bit	SAD1	@ 0x99;
static 		bit	SAD2	@ 0x9A;
static 		bit	SAD3	@ 0x9B;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES2	@ 0xAD;
static 		bit	ES1	@ 0xAE;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

#if defined(_note1)
//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENSI	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;
#endif

#if defined(_note2)
//Serial I2C-bus S1SCS
static		bit	ENS	@ 0xD8;
static		bit	STR	@ 0xD9;
static volatile bit	WBF	@ 0xDA;
static volatile bit	RBF	@ 0xDB;
static volatile bit	BB	@ 0xDC;
static volatile bit	CLH	@ 0xDD;
static volatile bit	SCI	@ 0xDE;
static volatile bit	SDI	@ 0xDF;
#endif

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Software ADC (MSB) SAD
static		bit	SAD4	@ 0xE8;
static		bit	SAD5	@ 0xE9;
static		bit	SAD6	@ 0xEA;
static		bit	SAD7	@ 0xEB;
static volatile	bit	ST	@ 0xEC;
static		bit	CH0	@ 0xED;
static		bit	CH1	@ 0xEE;
static volatile	bit	VHI	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	BYTEI2C	0x2B
#if defined(_note2)
#define	BITI2C	0x53
#endif

#endif
