
#ifndef	_HTC_H_
#warning Header file t8xc5121.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Microcontroller
	T83C5121
	T85C5121
	T89C5121
*/

#ifndef __T8XC5121_H
#define __T8XC5121_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static		unsigned char AUXR	@ 0x8E;
static		unsigned char CKCON0	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static		unsigned char SIOCON	@ 0x91;
static		unsigned char CKRL	@ 0x97;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static		unsigned char BRL	@ 0x9A;
static		unsigned char BDRCON	@ 0x9B;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char AUXR1	@ 0xA2;
static volatile unsigned char WDTRST	@ 0xA6;
static		unsigned char WDTPRG	@ 0xA7;
static		unsigned char IE0	@ 0xA8;
static		unsigned char SADDR	@ 0xA9;
static volatile unsigned char SCTBUF	@ 0xAA;
static volatile unsigned char SCSR	@ 0xAB;
static volatile unsigned char SCCON	@ 0xAC;
static volatile unsigned char SCISR	@ 0xAD;
static volatile unsigned char SCIIR	@ 0xAE;
static		unsigned char CKCON1	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IE1	@ 0xB1;
static		unsigned char IPL1	@ 0xB2;
static		unsigned char IPH1	@ 0xB3;
static volatile unsigned char SCWT0	@ 0xB4;
static volatile unsigned char SCWT1	@ 0xB5;
static volatile unsigned char SCWT2	@ 0xB6;
static		unsigned char IPH0	@ 0xB7;
static		unsigned char IPL0	@ 0xB8;
static		unsigned char SADEN	@ 0xB9;
static volatile unsigned char ISEL	@ 0xBA;
static		unsigned char DCCKPS	@ 0xBF;
static volatile unsigned char PSW	@ 0xD0;
static		unsigned char RCON	@ 0xD1;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char B		@ 0xF0;
static		unsigned char LEDCON	@ 0xF1;
// Registers available only when SCSR.0 = 1
static volatile unsigned char SCRBUF	@ 0xAA;
static volatile unsigned char SCETU0	@ 0xAC;
static volatile unsigned char SCETU	@ 0xAD;
static volatile unsigned char SCIER	@ 0xAE;
static volatile unsigned char SCGT0	@ 0xB4;
static volatile unsigned char SCGT1	@ 0xB5;
static volatile unsigned char SCICR	@ 0xB6;

static volatile SFR_BITS	P0_BITS		@ 0x80;
static volatile SFR_BITS	PCON_BITS	@ 0x87;
static volatile SFR_BITS	TCON_BITS	@ 0x88;
static		SFR_BITS	TMOD_BITS	@ 0x89;
static		SFR_BITS	AUXR_BITS	@ 0x8E;
static		SFR_BITS	CKCON0_BITS	@ 0x8F;
static volatile SFR_BITS	P1_BITS		@ 0x90;
static		SFR_BITS	SIOCON_BITS	@ 0x91;
static volatile SFR_BITS	SCON_BITS	@ 0x98;
static		SFR_BITS	BDRCON_BITS	@ 0x9B;
static volatile SFR_BITS	P2_BITS		@ 0xA0;
static		SFR_BITS	AUXR1_BITS	@ 0xA2;
static		SFR_BITS	WDTPRG_BITS	@ 0xA7;
static		SFR_BITS	IE0_BITS	@ 0xA8;
static volatile SFR_BITS	SCSR_BITS	@ 0xAB;
static volatile SFR_BITS	SCCON_BITS	@ 0xAC;
static volatile SFR_BITS	SCISR_BITS	@ 0xAD;
static volatile SFR_BITS	SCIIR_BITS	@ 0xAE;
static		SFR_BITS	CKCON1_BITS	@ 0xAF;
static volatile SFR_BITS	P3_BITS		@ 0xB0;
static		SFR_BITS	IE1_BITS	@ 0xB1;
static		SFR_BITS	IPL1_BITS	@ 0xB2;
static		SFR_BITS	IPH1_BITS	@ 0xB3;
static volatile SFR_BITS	SCWT0_BITS	@ 0xB4;
static volatile SFR_BITS	SCWT1_BITS	@ 0xB5;
static volatile SFR_BITS	SCWT2_BITS	@ 0xB6;
static		SFR_BITS	IPH0_BITS	@ 0xB7;
static		SFR_BITS	IPL0_BITS	@ 0xB8;
static volatile SFR_BITS	ISEL_BITS	@ 0xBA;
static volatile SFR_BITS	PSW_BITS	@ 0xD0;
static		SFR_BITS	RCON_BITS	@ 0xD1;
static volatile SFR_BITS	ACC_BITS	@ 0xE0;
static volatile SFR_BITS	B_BITS		@ 0xF0;
static		SFR_BITS	LEDCON_BITS	@ 0xF1;
// Registers available only when SCSR.0 = 1
static volatile SFR_BITS	SCETU0_BITS	@ 0xAC;
static volatile SFR_BITS	SCETU_BITS	@ 0xAD;
static volatile SFR_BITS	SCIER_BITS	@ 0xAE;
static volatile SFR_BITS	SCGT0_BITS	@ 0xB4;
static volatile SFR_BITS	SCGT1_BITS	@ 0xB5;
static volatile SFR_BITS	SCICR_BITS	@ 0xB6;

//Bit Addressable Locations
//Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IEDGE0	@ 0x89;	// IE0 renamed to IEDGE0: name conflict with Interrupt Enable SFR
static 		bit	IT1	@ 0x8A;
static volatile bit	IEDGE1	@ 0x8B;	// IE1 renamed to IEDGE1: name conflict with Interrupt Enable SFR
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate Functions
static volatile bit	CIO	@ 0x90;
static volatile bit	CC8	@ 0x91;
static volatile bit	CPRES	@ 0x92;
static volatile bit	CC4	@ 0x93;
static volatile bit	CCLK	@ 0x94;
static volatile bit	CRST	@ 0x95;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile bit	SM0	@ 0x9F;
// alternate definition
static volatile bit	FE	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternat functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

//Interrupt Enable 0 IE0
static 		bit	EX0	@ 0xA8;
static 		bit	ET0	@ 0xA9;
static 		bit 	EX1	@ 0xAA;
static 		bit 	ET1	@ 0xAB;
static 		bit 	ES	@ 0xAC;
static 		bit 	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

//include data for IPL0
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit 	PX1	@ 0xBA;
static 		bit 	PT1	@ 0xBB;
static 		bit 	PS	@ 0xBC;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	SCI	0x53

#endif
