
#ifndef	_HTC_H_
#warning Header file upsd3212.h included directly. Use #include <htc.h> instead.
#endif


 /* header file for the ST microcontrollers
	UPSD3212A
	UPSD3212C
	UPSD3212CV
 */

#ifndef	__UPSD3212_H

#define	__UPSD3212_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char P0	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static          unsigned char P1SFS	@ 0x91;
static          unsigned char P3SFS	@ 0x93;
static          unsigned char P4SFS	@ 0x94;
static          unsigned char ASCL	@ 0x95;
static volatile unsigned char ADAT	@ 0x96;
static volatile unsigned char ACON	@ 0x97;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static volatile unsigned char SCON2	@ 0x9A;
static volatile unsigned char SBUF2	@ 0x9B;
static volatile unsigned char P2	@ 0xA0;
static          unsigned char PWMCON	@ 0xA1;
static          unsigned char PWM0	@ 0xA2;
static          unsigned char PWM1	@ 0xA3;
static          unsigned char PWM2	@ 0xA4;
static          unsigned char PWM3	@ 0xA5;
static volatile unsigned char WDRST	@ 0xA6;
static          unsigned char IEA	@ 0xA7;
static          unsigned char IE	@ 0xA8;
static          unsigned char PWM4P	@ 0xAA;
static          unsigned char PWM4W	@ 0xAB;
static          unsigned char WDKEY	@ 0xAE;
static volatile unsigned char P3	@ 0xB0;
static volatile unsigned char PSCL0L	@ 0xB1;
static volatile unsigned char PSCL0H	@ 0xB2;
static volatile unsigned char PSCL1L	@ 0xB3;
static volatile unsigned char PSCL1H	@ 0xB4;
static          unsigned char IPA	@ 0xB7;
static          unsigned char IP	@ 0xB8;
static volatile unsigned char P4	@ 0xC0;
static volatile unsigned char T2CON	@ 0xC8;
static          unsigned char T2MOD	@ 0xC9;
static volatile unsigned char RCAP2L	@ 0xCA;
static volatile unsigned char RCAP2H	@ 0xCB;
static volatile unsigned char TL2	@ 0xCC;
static volatile unsigned char TH2	@ 0xCD;
static volatile unsigned char PSW	@ 0xD0;
static          unsigned char S2SETUP	@ 0xD2;
static volatile unsigned char S2CON	@ 0xDC;
static volatile unsigned char S2STA	@ 0xDD;
static volatile unsigned char S2DAT	@ 0xDE;
static          unsigned char S2ADR	@ 0xDF;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char B		@ 0xF0;

static volatile SFR_BITS	 P0_BITS	@ 0x80;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static          SFR_BITS	 P1SFS_BITS	@ 0x91;
static          SFR_BITS	 P3SFS_BITS	@ 0x93;
static          SFR_BITS	 P4SFS_BITS	@ 0x94;
static volatile SFR_BITS	 ACON_BITS	@ 0x97;
static volatile SFR_BITS	 SCON_BITS	@ 0x98;
static volatile SFR_BITS	 SCON2_BITS	@ 0x9A;
static volatile SFR_BITS	 SBUF2_BITS	@ 0x9B;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static          SFR_BITS	 PWMCON_BITS	@ 0xA1;
static          SFR_BITS	 PWM0_BITS	@ 0xA2;
static          SFR_BITS	 PWM1_BITS	@ 0xA3;
static          SFR_BITS	 PWM2_BITS	@ 0xA4;
static          SFR_BITS	 PWM3_BITS	@ 0xA5;
static          SFR_BITS	 IEA_BITS	@ 0xA7;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static          SFR_BITS	 IPA_BITS	@ 0xB7;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 P4_BITS	@ 0xC0;
static volatile SFR_BITS	 T2CON_BITS	@ 0xC8;
static          SFR_BITS	 T2MOD_BITS	@ 0xC9;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static volatile SFR_BITS	 S2CON_BITS	@ 0xDC;
static volatile SFR_BITS	 S2STA_BITS	@ 0xDD;
static volatile SFR_BITS	 S2DAT_BITS	@ 0xDE;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static volatile SFR_BITS	 B_BITS		@ 0xF0;


// Bit Addressable Locations
// Port 0 P0
static volatile bit	P00	@ 0x80;
static volatile bit	P01	@ 0x81;
static volatile bit	P02	@ 0x82;
static volatile bit	P03	@ 0x83;
static volatile bit	P04	@ 0x84;
static volatile bit	P05	@ 0x85;
static volatile bit	P06	@ 0x86;
static volatile bit	P07	@ 0x87;
// Alternate Functions
static volatile bit	AD0	@ 0x80;
static volatile bit	AD1	@ 0x81;
static volatile bit	AD2	@ 0x82;
static volatile bit	AD3	@ 0x83;
static volatile bit	AD4	@ 0x84;
static volatile bit	AD5	@ 0x85;
static volatile bit	AD6	@ 0x86;
static volatile bit	AD7	@ 0x87;

// Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

// Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

// Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static volatile bit	SM0	@ 0x9F;

// Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	A8	@ 0xA0;
static volatile bit	A9	@ 0xA1;
static volatile bit	A10	@ 0xA2;
static volatile bit	A11	@ 0xA3;
static volatile bit	A12	@ 0xA4;
static volatile bit	A13	@ 0xA5;
static volatile bit	A14	@ 0xA6;
static volatile bit	A15	@ 0xA7;

// Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	ET2	@ 0xAD;
static 		bit	EA	@ 0xAF;

// Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;
static volatile bit	WR	@ 0xB6;
static volatile bit	RD	@ 0xB7;

// Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
static 		bit	PT2	@ 0xBD;

// Port 4
static volatile bit	P40	@ 0xC0;
static volatile bit	P41	@ 0xC1;
static volatile bit	P42	@ 0xC2;
static volatile bit	P43	@ 0xC3;
static volatile bit	P44	@ 0xC4;
static volatile bit	P45	@ 0xC5;
static volatile bit	P46	@ 0xC6;
static volatile bit	P47	@ 0xC7;

// Timer 2 Control T2CON
static 		bit	CPRL2	@ 0xC8;
static 		bit	CT2	@ 0xC9;
static 		bit	TR2	@ 0xCA;
static 		bit	EXEN2	@ 0xCB;
static		bit	TCLK	@ 0xCC;
static		bit	RCLK	@ 0xCD;
static volatile	bit	EXF2	@ 0xCE;
static volatile	bit	TF2	@ 0xCF;

// Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

// Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

// B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


// Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL0	0x23
#define	TIMER2	0x2B
#define	I2C	0x43
#define	SERIAL1	0x4B

#endif
