
#ifndef	_HTC_H_
#warning Header file w78e354.h included directly. Use #include <htc.h> instead.
#endif



 /* header file for the Winbond microcontrollers
	W78E354
 */

#ifndef	__W78E354_H

#define	__W78E354_H

typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char CONTREG1	@ 0x80;
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static		unsigned char CONTREG5	@ 0x84;
static		unsigned char CONTREG2	@ 0x85;
static volatile unsigned char CONTREG3	@ 0x86;
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static          unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static		unsigned char PARAL	@ 0x8E;
static		unsigned char PARAH	@ 0x8F;
static volatile unsigned char P1	@ 0x90;
static		unsigned char AUTOLOAD	@ 0x91;
static		unsigned char DHREG	@ 0x92;
static		unsigned char DVREG	@ 0x93;
static volatile unsigned char DDC1	@ 0x94;
static		unsigned char INTMSK	@ 0x95;
static		unsigned char BDDAC	@ 0x96;
static		unsigned char DBRM	@ 0x97;
static volatile unsigned char SCON	@ 0x98;
static volatile unsigned char SBUF	@ 0x99;
static		unsigned char BSDAC0	@ 0x9A;
static		unsigned char BSDAC1	@ 0x9B;
static		unsigned char WDTCLR	@ 0x9C;
static		unsigned char DDAC0	@ 0x9D;
static		unsigned char DDAC1	@ 0x9E;
static		unsigned char DDAC2	@ 0x9F;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char SDAC0	@ 0xA1;
static		unsigned char SDAC1	@ 0xA2;
static		unsigned char SDAC2	@ 0xA3;
static		unsigned char SDAC3	@ 0xA4;
static		unsigned char SDAC4	@ 0xA5;
static		unsigned char SDAC5	@ 0xA6;
static		unsigned char SDAC6	@ 0xA7;
static          unsigned char IE	@ 0xA8;
static		unsigned char SDAC7	@ 0xA9;
static		unsigned char SDAC8	@ 0xAA;
static		unsigned char SDAC9	@ 0xAB;
static		unsigned char SDAC10	@ 0xAC;
static		unsigned char SDAC11	@ 0xAD;
static		unsigned char SDAC12	@ 0xAE;
static		unsigned char SDAC13	@ 0xAF;
static volatile unsigned char P3	@ 0xB0;
static volatile unsigned char ADC	@ 0xB1;
static		unsigned char INTVECT	@ 0xB2;
static volatile unsigned char STATUS	@ 0xB3;
static volatile unsigned char HFCOUNTL	@ 0xB4;
static volatile unsigned char HFCOUNTH	@ 0xB5;
static volatile unsigned char VFCOUNTL	@ 0xB6;
static volatile unsigned char VFCOUNTH	@ 0xB7;
static          unsigned char IP	@ 0xB8;
static		unsigned char SBRM0	@ 0xB9;
static		unsigned char SBRM1	@ 0xBA;
static volatile unsigned char PORT4	@ 0xBB;
static		unsigned char SOAREG	@ 0xBC;
static		unsigned char SOACLR	@ 0xBD;
static volatile unsigned char CONTREG4	@ 0xC8;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static          unsigned char S1ADR	@ 0xDB;
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char B		@ 0xF0;

static volatile SFR_BITS	 CONTREG1_BITS	@ 0x80;
static		SFR_BITS	 CONTREG5_BITS	@ 0x84;
static		SFR_BITS	 CONTREG2_BITS	@ 0x85;
static volatile SFR_BITS	 CONTREG3_BITS	@ 0x86;
static volatile SFR_BITS	 PCON_BITS	@ 0x87;
static volatile SFR_BITS	 TCON_BITS	@ 0x88;
static          SFR_BITS	 TMOD_BITS	@ 0x89;
static volatile SFR_BITS	 P1_BITS	@ 0x90;
static		SFR_BITS	 INTMSK_BITS	@ 0x95;
static volatile SFR_BITS	 SCON_BITS	@ 0x98;
static volatile SFR_BITS	 P2_BITS	@ 0xA0;
static          SFR_BITS	 IE_BITS	@ 0xA8;
static volatile SFR_BITS	 P3_BITS	@ 0xB0;
static volatile SFR_BITS	 INTVECT_BITS	@ 0xB2;
static volatile SFR_BITS	 STATUS_BITS	@ 0xB3;
static          SFR_BITS	 IP_BITS	@ 0xB8;
static volatile SFR_BITS	 PORT4_BITS	@ 0xBB;
static volatile SFR_BITS	 CONTREG4_BITS	@ 0xC8;
static volatile SFR_BITS	 PSW_BITS	@ 0xD0;
static volatile SFR_BITS	 S1CON_BITS	@ 0xD8;
static volatile SFR_BITS	 S1STA_BITS	@ 0xD9;
static volatile SFR_BITS	 S1DAT_BITS	@ 0xDA;
static          SFR_BITS	 S1ADR_BITS	@ 0xDB;
static volatile SFR_BITS	 ACC_BITS	@ 0xE0;
static volatile SFR_BITS	 B_BITS		@ 0xF0;


// Bit Addressable Locations
// iControl Register 1 CONTREG1
static		bit	ADCS0	@ 0x80;
static		bit	ADCS1	@ 0x81;
static		bit	ENDDC1	@ 0x82;
static		bit	HCES	@ 0x83;
static		bit	HCWS0	@ 0x84;
static		bit	HCWS1	@ 0x85;
static		bit	DUMMYEN	@ 0x86;
static volatile bit	ADCSTRT	@ 0x87;

//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;

//Serial Control SCON
static volatile bit	RI	@ 0x98;
static volatile bit	TI	@ 0x99;
static volatile bit	RB8	@ 0x9A;
static		bit	TB8	@ 0x9B;
static 		bit	REN	@ 0x9C;
static		bit	SM2	@ 0x9D;
static		bit	SM1	@ 0x9E;
static		bit	SM0	@ 0x9F;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
// address 0xAA must be accessed via IE.2
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
// address 0xAD must be accessed via IE.5
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	RXD	@ 0xB0;
static volatile bit	TXD	@ 0xB1;
static volatile bit	INT0	@ 0xB2;
static volatile bit	INT1	@ 0xB3;
static volatile bit	T0	@ 0xB4;
static volatile bit	T1	@ 0xB5;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
// address 0xBA must be accessed via IE.2
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;
// address 0xBD must be accessed via IE.5

// Control register 4 CONTREG4
static volatile bit	P24SF	@ 0xC8;
static volatile bit	P25SF	@ 0xC9;
static volatile bit	P26SF	@ 0xCA;
static volatile bit	P27SF	@ 0xCB;
static volatile bit	P14SF	@ 0xCC;
static volatile bit	P15SF	@ 0xCD;
static volatile bit	P23SF	@ 0xCE;
static		bit	INVSTP	@ 0xCF;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//Accumulator ACC
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23
#define	TIMER2	0x2B

#endif
