
#ifndef	_HTC_H_
#warning Header file w78x37x.h included directly. Use #include <htc.h> instead.
#endif

/* This is a header file for the Winbond Microcontrollers
	W78E378
	W78C378
	W78C374
*/

#ifndef __W78X37X_H
#define __W78X37X_H


typedef struct {
	unsigned B7:1; //This is the most signifigant bit
	unsigned B6:1;
	unsigned B5:1;
	unsigned B4:1;
	unsigned B3:1;
	unsigned B2:1;
	unsigned B1:1;
	unsigned B0:1;
}	SFR_BITS;

//Special Function Registers
static volatile unsigned char SP	@ 0x81;
static volatile unsigned char DPL	@ 0x82;
static volatile unsigned char DPH	@ 0x83;
// 16 bit definition
static volatile unsigned char PCON	@ 0x87;
static volatile unsigned char TCON	@ 0x88;
static		unsigned char TMOD	@ 0x89;
static volatile unsigned char TL0	@ 0x8A;
static volatile unsigned char TL1	@ 0x8B;
static volatile unsigned char TH0	@ 0x8C;
static volatile unsigned char TH1	@ 0x8D;
static volatile unsigned char P1	@ 0x90;
static volatile unsigned char P2	@ 0xA0;
static		unsigned char IE	@ 0xA8;
static volatile unsigned char P3	@ 0xB0;
static		unsigned char IP	@ 0xB8;
static volatile unsigned char TMREG	@ 0xC0;
static volatile unsigned char PSW	@ 0xD0;
static volatile unsigned char S1CON	@ 0xD8;
static volatile unsigned char S1STA	@ 0xD9;
static volatile unsigned char S1DAT	@ 0xDA;
static		unsigned char S1ADR1	@ 0xDB;
static		unsigned char S1ADR2	@ 0xDC;
static volatile unsigned char A		@ 0xE0;
// Alternate definition
static volatile unsigned char ACC	@ 0xE0;
static volatile unsigned char S2CON	@ 0xE8;
static volatile unsigned char S2STA	@ 0xE9;
static volatile unsigned char S2DAT	@ 0xEA;
static		unsigned char S2ADR1	@ 0xEB;
static		unsigned char S2ADR2	@ 0xEC;
static volatile unsigned char B		@ 0xF0;

static volatile SFR_BITS PCON_BITS		@ 0x87;
static volatile SFR_BITS TCON_BITS		@ 0x88;
static		SFR_BITS TMOD_BITS		@ 0x89;
static volatile SFR_BITS P1_BITS		@ 0x90;
static volatile SFR_BITS P2_BITS		@ 0xA0;
static		SFR_BITS IE_BITS		@ 0xA8;
static volatile SFR_BITS P3_BITS		@ 0xB0;
static		SFR_BITS IP_BITS		@ 0xB8;
static volatile SFR_BITS TMREG_BITS		@ 0xC0;
static volatile SFR_BITS PSW_BITS		@ 0xD0;
static volatile SFR_BITS S1CON_BITS		@ 0xD8;
static volatile SFR_BITS S1STA_BITS		@ 0xD9;
static volatile SFR_BITS A_BITS			@ 0xE0;
// Alternate definition
static volatile SFR_BITS ACC_BITS		@ 0xE0;
static volatile SFR_BITS S2CON_BITS		@ 0xE8;
static volatile SFR_BITS S2STA_BITS		@ 0xE9;
static volatile SFR_BITS B_BITS			@ 0xF0;

//Bit Addressable Locations
//Timer Control TCON
static 		bit	IT0	@ 0x88;
static volatile bit	IE0	@ 0x89;
static 		bit	IT1	@ 0x8A;
static volatile bit	IE1	@ 0x8B;
static 		bit	TR0	@ 0x8C;
static volatile bit	TF0	@ 0x8D;
static 		bit	TR1	@ 0x8E;
static volatile bit	TF1	@ 0x8F;

//Port 1 P1
static volatile bit	P10	@ 0x90;
static volatile bit	P11	@ 0x91;
static volatile bit	P12	@ 0x92;
static volatile bit	P13	@ 0x93;
static volatile bit	P14	@ 0x94;
static volatile bit	P15	@ 0x95;
static volatile bit	P16	@ 0x96;
static volatile bit	P17	@ 0x97;
// Alternate Functions
static volatile bit	DAC0	@ 0x90;
static volatile bit	DAC1	@ 0x91;
static volatile bit	DAC2	@ 0x92;
static volatile bit	DAC3	@ 0x93;
static volatile bit	DAC4	@ 0x94;
static volatile bit	DAC5	@ 0x95;
static volatile bit	DAC6	@ 0x96;
static volatile bit	DAC7	@ 0x97;

//Port 2 P2
static volatile bit	P20	@ 0xA0;
static volatile bit	P21	@ 0xA1;
static volatile bit	P22	@ 0xA2;
static volatile bit	P23	@ 0xA3;
static volatile bit	P24	@ 0xA4;
static volatile bit	P25	@ 0xA5;
static volatile bit	P26	@ 0xA6;
static volatile bit	P27	@ 0xA7;
// Alternate Functions
static volatile bit	DAC8	@ 0xA0;
static volatile bit	DAC9	@ 0xA1;
static volatile bit	DAC10	@ 0xA2;
static volatile bit	HCLAMP	@ 0xA3;
static volatile bit	ADC0	@ 0xA4;
static volatile bit	ADC1	@ 0xA5;
static volatile bit	ADC2	@ 0xA6;
static volatile bit	ADC3	@ 0xA7;

//Interrupt Enable IE
static		bit	EX0	@ 0xA8;
static		bit	ET0	@ 0xA9;
static		bit	EX1	@ 0xAA;
static		bit	ET1	@ 0xAB;
static 		bit	ES	@ 0xAC;
static 		bit	EA	@ 0xAF;

//Port 3 P3
static volatile bit	P30	@ 0xB0;
static volatile bit	P31	@ 0xB1;
static volatile bit	P32	@ 0xB2;
static volatile bit	P33	@ 0xB3;
static volatile bit	P34	@ 0xB4;
static volatile bit	P35	@ 0xB5;
static volatile bit	P36	@ 0xB6;
static volatile bit	P37	@ 0xB7;
// Alternate Functions
static volatile bit	HOUT	@ 0xB3;
static volatile bit	VOUT	@ 0xB4;

//Interrupt Priority
static 		bit	PX0	@ 0xB8;
static 		bit	PT0	@ 0xB9;
static 		bit	PX1	@ 0xBA;
static 		bit	PT1	@ 0xBB;
static 		bit	PS	@ 0xBC;

// TMREG register
static volatile bit	TM1	@ 0xC0;
static volatile bit	TM2	@ 0xC1;
static volatile bit	TM3	@ 0xC2;

//Program Status Word PSW
static volatile bit	P	@ 0xD0;
static volatile bit	F1	@ 0xD1;
static volatile bit	OV	@ 0xD2;
static 		bit	RS0	@ 0xD3;
static 		bit	RS1	@ 0xD4;
static volatile bit	F0	@ 0xD5;
static volatile bit	AC	@ 0xD6;
static volatile bit	CY	@ 0xD7;

//Serial Control 1 S1CON
static 		bit 	CR0 	@ 0xD8;
static 		bit 	CR1 	@ 0xD9;
static volatile bit 	AA	@ 0xDA;
static volatile bit 	SI	@ 0xDB;
static volatile bit 	STO 	@ 0xDC;
static volatile bit 	STA 	@ 0xDD;
static 		bit 	ENS1	@ 0xDE;
static 		bit 	CR2 	@ 0xDF;

//A Register
static volatile bit	A0	@ 0xE0;
static volatile bit	A1	@ 0xE1;
static volatile bit	A2	@ 0xE2;
static volatile bit	A3	@ 0xE3;
static volatile bit	A4	@ 0xE4;
static volatile bit	A5	@ 0xE5;
static volatile bit	A6	@ 0xE6;
static volatile bit	A7	@ 0xE7;
// Alternate definitions
static volatile bit	ACC0	@ 0xE0;
static volatile bit	ACC1	@ 0xE1;
static volatile bit	ACC2	@ 0xE2;
static volatile bit	ACC3	@ 0xE3;
static volatile bit	ACC4	@ 0xE4;
static volatile bit	ACC5	@ 0xE5;
static volatile bit	ACC6	@ 0xE6;
static volatile bit	ACC7	@ 0xE7;

//Serial Control 2 S2CON
static volatile bit	S2CON0	@ 0xE8;
static volatile bit	S2CON1	@ 0xE9;
static volatile bit	S2CON2	@ 0xEA;
static volatile bit	S2CON3	@ 0xEB;
static volatile bit	S2CON4	@ 0xEC;
static volatile bit	S2CON5	@ 0xED;
static volatile bit	S2CON6	@ 0xEE;
static volatile bit	S2CON7	@ 0xEF;

//B register
static volatile bit	B0	@ 0xF0;
static volatile bit	B1	@ 0xF1;
static volatile bit	B2	@ 0xF2;
static volatile bit	B3	@ 0xF3;
static volatile bit	B4	@ 0xF4;
static volatile bit	B5	@ 0xF5;
static volatile bit	B6	@ 0xF6;
static volatile bit	B7	@ 0xF7;


//Interrupt Vectors
#define	RESET	0
#define	EXTINT0	0x03
#define TIMER0	0x0B
#define	EXTINT1	0x13
#define	TIMER1	0x1B
#define	SERIAL	0x23

#endif
