
; HI-TECH Software PICC Assembler header file.
; Definitions based on C header file: pic1684.h.

; NOTE: PICC assembler option -P is required to preprocess assembler sources. 

; Special Function Register definitions
RTCC		equ	001h
TMR0		equ	001h
PCL		equ	002h
STATUS		equ	003h
FSR		equ	004h
PORTA		equ	005h
PORTB		equ	006h
EEDATA		equ	008h
EEADR		equ	009h
PCLATH		equ	00Ah
INTCON		equ	00Bh
OPTION		equ	081h
TRISA		equ	085h
TRISB		equ	086h
EECON1		equ	088h
EECON2		equ	089h

; Bit variables associates within SFRs
#define RP0	STATUS,5
#define TO	STATUS,4
#define PD	STATUS,3
#define ZERO	STATUS,2
#define DC	STATUS,1
#define CARRY	STATUS,0
#define RA4	PORTA,4
#define RA3	PORTA,3
#define RA2	PORTA,2
#define RA1	PORTA,1
#define RA0	PORTA,0
#define RB7	PORTB,7
#define RB6	PORTB,6
#define RB5	PORTB,5
#define RB4	PORTB,4
#define RB3	PORTB,3
#define RB2	PORTB,2
#define RB1	PORTB,1
#define RB0	PORTB,0
#define INT	PORTB,0
#define GIE	INTCON,7
#define EEIE	INTCON,6
#define T0IE	INTCON,5
#define INTE	INTCON,4
#define RBIE	INTCON,3
#define T0IF	INTCON,2
#define INTF	INTCON,1
#define RBIF	INTCON,0
#define RBPU	OPTION,7
#define INTEDG	OPTION,6
#define T0CS	OPTION,5
#define T0SE	OPTION,4
#define PSA	OPTION,3
#define PS2	OPTION,2
#define PS1	OPTION,1
#define PS0	OPTION,0
#define TRISA4	TRISA,4
#define TRISA3	TRISA,3
#define TRISA2	TRISA,2
#define TRISA1	TRISA,1
#define TRISA0	TRISA,0
#define TRISB7	TRISB,7
#define TRISB6	TRISB,6
#define TRISB5	TRISB,5
#define TRISB4	TRISB,4
#define TRISB3	TRISB,3
#define TRISB2	TRISB,2
#define TRISB1	TRISB,1
#define TRISB0	TRISB,0
#define EEIF	EECON1,4
#define WRERR	EECON1,3
#define WREN	EECON1,2
#define WR	EECON1,1
#define RD	EECON1,0
